IsRelease = True
version = "0.24"
IO_SPI = 1
class Globals(object):
    def __init__(self): raise NotImplementedError("Singleton means single instance")
    SpecialAllocDct = {
        (IO_SPI, "A3R8"): (0, 0),
        (IO_SPI, "A3K7"): (0, 0)}
    HostRPC = not IsRelease
    #StartBlank = False
WhiteListPartsMfg = {
    "Peregrine": [
        "PE43704", "PE43705", "PE43713", "PE46120", "PE46130", "PE46140",
        "PE42722", "PE42820", "PE42522", "PE42525"
    ],
    "Hittite": [
        "HMC1018ALP4E", "HMC1019ALP4E", "HMC649ALP6E", "HMC936ALP6E",
        "HMC546", "HMC646"
    ],
    "Analog Devices": [
        "ADF4169", "ADF4159", "ADF5355", "ADF4355-2", "ADRF6720-27",
        "HMC1018ALP4E", "HMC1019ALP4E", "ADF4360-9", "ADRF5020", "ADRF5021",
        "ADF5356", "ADF4355", "HMC649ALP6E", "HMC936ALP6E", "ADF4355-3",
        "ADF4360-7", "ADRF5130", "ADRF6780", "ADF4360-1",
        "ADRF5730", "ADRF5720", "HMC546", "HMC646",
        "ADG918", "ADG919", "ADG901", "ADG902", "ADF4360-0", "ADF4360-4",
        "ADF4360-5", "ADF4360-6", "ADF4360-8", "ADF4360-9"
    ],
    "Qorvo": [
        "QPC3213"
    ],
    "UMS": [
        "CHT4012-QDG"
    ],
    "Mini-Circuits": [
        "CSWA2-63DR+"
    ],
    "IDT": [
        "F1956"
    ],
    "Texas Instruments": [
        "LMX2594", "LMX-2594", "LMX2595", "LMX-2595", "LMX2572", "LMX-2572"
    ],
    "MACOM": [
        "MASW-004103-1365" # Actually not tested
    ]
}


def release_initPartCls(oldFunc):
    if not IsRelease: return oldFunc

    def newFunc(cls):
        if not cls.DevOnly: cls.DevOnly = (
                (cls.mfgName not in WhiteListPartsMfg) or
                (cls.mfgPartName not in WhiteListPartsMfg[cls.mfgName]))
        return oldFunc(cls)

    newFunc.__name__ = oldFunc.__name__
    return newFunc
class GlobOps(object):
    def __init__(self): raise NotImplementedError("Singleton means single instance")
    @staticmethod
    def globalVars(globalVarsVal, dctGlobals):
        del dctGlobals
        if IsRelease:
            globalVarsVal.onlyPowerOff = True
            globalVarsVal.initPartCls = release_initPartCls(globalVarsVal.initPartCls)
        return globalVarsVal
class ProgramItData(object):
    def __init__(self): raise NotImplementedError("Singleton means single instance")
    # XM_partName of the program to go to when finished build
    defProg = None
    # iterable of XM_partName
    defProg1 = None
    # keyed:mfgName, valued:iterable of mfgPartNames or STRING("ALL")
    defProg2 = None
    # iterable of mfgPartName
    defProg3 = None
    if not IsRelease:
        #defProg = "XM-A3T3-0409"
        #defProg = "XM-A3R8-0409"
        #defProg1 = ["XM-A3R8-0409", "XM-A3K7-0604", "XM-A6J8-0819", "XM-ADRF5020*4-0808"]
        #defProg1 = ["XM-A3R8-0409", "XM-A5Y8-0409", "XM-A5Y9-0409"]
        #defProg = "XM-A5Y9-0409"
        #defProg1 = ["XM-A297-0604", "XM-A298-0604", "XM-A299-0404", "XM-HMC394-0604", "XM-A5T2-0604"]
        #defProg1 = ["XM-A3V9-0604"]
        #defProg1 = ["XM-HMC394-0604"]
        #defProg1 = ["XM-A3X3-0409"]
        #defProg1 = [
        #    "XM-*A5P5-0609", "XM-*A5P6-0609", "XM-*A5P7-0609", "XM-*A5P8-0609",
        #    "XM-*A5P9-0609", "XM-*A5R1-0609", "XM-*A5R2-0609", "XM-*A5R3-0609",
        #    "XM-*A5R4-0609", "XM-*A5R6-0609"]
        #defProg1 = ["XM-LMX2594-0409"]
        #defProg1 = ["XM-HMC832-0409"]
        #defProg = "XM-HMC832-0409"
        # defProg1 = ["XM-*A5R3-0609", "XM-A5R3-0609"]
        # defProg = "XM-*A5R3-0609"
        # defProg1 = ["XM-*A3R8-0409"]
        # defProg1 = ["XM-A7L2-0609"]
        # defProg = "XM-A7L2-0609"
        defProg1 = ["XM-A3K6-0604"] * 8
        # defProg1 = None
        # defProg = None
        #defProg1 = ["XM-*A3X3-0409", "XM-A3X3-0409", "XM-*ADFX35X-Test", "XM-*A5R6-0609", "XM-A5R6-0609"]
        #defProg = "XM-*ADFX35X-Test"
        #defProg1 = ["XM-8v97051-0609"]
        #defProg = "XM-8v97051-0609"
        #defProg = "XM-A3V9-0604"
        #defProg1 = ["XM-A3T3-0409"]
        #defProg2 = {"Hittite": ["HMC1018", "HMC1018", "HMC1019"]}
        #defProg2 = {"Analog Devices": ["ADF4355", "ADF4355-2", "ADF4355-3", "ADF4155", "ADF4356", "ADF5355"]}
        #defProg2 = {"Analog Devices": ["ADF4351", "ADF4350", "ADF4151", "ADF4150", "ADF4150HV"]}
        #defProg2 = {"Analog Devices": ["ADF4193", "ADF4196"]}
        #defProg2 = {"Analog Devices": ["ADF4153", "ADF4153A"]}
        #defProg2 = {"Analog Devices": ["ADF4158", "ADF4169", "ADF4159", "ADF4157", "ADF4156"]}
        #defProg2 = {"Analog Devices": ["ADF4001", "ADF4002", "ADF4106", "ADF4107", "ADF4108", "ADF41020", "ADF4110", "ADF4111", "ADF4112", "ADF4113", "ADF4113HV", "ADF4116", "ADF4117", "ADF4118"]}
        #defProg2 = {"Analog Devices": ["ADF4218L", "ADF4208", "ADF4212", "ADF4212L"]}
        #defProg2 = {"Analog Devices": ["ADF4252"]}
class ProgramItOps(object):
    def __init__(self): raise NotImplementedError("Singleton means single instance")
    @staticmethod
    def helpsMarkUp(helpsMarkUp):
        helpsMarkUp["Home"] = u"Version number [color=#ccff26]v%s[/color]\n"%version + helpsMarkUp["Home"]