from . import LibProgramIt
from . import globalVars
from .LibBaseProgPart import BaseProgPart
from .DataPackers import DataPacker, DataVarBytes, DataArray, DataInt, DataObj,\
    GetStrBytesLong, GetLongStrBytes, DataCondFmt, DataNone
import time
from .LibProgramIt import ProgramItApp
from .LibBaseFileLoading import LoadError, ERR_PROG_VER_NEW#, ERR_FL_FMT_VER_NEW, ERR_OTHER
# from .LibKivyProgramItApp import AppData
class BaseVer(object):
    ver = None
    @classmethod
    def SaveFile(cls, app, fl): pass
    @classmethod
    def LoadFile(cls, app, fl): pass
oldToNewMapping = {
    "XM-HMC1018-0604": "XM-A5D6-0604",
    "XM-HMC1018A-0604": "XM-A5D6-0604",
    "XM-HMC1019-0604": "XM-A5D7-0604",
    "XM-HMC1019A-0604": "XM-A5D7-0604",
    "XM-ADRF5020-0409": "XM-A3R1-0409",
    "XM-HMC986A-0409": "XM-A4F4-0404",
    "XM-HMC705-0604": "XM-A297-0604",
    "XM-HMC862A-0604": "XM-A299-0404",
    "XM-HMC794-0604": "XM-A298-0604",
    "XM-MASW_011036-0604": "XM-A3M8-0404",
    "XM-ADRF6720_27-0819": "XM-A6J8-0819",
    "XM-ADF4360(0)-0000": "XM-A5P5-0609",
    "XM-ADF4360(1)-0000": "XM-A5P6-0609",
    "XM-ADF4360(2)-0000": "XM-A5P7-0609",
    "XM-ADF4360(3)-0000": "XM-A5P8-0609",
    "XM-ADF4360(4)-0000": "XM-A5P9-0609",
    "XM-ADF4360(5)-0000": "XM-A5R1-0609",
    "XM-ADF4360(6)-0000": "XM-A5R2-0609",
    "XM-ADF4360(7)-0000": "XM-A5R3-0609",
    "XM-ADF4360(8)-0000": "XM-A5R4-0609",
    "XM-ADF4360(9)-0000": "XM-A5R6-0609",
    "XM-4159-0409": "XM-A5N5-0609",
    "XM-ADF4355-0409": "XM-A5M4-0409",
    "XM-ADF4355(3)-0409": "XM-A5M6-0409",
    "XM-ADF4356-0409": "XM-A5Y8-0409",
    "XM-ADG918-0409": "XM-A5G1-0409",
    "XM-ADG919-0409": "XM-A5G2-0409",
    "XM-ADG901-0409": "XM-A5G6-0404",
    "XM-ADG902-0409": "XM-A5G7-0404",
    "XM-ADRF5021-0409": "XM-A5M1-0409",
    "XM-HMC905-0604": "XM-A5T2-0604",
    "XM-HMC347A-0409": "XM-A668-0409",
    "XM-HMC574A-0409": "XM-A6B3-0409",
    "XM-HMC270A-0409": "XM-A659-0409",
    "XM-HMC8038-0409": "XM-A6D5-0409",
    "XM-HMC1118-0409": "XM-A645-0409",
    "XM-ADRF5040-0409": "XM-A636-0409",
    "XM-HMC244A-0409": "XM-A656-0409",
    "XM-HMC7992-0409": "XM-A6D4-0409",
    "XM-HMC1084-0409": "XM-A5U8-0409",
    "XM-HMC641A-0409": "XM-A6C1-0409",
    "XM-HMC241A-0409": "XM-A654-0409",
    "XM-ADRF5130-0409": "XM-A637-0409",
    "XM-HMC305S-0604": "XM-A661-0604",
    "XM-HMC939LP4-0604": "XM-A6E3-0604",
    "XM-HMC939ALP4-0604": "XM-A6E3-0604",
    "XM-HMC941ALP4E-0604": "XM-A6E4-0604",
    "XM-HMC941A-0604": "XM-A6E4-0604",
    "XM-HMC540S-0604": "XM-A6A7-0604",
    "XM-HMC424A-0604": "XM-A687-0604",
    "XM-ADF4153-0000": "XM-A5Y4-0409",
    "XM-ADF4156-0000": "XM-A5Y5-0409",
    "XM-ADF4350-0000": "XM-A5Y6-0409",
    "XM-ADF4351-0409": "XM-A5Y7-0409",
    "XM-A3L3-0604": "XM-A3L3-0404",
    "XM-A3L4-0604": "XM-A3L4-0404",
    "XM-A3L5-0604": "XM-A3L5-0404",
    "XM-A3T3-0409": "XM-A741-0409", # XM-A3T3-0409 has been removed,
    "XM-LMX2594-0409": "XM-A724-0609",
    "XM-A724-0409": "XM-A724-0609"
}
class Version0000(BaseVer):
    ver = 0
    XM_namePacker = DataPacker(
        DataArray(DataVarBytes(1, 1), 2))
    SpiChainPacker = DataPacker(
        DataArray(
            DataObj(
                DataInt(1),
                DataInt(2),
                DataArray(DataInt(2), 1))))
    @classmethod
    def SaveFile(cls, app, fl):
        """
        :param ProgramItApp app:
        :param file fl:
        """
        XM_names = map(lambda x: x.XM_partName, app.lstProgs)
        cls.XM_namePacker.Pack([XM_names], fl)
        cls.SaveSpiChains(app, fl)
        fl.flush()
        for prog in app.lstProgs:
            assert isinstance(prog, BaseProgPart)
            prog.serialize(fl, cls.ver)
    @classmethod
    def SaveSpiChains(cls, app, fl):
        """
        :param ProgramItApp app:
        :param file fl:
        """
        LstChains = [
            [bus, cs, list(map(app.lstProgs.index, app.app_data.SpiChains[(bus, cs)]))]
            for bus, cs in app.app_data.SpiChains]
        cls.SpiChainPacker.Pack([LstChains], fl)
    @classmethod
    def LoadFile(cls, app, fl):
        """
        :param ProgramItApp app:
        :param file fl:
        """
        XM_names = cls.XM_namePacker.Unpack(fl)[0]
        LstChains = cls.SpiChainPacker.Unpack(fl)[0]
        progClasses = [None] * len(XM_names)
        lstBadKeys = []
        for c in xrange(len(XM_names)):
            XM_name = XM_names[c]
            if XM_name in oldToNewMapping: XM_name = oldToNewMapping[XM_name]
            try:
                progClasses[c] = globalVars.dctParts[XM_name]
            except LookupError:
                lstBadKeys.append(XM_name)
        globalVars.log.Log("LoadFile: stage 5")
        if len(lstBadKeys):
            return "ERROR: Unrecognized part numbers in file: %s" % ", ".join(lstBadKeys)
        globalVars.log.Log("LoadFile: stage 6")
        app.wnd.clear_widgets()
        app.startProgBar(
            cls.buildProgFromFile(app, progClasses, fl),
            "Building Control Screens",
            lambda dt=None: cls.doneLoad(app, LstChains, fl))
    @classmethod
    def LoadSpiChains(cls, app, fl, LstChains):
        """
        :param ProgramItApp app:
        :param file fl:
        :param LstChains:
        """
        for bus, cs, chain in LstChains:
            app.app_data.SpiChains[(bus, cs)] = map(app.lstProgs.__getitem__, chain)
    @classmethod
    def buildProgFromFile(cls, app, progClasses, fl):
        app.lstProgs[:] = [None] * len(progClasses)
        data = app.data["progData1"]
        tTotal = sum(map(lambda x: data.get(x.XM_partName, 0), progClasses))
        yield tTotal
        totalTime = 0
        newTotalTime = 0
        for c in xrange(len(progClasses)):
            cur = progClasses[c]
            tPrev = time.time()
            try:
                app.lstProgs[c] = cur(fl, cls.ver)
            except:
                globalVars.log.Log("Error with class: %s while Loading File"%cur.__name__, 1)
                raise
            app.lstProgs[c].app = app.app_data
            tCur = time.time()
            old = data.get(cur.XM_partName, 0)
            tNew = tCur - tPrev
            data[cur.XM_partName] = tNew
            totalTime += old
            newTotalTime += tNew
            yield totalTime, newTotalTime
    @classmethod
    def finishLoad(cls, app, fl):
        pass
    @classmethod
    def doneLoad(cls, app, LstChains, fl):
        cls.finishLoad(app, fl)
        cls.LoadSpiChains(app, fl, LstChains)
        app.doneLoad(fl)
class Version0001(Version0000):
    ver = 1
    @classmethod
    def SaveFile(cls, app, fl):
        """
        :param ProgramItApp app:
        :param file fl:
        """
        super(Version0001, cls).SaveFile(app, fl)
        prevSel = app.prevSel
        if prevSel is None: prevSel = 0xFFFF
        fl.write(GetStrBytesLong(prevSel))
        fl.flush()
    @classmethod
    def finishLoad(cls, app, fl):
        super(Version0001, cls).finishLoad(app, fl)
        prevSel = GetLongStrBytes(fl.read(2))
        if prevSel == 0xFFFF: prevSel = None
        elif prevSel > len(app.lstProgs): prevSel = None
        app.prevSel = prevSel
class Version0002(Version0001):
    ver = 2
    versionPacker = DataPacker(DataInt(2), DataInt(2))
    @classmethod
    def SaveFile(cls, app, fl):
        """
        :param ProgramItApp app:
        :param file fl:
        """
        lst = map(int, globalVars.metainf["version"].split(".")) # major.minor
        assert len(lst) == 2
        cls.versionPacker.Pack(lst, fl)
        fl.flush()
        super(Version0002, cls).SaveFile(app, fl)
    @classmethod
    def LoadFile(cls, app, fl):
        """
        :param ProgramItApp app:
        :param file fl:
        """
        lst = tuple(cls.versionPacker.Unpack(fl))
        lstCmp = tuple(map(int, globalVars.metainf["version"].split("."))) # major.minor
        fName = None if not hasattr(fl, "name") else fl.name
        if lstCmp != (0, 0) and lst > lstCmp:
            raise LoadError(ERR_PROG_VER_NEW, fName, "Try Updating to version %u.%u" % lst)
        return super(Version0002, cls).LoadFile(app, fl)
class Version0003(Version0002):
    ver = 3
class Version0004(Version0003):
    ver = 4
    SpiChainPacker = DataPacker(
        DataArray(
            DataObj(
                DataInt(1), # Spi Bus
                DataInt(2), # Spi LE
                DataInt(1), # has multi (0 means no, 1 means yes)
                DataCondFmt(
                    lambda x: x,
                    DataNone(),
                    DataObj(
                        DataInt(1), # type of multi
                        DataArray(
                            DataInt(1), # chip select pin
                            1
                        ),
                        DataArray(
                            DataInt(1), # mux pin
                            1
                        )
                    )
                ),
                DataArray(DataInt(2), 1))))
    @classmethod
    def SaveSpiChains(cls, app, fl):
        """
        :param ProgramItApp app:
        :param file fl:
        """
        LstChains = [
            [k[0], k[1]] +
            ([0, None] if len(k) == 2 else [1, k[2]]) +
            [list(map(app.lstProgs.index, app.app_data.SpiChains[k]))]
            for k in app.app_data.SpiChains]
        cls.SpiChainPacker.Pack([LstChains], fl)
    @classmethod
    def LoadSpiChains(cls, app, fl, LstChains):
        """
        :param ProgramItApp app:
        :param file fl:
        :param LstChains:
        """
        for bus, cs, is_multi, multi, chain in LstChains:
            k = (bus, cs)
            if is_multi:
                lstCS = tuple(multi[1])
                muxPins = tuple(multi[2])
                k = (bus, cs, (multi[0], lstCS, muxPins))
            app.app_data.SpiChains[k] = map(app.lstProgs.__getitem__, chain)
# NOTE: after version 0002 it is strongly advised that following versions always place
#   [2bytes, 2bytes] version indicator after 2bytes file format version
#   in order to indicate to the user what version the save file is from when an error occurs
LibProgramIt.LstVer = [
    Version0000,
    Version0001,
    Version0002,
    Version0003,
    Version0004
]
def Check():
    for c, verCls in enumerate(LibProgramIt.LstVer):
        assert c == verCls.ver, "Version number in Version Class must match the index of Version Class in LstVer"
Check()