from .Logging import LoggingContext, Logger


class GlobalStorage(object):
    __slots__ = [
        "powerOff", "onlyPowerOff", "rPi", "canPowerOff", "execExit",
        "scroll_distance", "scroll_timeout", "dctParts", "partCats",
        "partManufs", "mfgPartNames", "app", "loadData", "useLoadData",
        "logCtx", "log", "flLog", "version", "metainf", "initPartCls",
        "showDevParts", "spi_obj", "pin_obj"
    ]
    def __init__(self, powerOff, onlyPowerOff, rPi, canPowerOff, execExit, scroll_distance, scroll_timeout, logCtx, log, flLog):
        assert isinstance(logCtx, LoggingContext)
        assert isinstance(log, Logger)
        self.powerOff = powerOff
        self.onlyPowerOff = onlyPowerOff
        self.rPi = rPi
        self.canPowerOff = canPowerOff
        self.execExit = execExit
        self.scroll_distance = scroll_distance
        self.scroll_timeout = scroll_timeout
        self.dctParts = {}
        self.partCats = []
        self.partManufs = {}
        self.mfgPartNames = {}
        self.app = None
        self.loadData = LoadDataStorage()
        self.useLoadData = False
        self.logCtx = logCtx
        self.log = log
        self.flLog = flLog
        self.version = None
        self.metainf = None
        self.initPartCls = None
        self.showDevParts = False
        self.spi_obj = []
        self.pin_obj = []


class LoadDataStorage(object):
    def __init__(self):
        self.curModule = "ProgramIt"
        self.allModules = {
            "ProgramIt": {
                "log": None,
                "parts": {}
            }
        }