from .DataEntryHelpers import *


# lstTab -> list[3-tuple(Name, tabVarName(string), namedGrid)]
# named grid format 3/4/5-tuple (clsType, gridName, kwargs, optional lstGrids=[], optional index=-1)
#
def procLstGrid(dctNamed, lstGrid, parent):
    """
    :param dict[str|unicode,Widget] dctNamed:
    :param list[((dict[str|unicode,any]) -> Widget, str|unicode|None, dict[str|unicode,any])|((dict[str|unicode,any]) -> Widget, str|unicode|None, dict[str|unicode,any], any)|((dict[str|unicode,any]) -> Widget, str|unicode|None, dict[str|unicode,any],any,int|long)] lstGrid:
    :param parent:
    :return:
    """
    for cur in lstGrid:
        lstGrid1 = []
        index = 0
        cls = cur[0]
        """ :type: (dict[str|unicode,any]) -> Widget"""
        gridName = cur[1]
        """ :type: str|unicode|None"""
        kwargs = cur[2]
        """ :type: dict[str|unicode,any]"""
        if len(cur) >= 4: lstGrid1 = cur[3]
        if len(cur) >= 5: index = cur[4]
        grid = cls(**kwargs)
        if parent is not None: parent.add_widget(grid, index=index)
        if gridName is not None: dctNamed[gridName] = grid
        if len(lstGrid1): procLstGrid(dctNamed, lstGrid1, grid)
"""
lstTab = [
    (name, attrName, namedGrid)
]
namedGrid = None | (cls, gridName | None, kwargsGrid, opt lstGrid)
lstGrid = [
    (cls, gridName, kwargs, lstGrid, index)
]
"""


def doAllowScroll(self, parent):
    if parent is not None:
        parent.bind(on_scroll_start=ScrollAllower)




def getTabPanel(lstTab, **kwargsPanel):
    """
    :param list[(str|unicode, str|unicode|None, any)] lstTab:
    :param kwargsPanel:
    :return:
    """
    assert isinstance(lstTab, list)
    defaults = {
        "pos_hint": {"top": 1.0586, 'x': 0.01}, "size_hint": (.98, .85),
        "default_tab_cls": SnappedTabbedPanelHeader}
    fillDictDefs(kwargsPanel, defaults)
    tabPanel = TabbedPanel(**kwargsPanel)
    tabPanel.default_tab.parent.bind(parent=doAllowScroll)
    clsTab = kwargsPanel["default_tab_cls"]
    dctNamed = {}
    name, attrName, namedGrid = lstTab[0]
    cur = tabPanel.default_tab
    tabPanel.default_tab_text = name
    if attrName is not None: dctNamed[attrName] = cur
    lstGrid = []
    cls, gridName, kwargsGrid = namedGrid[:3]
    grid = cur.content = cls(**kwargsGrid)
    if len(namedGrid) >= 4: lstGrid = namedGrid[3]
    if gridName is not None: dctNamed[gridName] = grid
    if len(lstGrid): procLstGrid(dctNamed, lstGrid, grid)
    it = iter(enumerate(lstTab))
    next(it)
    for c, (name, attrName, namedGrid) in it:
        cur = clsTab(text=name)
        tabPanel.add_widget(cur)
        if attrName is not None: dctNamed[attrName] = cur
        lstGrid = []
        cls, gridName, kwargsGrid = namedGrid[:3]
        grid = cur.content = cls(**kwargsGrid)
        if len(namedGrid) >= 4: lstGrid = namedGrid[3]
        if gridName is not None: dctNamed[gridName] = grid
        if len(lstGrid): procLstGrid(dctNamed, lstGrid, grid)
    return tabPanel, dctNamed



class GridSelFrame(object):
    def __init__(self, *widNamePairs):
        self.lstBtnArgs = widNamePairs
        self.lstPanels = []
        self.btns = {}
        self.on = (k5_GREY, kXM_GREEN1)
        self.off = (kWHITE, kBLACK)
    @staticmethod
    def getLayout():
        #return GridLayout(cols=1,size_hint=(.1,1.),spacing=[10,10],padding=[6])
        return GridLayout(cols=1, size_hint=(None, 1.), width=35, spacing=[0, 2])
    def mkPanel(self, index=0, sel=None):
        layout = self.getLayout()
        btns = [
            Button(
                text=txt, on_release=Bind(self.select, c, index),
                background_normal="",
                background_color=(self.on if (sel is not None and sel is wid) else self.off)[0],
                color=(self.on if (sel is not None and sel is wid) else self.off)[1])
            for c, (wid, txt) in enumerate(self.lstBtnArgs)]
        map(layout.add_widget, btns)
        self.lstPanels.append((layout, btns))
        self.btns[index] = btns
        return layout
    def colorize(self, obj):
        ppObj = obj.parent.parent
        for index in self.btns:
            for c in xrange(len(self.lstBtnArgs)):
                val = ppObj.children[index] is self.lstBtnArgs[c][0]
                btn = self.btns[index][c]
                btn.background_color, btn.color = (self.on if val else self.off)
    def select(self, c, index0, obj):
        par0 = obj.parent.parent
        wid0 = self.lstBtnArgs[c][0]
        par1 = wid0.parent
        if par0 is None:
            raise ValueError("Cannot be selected while not on a widget")
        try:
            wid1 = par0.children[index0]
        except (IndexError, KeyError):
            if par1 is not None:
                par1.remove_widget(wid0)
            par0.add_widget(wid0, index=index0)
            self.colorize(obj)
            return
        if wid0 is wid1: return
        par0.remove_widget(wid1)
        if par1 is not None:
            index1 = par1.children.index(wid0)
            par1.add_widget(wid1, index=index1)
            par1.remove_widget(wid0)
        par0.add_widget(wid0, index=index0)
        self.colorize(obj)
# def MkViewBtnBox(inst, *widNamePairs): inst.gridSelFrame = GridLayout(cols=1, size_hint=(.1, 1.), spacing=[10, 10], padding=[6])
def mkLblBorderGridFmt(clsLabel, clsInner, kwargsOuter, kwargsLabel, kwargsInner, names):
    return (
        Bordered,
        names[0],
        kwargsOuter,
        [(clsLabel, None, kwargsLabel), (clsInner, names[1], kwargsInner)]
    )
class GridSelFrameLayout(BorderedGridLayout):
    def __init__(self, **kwargs):
        side_names = kwargs["side_names"]
        kwargs["cols"] = 4
        self._n_show = 2
        super(GridSelFrameLayout, self).__init__(**kwargs)
        self._gridSelFrame = GridSelFrame(*map(lambda x: [None, x], side_names))
        self._l_panel = self._gridSelFrame.mkPanel(index=2)
        self._r_panel = self._gridSelFrame.mkPanel(index=1)
        self._cur_index = len(side_names)
        supObj = super(GridSelFrameLayout, self)
        supObj.add_widget(self._l_panel)
        supObj.add_widget(self._r_panel)
    def trackWidget(self, widget, index=0):
        if index < 0:
            self._cur_index -= 1
            index = self._cur_index
        if index >= len(self._gridSelFrame.lstBtnArgs) or index < 0:
            raise IndexError("Widget index out of bounds")
        self._gridSelFrame.lstBtnArgs[index][0] = widget
        iLayout = self._n_show - index
        if index < 2: self._gridSelFrame.select(index, iLayout, self._gridSelFrame.btns[iLayout][index])

    # noinspection PyMethodOverriding
    def add_widget(self, widget, index=0):
        if index < 0:
            index = len(self._gridSelFrame.lstBtnArgs) + index
            self.trackWidget(widget, index)
        else:
            super(GridSelFrameLayout, self).add_widget(widget, index)
    def remove_widget(self, widget):
        if widget is self._l_panel or widget is self._r_panel: return
        super(GridSelFrameLayout, self).remove_widget(widget)