from .DataEntryHelpers import *


class SimpleTextPopup(object):
    def __init__(self, title, validator, action, **kwargs):
        self.title = title
        self.validator = validator
        self.action = action
        self.popup = Popup(**kwargs)
        self.popup.title = title
        self.txtIn = TextInput(
            on_text_validate=self.onDone, multiline=False,
            pos_hint={"center_x": .5, "top": .6}, size_hint=(1., .2))
        self.doneBtn = Button(
            text="Done", on_release=self.onDone,
            pos_hint={"center_x": .5, "top": .2}, size_hint=(1., .2))
        if "content" not in kwargs:
            self.popup.content = FloatLayout()
        self.popup.content.add_widget(self.txtIn)
        self.popup.content.add_widget(self.doneBtn)

    def show(self, startText=""):
        self.txtIn.text = startText
        self.popup.open()

    def onDone(self, obj=None, val=None):
        del obj, val
        ok, reason = self.validator(self.txtIn.text)
        if not ok:
            self.txtIn.add_widget(ErrBubble(
                text=reason, background_color=(1.75, 1, 1, 1.25)))
        else:
            self.popup.dismiss()
            self.action(self.txtIn.text)