import socket
# import time
# import threading
# import sys
# sys, time and threading are imported with the line
# from .TinyLib import *
import cPickle

baseDir = __file__.replace("\\", "/")
if baseDir.count("/") > 0:
    baseDir = baseDir[:baseDir.rfind("/") + 1]
else:
    baseDir = ""

from kivy.uix.button import Button
#from kivy.lang import Builder
from kivy.uix.behaviors import ButtonBehavior
from kivy.uix.widget import Widget

Button.always_release.defaultvalue = False
ButtonBehavior.always_release.defaultvalue = False
from . import Configurator as AppCfg
from . import globalVars
import json
from .TinyLib import traceback, os, Bind, ValuePack, ReprMaxLenCh, VarContext
from .DataPackers import AlignStrBytesLong, GetLongStrBytes
import threading
import time
def reprStr(Str):
    return ("u" if isinstance(Str, unicode) else "") + json.dumps(Str)
log = globalVars.log
FlLog = globalVars.flLog
globalVars.version = AppCfg.version
globalVars.metainf = {
    "version": AppCfg.version,
    "os_pkg_ver": 1}
def loadMetaInf():
    log.Log("Locating metainf.json", 3)
    if os.path.isfile(baseDir + "../metainf.json"):
        log.Log("Located metainf.json", 3)
        with open(baseDir + "../metainf.json") as fl:
            try:
                globalVars.metainf = json.load(fl)
            except ValueError as Exc:
                log.Log("Could not load metainf.json: %s" % str(Exc), 2)
            else:
                log.Log("Loaded metainf.json successfully", 3)
    else:
        log.Log("Could not locate metainf.json", 2)
loadMetaInf()

import Queue
log.Log("Importing LibIO", 3)
from .LibIO import MOCK_gpio, MOCK_spidev, enumerateSpiBus, enumerateSpiBusCs,\
    spiIO_Object, PinIO_Object, getMulti#, MOCK_spiobj
from . import LibIO
log.Log("Importing CustomWidgets", 3)
from .CustomWidgets import GridLayout, Bordered, BorderedGridLayout, Label, FloatLayout, Image,\
    SpcHintGridLayout, sizedLabel, ClkImage, XMFlagStyleButton, BorderedList, XMButton, XMHomeItem, ClkCompLstItem
log.Log("Importing args_converters", 3)
from .args_converters import szYpx, kGREEN, kD0_GREY, kRED,\
    ScrollAllower, Clock, images, convProgLstItem2, catLstConv1, partLstCatConv1, partLstCatConv
log.Log("Importing DataEntryHelpers", 3)
from .DataEntryHelpers import ScrollView, Popup, SelectPopupMaker, ListAdapter
log.Log("Importing LibAppData", 3)
from .LibAppData import AppData
log.Log("Importing LibBaseProgPart", 3)
from .LibBaseProgPart import spiWriteNum, ChainSpiBus, catAll#, MAX_TEXTURE_SIZE

#from .LibBaseProgPart import *
log.Log("Importing LibBaseScreen")
from .LibBaseScreen import BaseScreen
log.Log("Importing LibIndAppData")
from .LibIndAppData import ProgStyleStorage, CmdList#, preLoadCheck, preSaveCheck
log.Log("Importing LibMessageBox")
from .LibMessageBox import MessageBox, MB_YESNO, MB_OK
log.Log("Importing LibTask")
from .LibTask import ImmediateAsynch
log.Log("Importing ScreenIOConfig")
from .ScreenIOConfig import IOConfigHelpers
#from .Logging import GetTmFmt


#from kivy.lang import Builder
#from kivy.uix.layout import Layout
from kivy.app import App
from kivy.uix.progressbar import ProgressBar


from .FileManagement import SaveLoadScreen, FileManagementScreen, UsbHandler,\
    UpdateFileManager, OS_UpdateFileManager, UsbScreenStorage,\
    getIPv4And6Addr#, FileChooser

from .PartControlScreen import PartCtlScreen
from .LibBaseFileLoading import LoadError, ERR_FL_FMT_VER_NEW
from watchdog import observers
try:
    import spidev
except ImportError:
    log.Log("Failed to import spidev. Mocking", 3)
    spidev = MOCK_spidev
try:
    import RPi.GPIO as gpio
except ImportError:
    gpio = MOCK_gpio
LibIO.InitLibIO(spidev, gpio)
log.Log("Imported all modules", 3)
"""spi = spidev.SpiDev()
spi.open(0, 1)
spi.max_speed_hz=3600000
spi1 = spidev.SpiDev()
spi1.open(0, 0)
spi1.max_speed_hz=3600000"""
globalVars.spi_obj[:] = [spiIO_Object(0, 1), spiIO_Object(0, 0)]
globalVars.pin_obj[:] = [PinIO_Object(2)]

StartBlank = True
PE437XX_AllShareBus = False
globalVars.showDevParts = False
spidev = None
HostRPC = True
RPC_PORT = 2500
HostCMD = True
CMD_PORT = 2501


def partLstConv(theApp, row_index, k):
    del row_index
    part = globalVars.dctParts[k]
    return {"text": k + " Uses " + part.mfgName + " P/N: " + part.mfgPartName,
            "size_hint_y": None, "height": szYpx, "is_representing_cls": True,
            "on_release": Bind(theApp.mkProg, part)}


def ExportMfgPartNames(fName):
    with open(fName, "w") as Fl:
        Fl.write("\n".join(sorted(globalVars.mfgPartNames)))


def ExportPartNames(fName):
    with open(fName, 'w') as Fl:
        Fl.write("\n".join(sorted(globalVars.dctParts)))


def ExportCSV_Parts(fName):
    dctParts = globalVars.dctParts
    partK = sorted(dctParts)
    output = [None] * (len(partK) + 1)
    output[0] = ("XM P/N", "MFG", "MFG P/N", "Is In Release")
    empty = []
    for c, k in enumerate(partK, 1):
        part = dctParts[k]
        mfgName, mfgPartName = part.mfgName, part.mfgPartName
        isInRelease = mfgPartName in AppCfg.WhiteListPartsMfg.get(mfgName, empty)
        output[c] = (k, mfgName, mfgPartName, isInRelease)
    with open(fName, 'w') as Fl:
        Fl.write("\n".join([",".join(map(json.dumps, x)) for x in output]))

Debug = False


# calculates column widths for the home screen and the home->new screen
def procColsW(lstColW, totalW):
    numColsDef = 0
    for colW in lstColW:
        if colW is None:
            numColsDef += 1
        else:
            totalW -= colW
    if numColsDef == 0: return
    totalW /= numColsDef
    for c in xrange(len(lstColW)):
        if lstColW[c] is None: lstColW[c] = totalW


def RPC_Action(Str, Globals, Locals, RtnQueue, dt=None):
    del dt
    Rtn = (0, None)
    try:
        try:
            Rtn = (1, eval(Str, Globals, Locals))
        except SyntaxError:
            exec (Str, Globals, Locals)
    except StandardError:
        Rtn = (2, traceback.format_exc()[:-1])
    except (StopIteration, GeneratorExit, KeyboardInterrupt):
        Rtn = (2, traceback.format_exc()[:-1])
    RtnQueue.put(Rtn)


def recv_all(sock, n_bytes):
    s = sock.recv(n_bytes)
    while len(s) < n_bytes:
        u = sock.recv(n_bytes - len(s))
        if len(u) == 0:
            return s, False
        s += u
    return s, True


def recv_delim(sock, delim, buf, blk_size=16):
    assert len(delim) <= blk_size
    s = bytes(buf) if len(buf) else sock.recv(blk_size)
    buf[:] = b""
    pos = s.find(delim)
    search_off = len(delim) - 1
    while pos == -1:
        x = len(s)
        s += sock.recv(blk_size)
        if len(s) == x:
            return s, False
        pos = s.find(delim, max(x - search_off, 0))
    buf[:] = s[pos + len(delim):]
    s = s[:pos]
    return s, True


partmods = None


# filled by FileVersionCompat.py
LstVer = []


def SaveFile(app, fVer, fl):
    return LstVer[fVer].SaveFile(app, fl)


def LoadFile(app, fVer, fl):
    return LstVer[fVer].LoadFile(app, fl)


SCRN_NONE = 0
SCRN_SAVE = 1
SCRN_LOAD = 2
SCRN_FILE_MGMT = 3
SCRN_IO_CFG = 4
SCRN_PART_CTL = 5
SCRN_MAX_PLUS_1 = 6

ACTION_LVL = 3


# naming scheme
#  functions named with go<NAME>(*args, obj=None) excluding goBack and goForward
#    are used by the designated action buttons
#  functions goBack and goForward
#    bypass the go<NAME> function to reach the target directly without
#    pushing commands to the command list
# function topMenu is usually called at every scene
class ProgramItApp(App):
    helps = {
        "Confirm Quit": "\n  ".join([
            "Meanings of the buttons:", "Yes: quit and power off", "No: don't quit and return to home screen",
            "Quit without powering off: quit the application but don't power off"]),
        "Select Category": "Select a category to get a list of parts to select from",
        "Home": "\n  ".join([
            "The home screen consists of the following",
            " - [I/O Config] Button: configure the I/O for part communication",
            " - [New] Button: add a new control screen (select a category to select a part to control)",
            " - [Remove All] Button: remove all control screens (program will ask for confirmation)",
            " - [Quit/Power Off] Button: confirm quit (and power off) or quit without powering off",
            " - List of control screens: lists of rows",
            "     each row has a [Remove] button on the right that, when clicked,",
            "       will ask if you want to remove that control screen",
            "     each row to the left of the [Remove] button can be clicked to go to that control screen",
            " - Top Navigation buttons are on every screen",
            "     [Left Arrow] go to previous screen that was visited",
            "     [Right Arrow] go to next screen that was visited",
            "     [Home Icon] go to Home",
            "     [? Icon] get help about the current screen"])}
    helpsMarkUp = {
        "Home": u"\n  ".join([
            u"The home screen consists of the following",
            u" \u2022 Top Navigation buttons are on every screen",
            u"    - [color=#CCFF26]Left Arrow[/color]: go to previous screen that was visited",
            u"    - [color=#CCFF26]Right Arrow[/color]: go to next screen that was visited",
            u"    - [color=#CCFF26]Home Icon[/color]: go to Home",
            u"    - [color=#CCFF26]? Icon[/color]: get help about the current screen",
            u" \u2022 List of control screens: lists of rows",
            u"     each row has a [color=#CCFF26]Remove[/color] button on the right that, when clicked,",
            u"       will ask if you want to remove that control screen",
            u"     each row to the left of the [color=#CCFF26]Remove[/color] button can be clicked to go to that control screen",
            u"     the last control screen that was viewed or added will be highlighted",
            u"       with a darker color and green text",
            u" \u2022 [color=#CCFF26]Quit/Power Off[/color] Button: quit and power off (program will ask for confirmation)",
            u" \u2022 [color=#CCFF26]Save[/color] Button: select a file to save to",
            u" \u2022 [color=#CCFF26]Load[/color] Button: select a file to load from",
            u" \u2022 [color=#CCFF26]Add Part[/color] Button: add a new control screen (select a category to select a part to control)",
            u" \u2022 [color=#CCFF26]Remove All[/color] Button: remove all control screens (program will ask for confirmation)",
            u" \u2022 [color=#CCFF26]I/O Config[/color] Button: configure the I/O for part communication"])
    }
    defDat_Data = {"partmods", "progData", "progData1"}
    SelectSpiBus = None
    SelectSpiLE = None
    curLoader = None
    progBar = None
    timeEstimateGrid = None
    timeLeftLbl = None
    progNext = None
    wnd = None
    thereCanOnlyBeOne = None
    smallLogo = None
    logo = None
    titleLbl = None
    goDelAll = None
    helpBtn = None
    homeBtn = None
    forwardBtn = None
    backBtn = None
    navGrid = None
    lstColW = None
    lstColHd = None
    headGrid = None
    footGrid = None
    lstColNewW = None
    lstColNewHd = None
    newHdGrid = None

    def __init__(self, **kwargs):
        assert "logObj" in kwargs
        try:
            with open(baseDir + "ProgramIt.dat", "rb") as Fl:
                self.data = cPickle.load(Fl)
        except (IOError, EOFError):
            self.data = {}
        for k in self.defDat_Data:
            if k not in self.data: self.data[k] = {}
        # config the app
        for k in dir(AppCfg.Globals):
            if k.startswith("_"): continue
            globals()[k] = getattr(AppCfg.Globals, k)
        import LibBaseProgPart
        for k in dir(AppCfg.GlobOps):
            if k.startswith("_"): continue
            d = globals()
            if k not in d:
                d = vars(LibBaseProgPart)
            d[k] = getattr(AppCfg.GlobOps, k)(d[k], d)
        # load part modules
        global partmods
        partmods = __import__(name="partmods", globals=globals(), locals=globals())
        super(ProgramItApp, self).__init__(**kwargs)
        self.logObj = kwargs["logObj"]
        if HostRPC:
            self.ThrdRPC = threading.Thread(
                target=self.RPC_Listener, args=(RPC_PORT,))
            self.ThrdRPC.daemon = True
        if HostCMD:
            self.ThrdCMD = threading.Thread(
                target=self.CMD_Listener, args=(CMD_PORT,))
            self.ThrdCMD.daemon = True
        # instances of MessageBox
        self.mbCheck = None
        self.mbOk = None
        # XM_partName of the program to go to when finished build
        self.defProg = None
        self.lstProgs = []
        # iterable of XM_partName
        self.defProg1 = None
        # keyed:mfgName, valued:iterable of mfgPartNames or STRING("ALL")
        self.defProg2 = None
        # iterable of mfgPartName
        self.defProg3 = None
        self.cmdList = CmdList()
        self.prevSel = None
        self.curProg = None
        self.usbFileChooser = None
        self.curProjName = ""
        self.progStyle = ProgStyleStorage()
        self.progStyle.lstW = .8
        self.progStyle.lstH = .75
        self.progStyle.btnH = .1
        self.progStyle.fntSz = 16
        scrnSize = 800, 480
        self.progStyle.scroll_dist_product = self.progStyle.lstH * scrnSize[1] * globalVars.scroll_distance
        self.progStyle.brdImgW = .128
        self.cbExitCurScrn = None
        self.saveItCB = lambda fName: self.saveIt(fName)
        self.loadItCB = lambda fName: self.loadIt(fName)
        self.app_data = AppData(
            dict(pos_hint={'x': 0.0, "top": .85}, size_hint=(1.0, .85)),
            {(bus, cs): [] for bus in enumerateSpiBus() for cs in enumerateSpiBusCs(bus)},
            None, # set wnd later
            None, # set mbCheck later
            None, # set mbOk later
            self.stopApp,
            None, # set usbEjectPopup later
            None, # set usbEjectFailPopup later
            None, # set lstColW later
            self.progStyle,
            self.lstProgs,
            self.logObj,
            None, # set usbScreenStorage later
            baseDir,
            self.saveItCB,
            self.loadItCB,
            self.chainProgramIt
        )
        for bus in enumerateSpiBus():
            multiData = getMulti(bus)
            if multiData is None:
                continue
            for (cs, muxVal, multi) in multiData:
                self.app_data.SpiChains[(bus, cs, multi)] = []
        screens = [None] * SCRN_MAX_PLUS_1
        " :type screens: list[BaseScreen|None]"
        screens[SCRN_NONE] = None
        screens[SCRN_SAVE] = SaveLoadScreen(True)
        screens[SCRN_LOAD] = SaveLoadScreen(False)
        screens[SCRN_FILE_MGMT] = FileManagementScreen()
        screens[SCRN_IO_CFG] = self.theIO_Config = IOConfigHelpers(self.app_data)
        screens[SCRN_PART_CTL] = PartCtlScreen()
        self.app_data.usbScreenStorage = scrnStor = UsbScreenStorage(screens, UsbHandler(self.app_data))
        self.observer = observers.Observer()
        if scrnStor.usbHandler.watchDir is not None:
            self.observer.schedule(scrnStor.usbHandler, scrnStor.usbHandler.watchDir, False)
        self.observer.start()
        self.progStyle.relYBtns = ((1 - self.progStyle.lstH) / 2 - self.progStyle.btnH) / 2
        self.testStyle = dict(pos_hint={'x': .1, "top": .85}, size_hint=(.8, .8))
        self.fVer = len(LstVer) - 1
        for k in dir(AppCfg.ProgramItData):
            if k.startswith("_"): continue
            setattr(self, k, getattr(AppCfg.ProgramItData, k))
        for k in dir(AppCfg.ProgramItOps):
            if k.startswith("_"): continue
            getattr(AppCfg.ProgramItOps, k)(getattr(self, k))
        self.DoSuggestVersionUpdate = True

    def goScreen(self, scrnId, ext_data=None, obj=None):
        assert obj is None or isinstance(obj, Widget)
        scrnStor = self.app_data.usbScreenStorage
        scrn = scrnStor.screens[scrnId]
        assert isinstance(scrn, BaseScreen)
        name = scrn.getName()
        if callable(name):
            name = name(scrn, self.app_data, ext_data)
        self.logObj.Log("Opening screenId=%u (%s)" % (scrnId, name), ACTION_LVL)
        self.execute_and_push(
            (self.doScreen, scrnId) if ext_data is None else (self.doScreen, scrnId, ext_data),
            name
        )

    def execute_and_push(self, cmd, name, noCpy=True):
        self.cmdList.push(cmd, name, noCpy)
        cmd[0](*cmd[1:])

    def doScreen(self, scrnId, ext_data=None):
        app_data = self.app_data
        scrnStor = app_data.usbScreenStorage
        scrn = scrnStor.screens[scrnId]
        assert isinstance(scrn, BaseScreen)
        self.logObj.Log("Doing screenId=%u (topMenu)" % scrnId, ACTION_LVL)
        self.topMenu(scrn.smallXM_Logo)
        scrnStor.curScreenId = scrnId
        scrnStor.cbExitCurScrn = self.hideScreen
        self.logObj.Log("Building screenId=%u (topMenu)" % scrnId, ACTION_LVL)
        if ext_data is None:
            scrn.build(app_data)
        else:
            scrn.build(app_data, ext_data)

    @staticmethod
    def hideScreen(app_data):
        assert isinstance(app_data, AppData)
        scrnStor = app_data.usbScreenStorage
        scrnId = scrnStor.curScreenId
        scrnStor.curScreenId = 0
        scrn = scrnStor.screens[scrnId]
        assert isinstance(scrn, BaseScreen)
        app_data.logObj.Log("Hiding screenId=%u" % scrnId, ACTION_LVL)
        scrn.hide(app_data)

    def CMD_Listener(self, port):
        try:
            for af, typ, prot, ca, sa in socket.getaddrinfo(
                    "", port, socket.AF_INET, socket.SOCK_STREAM, socket.IPPROTO_TCP):
                try:
                    sock = socket.socket(af, typ, prot)
                    sock.bind(sa)
                    sock.listen(0)
                except (socket.error, socket.timeout):
                    continue
                else:
                    break
            else:
                self.logObj.Log("CMD thread socket failed to bind", 1)
                return
        except socket.gaierror:
            sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM, socket.IPPROTO_TCP)
            sock.bind(("", CMD_PORT))
            sock.listen(0)
        while True:
            try:
                conn, addr = sock.accept()
                self.logObj.Log("Accepted CMD connection %s" % str(addr), 3)
                self.CMD_Thread(conn)
            except (socket.error, socket.timeout):
                self.logObj.Log("CMD thread Socket: %s" % traceback.format_exc()[:-1], 2)
            except StandardError:
                self.logObj.Log("CMD thread: %s" % traceback.format_exc()[:-1], 2)
            finally:
                self.logObj.Log("Terminated CMD connection %s" % str(addr), 3)

    def CMD_Thread(self, sock):
        rtn_queue = Queue.Queue()
        buf = bytearray()
        try:
            while True:
                s, is_all = recv_all(sock, 1)
                if not is_all:
                    raise socket.error("EndOfStream: connection reset by peer")
                cmd_src = s[0]
                if cmd_src == '#':
                    s, is_all = recv_all(sock, 4)
                    if not is_all:
                        raise socket.error("EndOfStream: connection reset by peer")
                    n = GetLongStrBytes(s)
                    s, is_all = recv_all(sock, n)
                elif cmd_src == '!':
                    s = sock.recv(4096)
                    is_all = len(s)
                elif cmd_src == '>':
                    s, is_all = recv_delim(sock, '\n', buf)
                    self.logObj.Log("CMD_Thread: >recv " + repr(s))
                elif cmd_src == '*':
                    s, is_all = recv_delim(sock, '\r', buf)
                    self.logObj.Log("CMD_Thread: *recv " + repr(s))
                elif cmd_src == '$':
                    s, is_all = recv_delim(sock, '\r\n', buf)
                    self.logObj.Log("CMD_Thread: $recv " + repr(s))
                else:
                    sock.send("EINVAL: Invalid Option")
                    continue
                if not is_all:
                    raise socket.error("EndOfStream: connection reset by peer")
                if cmd_src in "!#>*$":
                    if s.lower() in {"end session", "disconnect", "close"}:
                        sock.close()
                        break
                    elif s.lower() in {"shutdown", "poweroff", "quit"}:
                        sock.close()
                        Clock.schedule_once(lambda dt: self.stopAppAndPowerOff())
                        break
                    Clock.schedule_once(
                        Bind(ProgramItApp.executeCMD, self, s, rtn_queue))
                    rtn = rtn_queue.get()
                    if rtn[0] != 'S' and rtn[0] != 'E':
                        self.logObj.Log("Must use 'S' or 'E' for message", 2)
                    else:
                        rtn = {'S': "SUCCESS: ", 'E': "ERROR: "}[rtn[0]] + rtn[1:]
                    if cmd_src == '#':
                        sock.send(AlignStrBytesLong(len(rtn), 4) + rtn)
                    elif cmd_src == '>':
                        rtn += '\n'
                        self.logObj.Log("CMD_Thread: >send " + repr(rtn))
                        sock.send(rtn)
                    elif cmd_src == '*':
                        rtn += '\r'
                        self.logObj.Log("CMD_Thread: *send " + repr(rtn))
                        sock.send(rtn)
                    elif cmd_src == '$':
                        rtn += '\r\n'
                        self.logObj.Log("CMD_Thread: $send " + repr(rtn))
                        sock.send(rtn)
                    else:
                        sock.send(rtn)
        except:
            self.logObj.Log("ERROR in CMD_Thread\n" + traceback.format_exc(), 1)
            sock.close()

    def RPC_Listener(self, port):
        try:
            for af, typ, prot, ca, sa in socket.getaddrinfo(
                    "", port, socket.AF_INET, socket.SOCK_STREAM, socket.IPPROTO_TCP):
                try:
                    sock = socket.socket(af, typ, prot)
                    sock.bind(sa)
                    sock.listen(0)
                except (socket.error, socket.timeout):
                    continue
                else:
                    break
            else:
                self.logObj.Log("RPC thread socket failed to bind", 1)
                return
        except socket.gaierror:
            sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM, socket.IPPROTO_TCP)
            sock.bind(("", RPC_PORT))
            sock.listen(0)
        while True:
            try:
                conn, addr = sock.accept()
                self.logObj.Log("Accepted connection %s" % str(addr), 3)
                self.RPC_Thread(conn)
            except (socket.error, socket.timeout):
                self.logObj.Log("RPC thread Socket: %s" % traceback.format_exc()[:-1], 2)
            except StandardError:
                self.logObj.Log("RPC thread: %s" % traceback.format_exc()[:-1], 2)
            finally:
                self.logObj.Log("Terminated connection %s" % str(addr), 3)

    def RPC_Thread(self, sock):
        Persist = ValuePack()
        RtnQueue = Queue.Queue()
        Persist.TheApp = self
        res_buf = bytearray()
        Persist.output = lambda *args: res_buf.extend(", ".join(map(str, args)).encode("utf8"))
        CurWidth = 800
        while True:
            Str = sock.recv(4096)
            if len(Str) == 0:
                raise socket.error("EndOfStream: connection reset by peer")
            CmdSrc = ord(Str[0])
            Str = Str[1:]
            if CmdSrc == 0:  # SRC_PROGRAM
                CmdCode = ord(Str[0])
                Str = Str[1:]
                if CmdCode == 0:  # VAL_WIDTH
                    CurWidth = (ord(Str[1]) << 8) | ord(Str[0])
            elif CmdSrc == 1:  # SRC_USER
                sock.send(">>> " + Str)
                if Str.startswith("#exit"):
                    sock.close()
                    break
                Clock.schedule_once(
                    Bind(RPC_Action, Str, globals(), Persist.__dict__, RtnQueue))
                RtnCode, Rtn = RtnQueue.get()
                if len(res_buf):
                    res_buf.append("\n")
                if RtnCode == 0:
                    pass
                elif RtnCode == 1:
                    res_buf.extend(ReprMaxLenCh(Rtn, CurWidth // 9 + 1).encode("utf8"))
                elif RtnCode == 2:
                    res_buf.extend(Rtn.encode("utf8"))
                else:
                    res_buf.extend(b"UNKNOWN Return Type")
                if len(res_buf):
                    n = sock.send(res_buf)
                    res_buf[:n] = b""
                    while len(res_buf):
                        n = sock.send(res_buf)
                        res_buf[:n] = b""
            else:
                sock.send("WARNING: Invalid Option")

    def executeCMD(self, s, rtn_queue, dt=None):
        rtn = "Etype help to see how to use"
        data = s.split(' ', 1)
        cmd = data[0].lower()
        args = "" if len(data) == 1 else data[1].lstrip()
        if cmd in {"help", "howto"}:
            rtn = "S" + "\n".join([
                "list of commands",
                "  help/howto  -  displays this help",
                "  end session/disconnect/close  -  closes the connection",
                "  shutdown/poweroff/quit  -  ends the session and shuts down the Raspberry Pi",
                "  @part <number> <...command>  -  sends <command> to the part at index <number>",
                "  add_part_pn <partNumber>  -  adds the part named <partNumber> to the list of control screens",
                "  add_part_mfg_pn <mfg> <mfgPN>  -  adds the part from manufacturer <mfg> with part number <mfgPN>",
                "  remove_part <number>  -  removes the part at index <number>",
                "  remove_all  -  removes all parts",
                "  show_part <number>  -  shows the part on the screen",
                "  home_screen  -  goes to the home screen",
                "  screenshot <filename>  -  takes a screenshot and saves it to filename",
                "",
                "  type @part <number> help to see help for a specific part",
            ])
        elif cmd == "@part":
            args = args.split(' ', 1)
            if len(args) != 2:
                rtn = "E" + "expected number, type help to see how this works"
            else:
                args[1] = args[1].lstrip()
                try:
                    part_index = int(args[0])
                    if not (0 <= part_index < len(self.lstProgs)):
                        raise ValueError("expected number from 0 to %u" % (len(self.lstProgs) - 1))
                except ValueError as exc:
                    rtn = "E" + str(exc)
                else:
                    rtn = self.lstProgs[part_index].executeCMD(args[1])
        elif cmd == "add_part_pn":
            cls = globalVars.dctParts.get(args, None)
            if cls is None:
                rtn = "E" + "X-MW PN not found: '%s'" % args
            else:
                rtn = "S" + "'%s' control screen added" % args
                self.mkProg(cls, None)
        elif cmd == "add_part_mfg_pn":
            if len(args) == 0:
                rtn = "E" + "expected arguments to be provided, see help"
            else:
                end = args.find('"', 1) if args[0] == '"' else args.find(' ')
                mfgName = args[:end]
                mfgPartName = args[end:]
                if mfgPartName.startswith(' '):
                    mfgPartName = mfgPartName.lstrip()
                mfg = globalVars.partManufs.get(mfgName, None)
                if mfg is None:
                    rtn = "E" + "mfg not found: mfg='%s', mfgPN='%s'" % (mfgName, mfgPartName)
                else:
                    cls = mfg.get(mfgPartName, None)
                    if cls is None:
                        rtn = "E" + "mfgPN not found: mfg='%s', mfgPN='%s'" % (mfgName, mfgPartName)
                    else:
                        rtn = "S" + "control screen added: mfg='%s', mfgPN='%s'" % (mfgName, mfgPartName)
                        self.mkProg(cls, None)
        elif cmd == "remove_part":
            try:
                part_index = int(args)
            except ValueError as exc:
                rtn = "E" + str(exc)
            else:
                if part_index < 0:
                    rtn = "E" + "part index must be non-negative got %i" % part_index
                elif part_index >= len(self.lstProgs):
                    rtn = "E" + "part index >= # of ctl screens got %i when # of ctl screens is %u" % (
                        part_index, len(self.lstProgs))
                else:
                    self.removePart(part_index)
                    rtn = "S" + "removed control screen at index %u" % part_index
                    self.goHome()
        elif cmd == "remove_all":
            self.removePart(-1)
            rtn = "S" + "removed all control screens"
            self.goHome()
        elif cmd == "show_part":
            try:
                part_index = int(args.strip())
                if not (0 <= part_index < len(self.lstProgs)):
                    raise ValueError("expected number from 0 to %u" % (len(self.lstProgs) - 1))
            except ValueError as exc:
                rtn = "E" + str(exc)
            else:
                self.goProgPart(part_index)
                rtn = "Sshowing part %u" % part_index
        elif cmd == "home_screen":
            self.goHome()
            rtn = "S" + "going to home screen"
        elif cmd == "screenshot":
            rtn = "S" + "screenshot saved to " + self.wnd.parent.screenshot(name=args)
        if not isinstance(rtn, (str, unicode)):
            rtn = "S" + repr(rtn)
        if isinstance(rtn, unicode):
            rtn = "enc:utf8;" + rtn.encode("utf-8")
        rtn_queue.put(rtn)


    def removePart(self, part_index):
        if part_index < 0:
            # inplace clear so the references don't refer to an outdated list
            for prog in self.lstProgs:
                prog.destroy(self.app_data)
            self.lstProgs[:] = []
            self.prevSel = None
        else:
            self.lstProgs[part_index].destroy(self.app_data)
            self.lstProgs.pop(part_index)
            if self.prevSel is None:
                pass
            elif self.prevSel == part_index:
                self.prevSel = None
            elif self.prevSel > part_index:
                self.prevSel -= 1
        self.cmdList.clear()

    def TestParts(self, partIndex, until, dt=None):
        del dt
        self.goProgPart(partIndex)
        try:
            self.curProg.programIt(self.curProg.progBtn)
        except StandardError:
            self.logObj.Log("Error while testing %u: %s" % (
                partIndex, traceback.format_exc()[:-1]), 1)
        else:
            self.logObj.Log("Passed testing part %u" % partIndex, 3)
        partIndex += 1
        if partIndex < until:
            Clock.schedule_once(Bind(self.TestParts, partIndex, until), .5)
        else:
            self.logObj.Log("Finished part tests", 3)

    def postBuild(self, dt=None):
        del dt
        # self.MyConsole = console.start(self.root_window, self.wnd)
        if HostRPC:
            self.ThrdRPC.start()
        if HostCMD:
            self.ThrdCMD.start()
        self.SelectSpiBus = SelectPopupMaker(
            {x: "Spi Bus %u" % x for x in enumerateSpiBus()}, 0)
        self.SelectSpiLE = {
            x: SelectPopupMaker({x0: "LE/CS %u" % x0 for x0 in enumerateSpiBusCs(x)}, 0)
            for x in enumerateSpiBus()}
        self.app_data.usbScreenStorage.usbHandler.refresh_synch_main()

    def build1(self):
        # nTyp = (int, long)
        progClasses = []
        if not StartBlank: self.defProg1 = sorted(globalVars.dctParts)
        # noinspection PyBroadException
        try:
            if self.defProg1 is not None:
                progClasses = [globalVars.dctParts[name] for name in self.defProg1]
            elif self.defProg2 is not None:
                for manuf in self.defProg2:
                    if isinstance(self.defProg2[manuf], (str, unicode)):
                        if self.defProg2[manuf].upper() == "ALL":
                            self.defProg2[manuf] = sorted(globalVars.partManufs[manuf])
                    if not isinstance(self.defProg2[manuf], (list, tuple, set)):
                        raise TypeError(
                            "self.defProg2 values must of type list or have value" +
                            ".upper() == \"ALL\" if it is string")
                progClasses = reduce(list.__add__, [
                    [globalVars.partManufs[manuf][name] for name in self.defProg2[manuf]]
                    for manuf in sorted(self.defProg2)])
            elif self.defProg3 is not None:
                progClasses = [globalVars.mfgPartNames[name] for name in self.defProg3]
        except:
            progClasses = []
            log.Log(traceback.format_exc() + "  Failed to get classes for defProgs", 2)
        self.startProgBar(
            self.buildProg(progClasses),
            "Building Control Screens",
            lambda dt=None: self.build2())

    def buildProg(self, progClasses, ignoreBad=False):
        lstProgs = [None] * len(progClasses)
        data = self.data["progData"]
        tTotal = sum(map(lambda x: data.get(x.XM_partName, 0), progClasses))
        yield tTotal
        totalTime = 0
        newTotalTime = 0
        for c in xrange(len(progClasses)):
            cur = progClasses[c]
            tPrev = time.time()
            if ignoreBad:
                try:
                    lstProgs[c] = cur()
                    lstProgs[c].app = self.app_data
                except:
                    self.logObj.Log(
                        "buildProg: error at index = %u, name=%r, module=%r, tb: %s" % (
                            c, cur.__name__, cur.__module__, traceback.format_exc()[:-1]
                        ),
                        2
                    )
            else:
                lstProgs[c] = cur()
                lstProgs[c].app = self.app_data
            tCur = time.time()
            old = data.get(cur.XM_partName, 0)
            tNew = tCur - tPrev
            data[cur.XM_partName] = tNew
            totalTime += old
            newTotalTime += tNew
            yield totalTime, newTotalTime
        self.lstProgs[:] = filter(lambda x: x is not None, lstProgs)


    def build2(self):
        nTyp = (int, long)
        if self.defProg is None:
            self.goHome()
        elif isinstance(self.defProg, nTyp) and self.defProg < len(self.lstProgs):
            self.goProgPart(self.defProg)
        elif isinstance(self.defProg, str) and self.defProg in self.defProg1:
            self.goProgPart(self.defProg1.index(self.defProg))
        else:
            self.goHome()
        Clock.schedule_once(self.postBuild)

    def startProgBar(self, curLoader, title, progNext):
        self.curLoader = curLoader
        self.progBar = ProgressBar(
            max=self.curLoader.next(), size_hint=(.5, .1,),
            pos_hint={"center_x": 0.5, "center_y": .5})
        self.wnd.add_widget(self.progBar)
        self.timeEstimateGrid = GridLayout(
            cols=2, size_hint=(.5, .1), pos_hint={"center_x": .5, "top": .4})
        self.timeEstimateGrid.add_widget(sizedLabel(text="estimated time left"))
        self.timeLeftLbl = Label(text="Unknown")
        self.timeEstimateGrid.add_widget(self.timeLeftLbl)
        self.wnd.add_widget(self.timeEstimateGrid)
        self.wnd.add_widget(sizedLabel(
            text=title, font_size=24, pos_hint={"center_x": .5, "top": .75}))
        self.progNext = progNext
        Clock.schedule_once(self.doProgBar)

    def doProgBar(self, dt=None):
        del dt
        try:
            oldTotal, newTotal = self.curLoader.next()
            if newTotal > 0:
                num = (self.progBar.max - oldTotal) * oldTotal / float(newTotal)
                self.timeLeftLbl.text = "%.4g seconds" % num
            self.progBar.value = oldTotal
        except StopIteration:
            Clock.schedule_once(self.progNext, 0)
        else:
            Clock.schedule_once(self.doProgBar, 0)

    def build(self):
        self.app_data.wnd = self.wnd = Bordered(size_hint=(1.0, 1.0), bdw=0)
        self.thereCanOnlyBeOne = Label(
            text="Only one USB Drive at a time is supported.\nPlease remove all USB drives except for the one you want",
            halign="center", size_hint=(.48, .89), pos_hint={"x": 0.505, "y": 0.01})
        self.app_data.mbCheck = MessageBox(MB_YESNO, size_hint=(.4, .8))
        self.app_data.mbOk = MessageBox(MB_OK, size_hint=(.4, .8))
        UpdateFileManager.initCls(self.app_data)
        OS_UpdateFileManager.initCls(self.app_data)
        content = FloatLayout(size_hint=(1.0, 1.0), pos_hint={'x': 0.0, "top": 1.0})
        content.add_widget(Label(
            size_hint=(1.0, .8), pos_hint={'x': 0.0, 'y': .2}, text="\n".join([
                "Successfully ejected USB drive.",
                "The drive may now be safely removed."])))
        btn = Button(text="close", size_hint=(1.0, .2), pos_hint={'x': 0.0, 'y': 0.0})
        content.add_widget(btn)
        self.app_data.usbEjectPopup = Popup(
            title="USB Eject Success", title_color=kGREEN,
            title_size="18sp", separator_color=kD0_GREY,
            size_hint=(.4, .5), title_align="center", content=content)
        btn.bind(on_release=self.app_data.usbEjectPopup.dismiss)
        content1 = FloatLayout(size_hint=(1.0, 1.0), pos_hint={'x': 0.0, "top": 1.0})
        content1.add_widget(Label(
            size_hint=(1.0, .8), pos_hint={'x': 0.0, 'y': .2}, text="\n".join([
                "Error occured when attempting to eject",
                "USB drive.",
                "The drive is busy. Try again later."])))
        btn1 = Button(text="close", size_hint=(1.0, .2), pos_hint={'x': 0.0, 'y': 0.0})
        content1.add_widget(btn1)
        self.app_data.usbEjectFailPopup = Popup(
            title="USB Eject Error", title_color=kRED,
            title_size="18sp", separator_color=kD0_GREY,
            size_hint=(.4, .5), title_align="center", content=content1)
        btn1.bind(on_release=self.app_data.usbEjectFailPopup.dismiss)
        self.startProgBar(
            partmods.LoadModules(self.data["partmods"]),
            "Loading Modules",
            lambda dt=None: self.build0())
        return self.wnd

    def build0(self):
        self.wnd.clear_widgets()
        self.smallLogo = Image(
            source=images.smallLogo, size_hint=(.05, .08),
            pos_hint={'x': 0.0, "top": 1.0})
        # fullLogo is ./X-MW-logo.png or ./X-MW-logo1.png
        self.logo = Image(
            source=images.fullLogo, size_hint=(.25, .08),
            pos_hint={'x': .0, "top": 1.0})
        rPos = .995
        navW = .046 * 4
        rPos -= navW
        lPos = self.logo.size_hint[0] + self.logo.pos_hint['x']
        titleW = rPos - lPos
        self.titleLbl = Label(
            text="", size_hint=(titleW, .08), pos_hint={'x': lPos, "top": 1.0},
            font_size=24)
        fntSz = self.progStyle.fntSz
        self.goDelAll = Bind(self.goDelPart, -1)
        style = dict(color=(.75, .75, .75, 1.), disabled_color=(.4, .4, .4, 1.))
        self.helpBtn = ClkImage(
            on_release=self.goHelp, source=images.help, **style)
        self.homeBtn = ClkImage(
            on_release=self.goHome, source=images.home, **style)
        self.forwardBtn = ClkImage(
            on_release=self.goForward, source=images.forward, **style)
        self.backBtn = ClkImage(
            on_release=self.goBack, source=images.back, **style)
        self.navGrid = GridLayout(
            rows=1, pos_hint={"right": .995, "top": .99}, size_hint=(.046 * 4, .06))
        self.navGrid.add_widget(self.backBtn)
        self.navGrid.add_widget(self.forwardBtn)
        self.navGrid.add_widget(self.homeBtn)
        self.navGrid.add_widget(self.helpBtn)
        hdStyle = dict(font_size=fntSz, height=36)
        self.lstColW = [.1, .2, None, .18, .07, .1, .15]
        self.lstColHd = [
            "Category", "X-MW P/N", "MFG", "MFG P/N", "Bus", "Address", ""]
        cols = len(self.lstColHd)
        procColsW(self.lstColW, 1.0)
        self.app_data.lstColW = self.lstColW
        self.headGrid = BorderedGridLayout(
            cols=cols, size_hint=(.98, .06), pos_hint={'x': .01, "top": .91})
        for hdr, colW in zip(self.lstColHd, self.lstColW):
            self.headGrid.add_widget(Label(text=hdr, size_hint_x=colW, **hdStyle))
        relYBtns = self.progStyle.relYBtns
        btnH = self.progStyle.btnH
        fntSz = self.progStyle.fntSz
        quitBtn_x = .46
        quitBtn_w = .1
        quitTxt = "Quit"
        if globalVars.canPowerOff:
            if globalVars.onlyPowerOff:
                # quitTxt += " &\nPower off"
                pass
            else:
                quitTxt += " /\nPower off"
            quitBtn_x += quitBtn_w
            quitBtn_w += .05
            quitBtn_x -= quitBtn_w
        footSpaceHintX = .02
        footBtnW = [quitBtn_w, .1, .1, .1, .1, .1, .1]
        footSizeHintX = sum(footBtnW) + len(footBtnW) * footSpaceHintX
        footBtnW = map(lambda x: x / footSizeHintX, footBtnW)
        footBtnActions = [
            (quitTxt, self.goQuit),
            ("Manage\nFiles", Bind(self.goScreen, 3, None)),
            ("Save", Bind(self.goScreen, 1, None)),
            ("Load", Bind(self.goScreen, 2, None)),
            ("Add\nPart", self.goAddNew_CatList),
            ("Remove\nAll", self.goDelAll),
            ("I/O Config", self.goIO_Config)]
        footBtns = [
            Button(
                text=txt, on_release=action, size_hint=(widthHint, 1.0),
                font_size=fntSz, halign='center')
            for (txt, action), widthHint in zip(footBtnActions, footBtnW)]
        self.footGrid = SpcHintGridLayout(
            pos_hint={"center_x": .5, 'y': relYBtns}, rows=1,
            size_hint=(footSizeHintX, btnH), spacing_hint=[footSpaceHintX, 0])
        map(self.footGrid.add_widget, footBtns)
        self.lstColNewW = [None, None, None, .15]
        self.lstColNewHd = ["X-MW P/N", "MFG", "MFG P/N", "Interface"]
        cols = len(self.lstColNewHd)
        procColsW(self.lstColNewW, 1.0)
        self.newHdGrid = BorderedGridLayout(
            cols=cols, size_hint=(.98, .06), pos_hint={'x': .01, "top": .91})
        for hdr, colW in zip(self.lstColNewHd, self.lstColNewW):
            self.newHdGrid.add_widget(Label(text=hdr, size_hint_x=colW, **hdStyle))
        self.build1()

    def buildProgFromFile(self, progClasses, fl):
        self.lstProgs[:] = [None] * len(progClasses)
        data = self.data["progData1"]
        tTotal = sum(map(lambda x: data.get(x.XM_partName, 0), progClasses))
        yield tTotal
        totalTime = 0
        newTotalTime = 0
        for c in xrange(len(progClasses)):
            cur = progClasses[c]
            tPrev = time.time()
            self.lstProgs[c] = cur(fl)
            self.lstProgs[c].app = self.app_data
            tCur = time.time()
            old = data.get(cur.XM_partName, 0)
            tNew = tCur - tPrev
            data[cur.XM_partName] = tNew
            totalTime += old
            newTotalTime += tNew
            yield totalTime, newTotalTime

    def saveIt(self, fName):
        fl = open(fName, "wb")
        fl.write(AlignStrBytesLong(self.fVer, 2))
        SaveFile(self, self.fVer, fl)
        fl.close()
        # return "Successfully saved %s"
        self.goHome(None)

    def loadIt(self, fName):
        fl = open(fName, "rb")
        try:
            fVer = GetLongStrBytes(fl.read(2))
            if fVer > self.fVer:
                if self.DoSuggestVersionUpdate and self.fVer >= 2:
                    major, minor = LstVer[2].versionPacker.Unpack(fl)
                    raise LoadError(
                        ERR_FL_FMT_VER_NEW, fName,
                        "check for file corruption or\n(suggestion) update to version %u.%u" % (
                            major, minor))
                raise IOError("unsupported (too new) file version. Possible corrupt file or outdated program")
            for prog in self.lstProgs:
                prog.destroy(self.app_data)
            self.prevSel = None
            log.Log("LoadFile before: stage 1")
            rtn = LoadFile(self, fVer, fl) # file closed with the call to self.doneLoad
            log.Log("LoadFile after: stage 2")
            if rtn is not None:
                log.Log("LoadFile after(branch): stage 3")
                log.Log("in file '%s', %s" % (fName, rtn), 2)
                log.Log("LoadFile after(branch): stage 4")
                fl.close()
                log.Log("LoadFile after(branch): stage 5")
        except:
            fl.close()
            raise

    def doneLoad(self, fl):
        fl.close()
        self.cmdList.clear()
        self.goHome(None)

    def goHome(self, obj=None):
        del obj
        self.cmdList.push((self.home,), "Home")
        self.home()

    @staticmethod
    def hasHelp(cmd):
        if cmd is None: return False
        return False

    def getHelp(self, cmd):
        defRtn = "Help not available for this section yet"
        rtn = None
        markup = False
        if cmd[0][0] == self.doScreen:
            scrnId = cmd[0][1]
            app_data = self.app_data
            scrnStor = app_data.usbScreenStorage
            scrn = scrnStor.screens[scrnId]
            assert isinstance(scrn, BaseScreen)
            rtn = scrn.getHelp(self)
            if rtn is not None:
                assert isinstance(rtn, (tuple, list)), "scrn.getHelp(app) must return tuple(text, isMarkup)"
                return rtn
        if cmd[1].startswith("Programming"):
            try:
                rtn = self.lstProgs[cmd[0][1]].userHelp
            except IndexError:
                rtn = "help is not available for this control screen yet"
        elif cmd[1].startswith("Select Part in Category"):
            rtn = cmd[0][1].userHelp
        elif cmd[1] in self.helps:
            markup = cmd[1] in self.helpsMarkUp
            if markup:
                rtn = self.helpsMarkUp[cmd[1]]
                if cmd[1] == "Home" and (HostCMD or HostRPC):
                    x = getIPv4And6Addr()
                    if x[0] != "127.0.0.1":
                        rtn += (
                            "\n ipv4 address: [color=#CCFF26]%s[/color]\n ipv6 address: [color=#CCFF26]%s[/color]" %
                            x
                        )
            else:
                rtn = self.helps[cmd[1]]
                if cmd[1] == "Home" and (HostCMD or HostRPC):
                    x = getIPv4And6Addr()
                    if x[0] != "127.0.0.1":
                        rtn += "\n ipv4 address: %s\n ipv6 address: %s" % x
        return (defRtn if rtn is None else rtn), markup

    def goHelp(self, obj=None):
        del obj
        title = "Help"
        if self.hasHelp(self.cmdList.atCur()):
            title += ": " + self.cmdList.atCur()[1]
        self.cmdList.push((self.Help,), title)
        self.Help()

    def goProgPart(self, progIndex, obj=None):
        del obj
        scrnStor = self.app_data.usbScreenStorage
        scrn = scrnStor.screens[SCRN_PART_CTL]
        assert isinstance(scrn, PartCtlScreen)
        self.goScreen(SCRN_PART_CTL, progIndex)
        # self.cmdList.push((self.progPart, progIndex), "Programming %s" % self.lstProgs[progIndex].XM_partName)
        # self.progPart(progIndex)

    def goDelPart(self, progIndex, obj=None):
        del obj
        self.cmdList.push((self.delPart, progIndex), "Confirm Delete")
        self.delPart(progIndex)

    def goQuit(self, obj=None):
        del obj
        self.logObj.Log("Doing goQuit", ACTION_LVL)
        self.cmdList.push((self.doQuit,), "Confirm Quit")
        self.doQuit()

    def doQuit(self):
        self.topMenu()
        layout = GridLayout(rows=2, cols=2, **self.app_data.defStyle)
        sz = self.progStyle.fntSz
        layout.add_widget(Label(
            text="Are you sure you want to quit?\nAny unsaved changes will be lost.", font_size=sz * 1.6))

        def YesQuit(obj):
            self.cmdList.clear()
            self.stopApp(obj)

        def NoQuit(obj):
            self.goBack(obj)
            self.goHome(obj)

        def YesPwrOff(obj):
            try:
                YesQuit(obj)
            finally:
                globalVars.powerOff = True

        if globalVars.canPowerOff and not globalVars.onlyPowerOff:
            otherWidget = Button(
                text="Quit without powering off", on_release=YesQuit, font_size=sz * 1.6)
        else:
            otherWidget = Label(text="", font_size=sz)
        # txt += "\nIf not then click the help (?) button."
        layout.add_widget(otherWidget)
        sz *= 6
        YesAction = YesPwrOff if globalVars.canPowerOff else YesQuit
        layout.add_widget(Button(text="Yes", on_release=YesAction, font_size=sz))
        layout.add_widget(Button(text="No", on_release=NoQuit, font_size=sz))
        self.wnd.add_widget(layout)

    def stopAppAndPowerOff(self):
        self.stopApp()
        if globalVars.canPowerOff:
            globalVars.powerOff = True

    def goBack(self, obj):
        del obj
        tmp = self.cmdList.pop()
        if tmp is not None:
            cmd, name = tmp
            cmd[0](*cmd[1:])

    def goForward(self, obj):
        del obj
        tmp = self.cmdList.unPop()
        if tmp is not None:
            cmd, name = tmp
            cmd[0](*cmd[1:])

    def home(self):
        self.topMenu()
        # self.scrName("Home")
        relSz = (.98, .7)
        relX = .5 - relSz[0] / 2
        relY = .48 - relSz[1] / 2
        #UseNewList = True
        theListCls = XMFlagStyleButton#XMHomeItem if UseNewList else CompositeListItem
        theListArgsConv = convProgLstItem2#convProgLstItem1 if UseNewList else convProgLstItem
        theList = BorderedList(bdr=8, adapter=ListAdapter(
            cls=theListCls, allow_empty_selection=True,
            selection_mode='single', data=self.lstProgs,
            args_converter=Bind(theListArgsConv, self)
        ), pos_hint={'x': relX, 'y': relY}, size_hint=relSz)
        if self.prevSel is not None:
            theList.adapter.select_list([theList.adapter.get_view(self.prevSel)], False)
        scroll = filter(lambda x: isinstance(x, ScrollView), theList.children)[0]
        scroll.bind(on_scroll_start=ScrollAllower)
        # disabled, because it would prevent scrolled widgets from getting touch_down events until released
        # theList.container.parent.bind(on_scroll_start=ScrollAllower)
        self.wnd.add_widget(self.headGrid)
        self.wnd.add_widget(theList)
        self.wnd.add_widget(self.footGrid)
        """self.wnd.add_widget(
            Button(text="Test", on_press=self.goTest,font_size=fntSz,
                   pos_hint={'x':.14, 'y':relYBtns}, size_hint=(.1, btnH)))"""
    def on_stop(self, obj=None):
        self.observer.stop()
        with open(baseDir + "ProgramIt.dat", "wb") as Fl:
            cPickle.dump(self.data, Fl, 1)
        with open(baseDir + "../metainf.json", "w") as Fl:
            json.dump(globalVars.metainf, Fl)
        for dev_inf, devName, mntDir in list(self.app_data.usbScreenStorage.usbHandler.mounted):
            self.app_data.usbScreenStorage.usbHandler.process_rem_dev(None, devName, ImmediateAsynch)

    def stopApp(self, obj=None):
        #self.root_window.close()
        if obj is not None:
            self.stop(obj)
        else:
            self.stop()

    def topMenu(self, small=False):
        scrnStor = self.app_data.usbScreenStorage
        if scrnStor.cbExitCurScrn is not None:
            scrnStor.cbExitCurScrn(self.app_data)
            scrnStor.cbExitCurScrn = None
        self.wnd.clear_widgets()
        self.wnd.add_widget(self.navGrid)
        back = self.cmdList.atPrev()
        forward = self.cmdList.atNext()
        self.backBtn.disabled = back is None
        self.forwardBtn.disabled = forward is None
        if small:
            self.wnd.add_widget(self.smallLogo)
        else:
            self.wnd.add_widget(self.logo)
            self.scrName("Untitled Screen")
            cur = self.cmdList.atCur()
            if cur[1] is not None: self.scrName(cur[1])
            self.wnd.add_widget(self.titleLbl)

    def Help(self):
        self.topMenu()
        fntSz = self.progStyle.fntSz
        txt, markup = self.getHelp(self.cmdList.atPrev())
        self.wnd.add_widget(Label(text=txt, markup=markup, font_size=fntSz))

    def goIO_Config(self, obj):
        self.logObj.Log("called goIO_Config", ACTION_LVL)
        return self.goScreen(SCRN_IO_CFG, obj)

    def goIO_Config_old(self, obj):
        del obj
        self.cmdList.push((self.ioConfig,), "I/O Config")
        self.ioConfig()

    def chainProgramIt(self, bus, cs):
        assert (bus, cs) in self.app_data.SpiChains
        self.logObj.Log("Begin Chain Programming", 3)
        spiChain = self.app_data.SpiChains[(bus, cs)]
        chainSpiBus = ChainSpiBus()
        for prog in spiChain:
            self.logObj.Log("Chain Programming: %s" % repr(prog), 3)
            with VarContext(prog, {"spiBus": chainSpiBus}):
                prog.programIt(prog.progBtn if hasattr(prog, "progBtn") else None)
        spiBus = spiIO_Object(bus, cs)
        spiWriteNum(chainSpiBus.bits.num, chainSpiBus.bits.bitLen, spiBus)
        spiBus.close()
        self.logObj.Log("End Chain Programming", 3)

    def ioConfig(self):
        self.topMenu()
        assert self.app_data.lstProgs is self.lstProgs
        self.theIO_Config.build(self.app_data)
        self.cbExitCurScrn = self.theIO_Config.hide

    def goTest2(self, obj=None):
        del obj
        self.test2(0)

    def test2(self, index, dt=None):
        self.goProgPart(index)
        Clock.schedule_once(Bind(self.test3, index))

    def test3(self, index, dt=None):
        scrnStor = self.app_data.usbScreenStorage
        scrn = scrnStor.screens[SCRN_PART_CTL]
        assert isinstance(scrn, PartCtlScreen)
        try:
            scrn.cur_prog.programIt()
        except:
            self.logObj.Log("test3: error at index = %u, tb: %s" % (index, traceback.format_exc()[:-1]), 2)
        if index + 1 < len(self.lstProgs):
            Clock.schedule_once(Bind(self.test2, index + 1))

    def test1(self):
        dctParts = globalVars.dctParts
        self.startProgBar(
            self.buildProg([dctParts[k] for k in sorted(dctParts)], True),
            "Building Control Screens",
            lambda dt=None: self.goTest2(None))

    def mkProg(self, cls, obj):
        del obj
        self.logObj.Log("called mkProg(%r)" % cls, ACTION_LVL)
        index = len(self.lstProgs)
        self.lstProgs.append(cls())
        self.lstProgs[index].app = self.app_data
        # self.progPart(index)
        self.prevSel = index
        self.cmdList.clear()
        self.goHome()

    def goAddNew_CatList(self, obj):
        del obj
        self.cmdList.push((self.addNew_CatList,), "Select Category")
        self.addNew_CatList()

    def goAddNew_PartList(self, cat, obj):
        del obj
        self.cmdList.push(
            (self.addNew_PartList, cat),
            "Select Part in Category: " + str(cat.abrev))
        self.addNew_PartList(cat)

    def scrName(self, title):
        self.titleLbl.text = title

    # add new control screen(category selection screen)
    def addNew_CatList(self):
        self.topMenu()
        self.logObj.Log("called addNew_CatList", ACTION_LVL)
        relSz = (.98, self.progStyle.lstH)
        relX = .5 - relSz[0] / 2
        relY = .5 - relSz[1] / 2
        theList = BorderedList(bdr=8, adapter=ListAdapter(
            cls=XMButton, allow_empty_selection=False,
            selection_mode='none', args_converter=Bind(catLstConv1, self),
            data=[catAll] + sorted([x for x in globalVars.partCats if not x.isEmpty()])
        ), pos_hint={'x': relX, 'y': relY}, size_hint=relSz)
        scroll = filter(lambda x1: isinstance(x1, ScrollView), theList.children)[0]
        scroll.bind(on_scroll_start=ScrollAllower)
        self.wnd.add_widget(theList)

    def addNew_PartList(self, cat):
        self.topMenu()
        self.logObj.Log("called addNew_PartList CATEGORY: %s (%s)" % (cat.name, cat.abrev), ACTION_LVL)
        relSz = (.98, .7)
        relX = .5 - relSz[0] / 2
        relY = .48 - relSz[1] / 2
        self.wnd.add_widget(self.newHdGrid)
        UseNewList = True
        theListCls = XMHomeItem if UseNewList else ClkCompLstItem
        theListArgsConv = partLstCatConv1 if UseNewList else partLstCatConv
        theList = BorderedList(bdr=8, adapter=ListAdapter(
            cls=theListCls, allow_empty_selection=False,
            selection_mode='none', data=cat.filteredKeys(),
            args_converter=Bind(theListArgsConv, self, cat)
        ), pos_hint={'x': relX, 'y': relY}, size_hint=relSz)
        scroll = filter(lambda x: isinstance(x, ScrollView), theList.children)[0]
        scroll.bind(on_scroll_start=ScrollAllower)
        self.wnd.add_widget(theList)

        """# allows the user to program a part
    def progPart(self, progIndex):
        self.topMenu(True)
        part = self.lstProgs[progIndex]
        part.build(self.app_data)
        self.curProg = part
        self.cbExitCurScrn = self.hideProgPart

        @staticmethod
    def hideProgPart(self):  # self is the app instance that is explicitly passed to this callback
        assert isinstance(self, AppData)
        scrnStor = self.usbScreenStorage
        progScrn = scrnStor.screens[scrnStor.curScreenId]
        assert isinstance(progScrn, PartCtlScreen)
        progScrn.prev_sel
        self.curProg.onhide(self.app_data)
        self.prevSel = self.lstProgs.index(self.curProg)
        self.curProg = None"""

    # confirms that the user wants to delete a program at partIndex
    #  or, if partIndex == -1, all programs
    #  self.delAll(*Params) results in a call to delPart(-1, *Params)
    def delPart(self, progIndex):
        self.topMenu()
        self.logObj.Log("called delPart(%r)" % progIndex, ACTION_LVL)
        layout = GridLayout(rows=2, cols=2, **self.app_data.defStyle)
        txt = "[ALL ITEMS]"
        if progIndex != -1:
            txt = self.lstProgs[progIndex].XM_partName + " (Type: %s)" % globalVars.partCats[self.lstProgs[progIndex].catId].abrev
        sz = self.progStyle.fntSz
        layout.add_widget(Label(
            text="Are you sure you want to remove?", font_size=sz * 1.6))
        layout.add_widget(Label(text=txt, font_size=sz * 1.6))

        def YesDelete(obj):
            del obj
            self.removePart(progIndex)
            self.goHome()

        def NoDelete(obj):
            del obj
            self.cmdList.clear()
            self.goHome()

        sz *= 6
        layout.add_widget(Button(text="Yes", on_release=YesDelete, font_size=sz))
        layout.add_widget(Button(text="No", on_release=NoDelete, font_size=sz))
        self.wnd.add_widget(layout)
