from threading import Condition, Lock


#acts like Clock as in Clock.schedule_once, but executes the callback immediately
class ImmediateAsynch(object):
    @staticmethod
    def schedule_once(fn, *args):
        del args
        fn(0)


class Task(object):
    def __init__(self, fn, *args, **kwargs):
        self.fn = fn
        self.args = args
        self.kwargs = kwargs
        self.Returned = False
        self.Rtn = None
        self.RtnCond = Condition(Lock())

    def run(self, *args):
        del args
        try:
            Rtn = self.fn(*self.args, **self.kwargs)
            Returned = 1
        except Exception as Exc:
            Rtn = Exc
            Returned = 2
        with self.RtnCond:
            self.Rtn = Rtn
            self.Returned = Returned
            self.RtnCond.notify_all()

    def getReturn(self):
        with self.RtnCond:
            if self.Returned == 1:
                return self.Rtn
            elif self.Returned == 2:
                raise self.Rtn
            self.RtnCond.wait()
            if self.Returned == 1:
                return self.Rtn
            elif self.Returned == 2:
                raise self.Rtn