from . import globalVars


# part category
class PartCat(object):
    userHelp = "Select a part from the list of "

    def __init__(self, name, abrev, catId):
        self.name = name
        self.abrev = abrev
        self.catId = catId
        self.parts = {}
        self.userHelp += name

    def filteredKeys(self):
        if globalVars.showDevParts: return sorted(self.parts)
        return [k for k in sorted(self.parts) if not self.parts[k].DevOnly]

    def isEmpty(self):
        if len(self.parts) == 0: return True
        if globalVars.showDevParts: # TODO: make this in globalVars
            return False
        else:
            for k in self.parts:
                if not self.parts[k].DevOnly: return False
        return True

    def __cmp__(self, other):
        return cmp(self.catId, other.catId)

    def __str__(self):
        return self.name + " (" + self.abrev + ")"


def mkPartCat(name, abrev):
    obj = PartCat(name, abrev, len(globalVars.partCats))
    globalVars.partCats.append(obj)
    return obj.catId


catAll = PartCat("All Components", "All", -1)
catAll.parts = globalVars.dctParts
CAT_ALL = -1
CAT_NONE = mkPartCat("Others", "N/A")
CAT_MPAC = mkPartCat("Monolithic Phase Amplitude Controllers", "MPAC")
CAT_DSA = mkPartCat("Digital Step Attenuators", "DSA")
CAT_VGA = mkPartCat("Variable Gain Amplifiers", "VGA")
CAT_DPS = mkPartCat("Digital Phase Shifters", "DPS")
CAT_PLL = mkPartCat("Phase Locked Loops", "PLL")
CAT_PLL_VCO = mkPartCat("PLLs with Integrated VCOs", "PLL/VCO")
CAT_CNV_UP_DN = mkPartCat("Up/Down Converter", "CNV")
CAT_SWITCH = mkPartCat("Switches", "SW")
CAT_DIV = mkPartCat("Frequency Dividers", "DIV")
CAT_TUNE_BPF = mkPartCat("Tunable Band Pass Filters", "TUNE_BPF")
# CAT_HELLO = mkPartCat("Hello There", "HT")