from .LibBaseScreen import BaseScreen
from .LibAppData import AppData


def name_requires_data(scrn, app_data, ext_data):
    del scrn
    partName = app_data.lstProgs[ext_data].XM_partName
    return "Programming " + partName


class PartCtlScreen(BaseScreen):
    __slots__ = ["app", "cur_sel", "prev_sel", "cur_prog"]
    smallXM_Logo = True

    def __init__(self):
        self.app = None
        self.cur_sel = 0
        self.prev_sel = 0
        self.cur_prog = None

    def getName(self):
        return name_requires_data

    def build(self, app, ext_data=0):
        """
        :param AppData app:
        :param int ext_data:
        """
        assert isinstance(app, AppData)
        assert isinstance(ext_data, (int, long))
        self.cur_sel = ext_data
        self.cur_prog = app.lstProgs[ext_data]
        super(PartCtlScreen, self).build(app) # TODO: add another argument to indicate progIndex
        self.cur_prog.build(app)

    def hide(self, app):
        assert isinstance(app, AppData)
        self.cur_prog.onhide(app)
        self.prev_sel = self.cur_sel
        self.cur_prog = None
        super(PartCtlScreen, self).hide(app)

    def getHelp(self, app):
        super(PartCtlScreen, self).getHelp(app)