from .CustomWidgets import *

from kivy.clock import Clock


def ScrollAllower(inst, val):
    del val
    # noinspection PyProtectedMember
    Clock.schedule_once(lambda dt=None: Clock.unschedule(inst._change_touch_mode), 0)


szYpx = 48


def convProgLstItem(theApp, row_index, prog):
    action = Bind(theApp.goProgPart, row_index)
    lstDisp = prog.getDispCols()
    clsDicts = []
    for disp, colW in zip(lstDisp, theApp.lstColW[:len(lstDisp)]):
        clsDicts.append({
            "cls": LstItemBtnLabel, "kwargs": {
                "size_hint_x": colW, "text": disp,
                "is_representing_cls": True, "on_release": action}})
    clsDicts.append({
        "cls": SnappedListItemButton, "kwargs": {
            "size_hint_x": theApp.lstColW[-1], "text": "Remove",
            "on_release": Bind(theApp.goDelPart, row_index)}})
    clsDicts[1]["kwargs"]["color"] = kXM_GREEN
    leftOver = 1.0
    elems = 0
    for part in clsDicts:
        kwargs = part["kwargs"]
        kwargs["font_size"] = theApp.progStyle.fntSz
        kwargs["deselected_color"] = kWHITE
        szX = kwargs["size_hint_x"]
        if szX is not None:
            leftOver -= szX
        else:
            elems += 1
    if elems > 0:
        leftOver /= elems
        for part in clsDicts:
            kwargs = part["kwargs"]
            if kwargs["size_hint_x"] is None: kwargs["size_hint_x"] = leftOver
    txt = prog.dispName()
    return {"text": txt, "size_hint_y": None, "height": szYpx, "cls_dicts": clsDicts}


def convProgLstItem1(theApp, row_index, prog):
    action = Bind(theApp.goProgPart, row_index)
    lstDisp = prog.getDispCols()
    clsDicts = []
    colors = (kXM_LIST_BG[row_index % 2], k5_GREY)
    for disp, colW in zip(lstDisp, theApp.lstColW[:len(lstDisp)]):
        clsDicts.append({
            "cls": Label, "kwargs": {
                "color": kBLACK,
                "size_hint_x": colW, "text": disp}})
    clsDicts.append({
        "cls": XMButton, "id": "remove_btn", "kwargs": {
            # "background_normal_color": kStrRGB("FF7F7F"),
            "background_normal_color": k7F_GREY,
            # "background_down_color": kStrRGB("CF4F4F"),
            "background_down_color": k4F_GREY,
            "background_normal": "",
            "background_down": "",
            "size_hint_x": theApp.lstColW[-1], "text": "Remove",
            "on_release": Bind(theApp.goDelPart, row_index)}})
    # clsDicts[1]["kwargs"]["color"] = kXM_GREEN1
    clsDicts[1]["kwargs"]["color"] = kXM_RED
    clsDicts[1]["id"] = "XM_name"
    leftOver = 1.0
    elems = 0
    for part in clsDicts:
        kwargs = part["kwargs"]
        kwargs["font_size"] = theApp.progStyle.fntSz
        szX = kwargs["size_hint_x"]
        if szX is not None:
            leftOver -= szX
        else:
            elems += 1
    if elems > 0:
        leftOver /= elems
        for part in clsDicts:
            kwargs = part["kwargs"]
            if kwargs["size_hint_x"] is None: kwargs["size_hint_x"] = leftOver
    # txt = prog.dispName()

    def onState(obj, val):
        assert isinstance(obj, XMHomeItem)
        val = fromState[val]
        obj.background_color = obj.selected_color = obj.deselected_color = colors[val]
        xmName = obj.get_widget("XM_name")
        rmBtn = obj.get_widget("remove_btn")
        color = kXM_GREEN1 if val else kBLACK
        for wid in obj.children:
            if wid is rmBtn or (not val and wid is xmName): continue
            wid.color = color
        if not val: xmName.color = kXM_RED

    return {
        "size_hint_y": None, "height": szYpx, "cls_dicts": clsDicts,
        "deselected_color": colors[0], "on_release": action,
        "selected_color": k4F_GREY, "on_state": onState}


def convProgLstItem2(theApp, row_index, prog):
    action = Bind(theApp.goProgPart, row_index)
    lstDisp = prog.getDispCols()
    clsDicts = []
    colors = (kXM_LIST_BG[row_index % 2], k5_GREY)
    for disp, colW in zip(lstDisp, theApp.lstColW[:len(lstDisp)]):
        clsDicts.append({
            "cls": Label, "kwargs": {
                "color": kBLACK,
                "size_hint_x": colW, "text": disp}})
    clsDicts.append({
        "cls": XMButton, "id": "remove_btn", "kwargs": {
            # "background_normal_color": kStrRGB("FF7F7F"),
            "background_normal_color": k7F_GREY,
            # "background_down_color": kStrRGB("CF4F4F"),
            "background_down_color": k4F_GREY,
            "background_normal": "",
            "background_down": "",
            "size_hint_x": theApp.lstColW[-1], "text": "Remove",
            "on_release": Bind(theApp.goDelPart, row_index)}})
    # clsDicts[1]["kwargs"]["color"] = kXM_GREEN1
    clsDicts[1]["kwargs"]["color"] = kXM_RED
    clsDicts[1]["id"] = "XM_name"
    leftOver = 1.0
    elems = 0
    for part in clsDicts:
        kwargs = part["kwargs"]
        kwargs["font_size"] = theApp.progStyle.fntSz
        szX = kwargs["size_hint_x"]
        if szX is not None:
            leftOver -= szX
        else:
            elems += 1
    if elems > 0:
        leftOver /= elems
        for part in clsDicts:
            kwargs = part["kwargs"]
            if kwargs["size_hint_x"] is None: kwargs["size_hint_x"] = leftOver
    # txt = prog.dispName()

    '''def onState(obj, val):
        assert isinstance(obj, XMHomeItem)
        val = fromState[val]
        obj.background_color = obj.selected_color = obj.deselected_color = colors[val]
        xmName = obj.get_widget("XM_name")
        rmBtn = obj.get_widget("remove_btn")
        color = kXM_GREEN1 if val else kBLACK
        for wid in obj.children:
            if wid is rmBtn or (not val and wid is xmName): continue
            wid.color = color
        if not val: xmName.color = kXM_RED'''
    selected_normal = selected_down = deselected_down = {
        "background_color": colors[1],
        "selected_color": colors[1],
        "deselected_color": colors[1],
        "#": {
            "color": kXM_GREEN1},
        "#remove_btn": {
            "background_normal_color": k7F_GREY,
            "background_down_color": k4F_GREY,
            "normal_color": kWHITE,
            "down_color": kWHITE,
            "color": kWHITE}
    }
    deselected_normal = {
        "background_color": colors[0],
        "selected_color": colors[0],
        "deselected_color": colors[0],
        "#": {
            "color": kBLACK},
        "#XM_name": {
            "color": kXM_RED},
        "#remove_btn": {
            "background_normal_color": k7F_GREY,
            "background_down_color": k4F_GREY,
            "normal_color": kWHITE,
            "down_color": kWHITE,
            "color": kWHITE}
    }

    return {
        "size_hint_y": None, "height": szYpx,
        "cls_dicts": clsDicts, "on_release": action,
        "selected_normal_style":selected_normal,
        "selected_down_style":selected_down,
        "deselected_normal_style":deselected_normal,
        "deselected_down_style":deselected_down}


def on_releaseAsync(func, obj):
    obj.state = "down"
    Clock.schedule_once(lambda dt=None: func(obj))


def mkOnReleaseAsync(func):
    return Bind(on_releaseAsync, func)


def partLstCatConv(theApp, cat, row_index, k):
    del row_index
    fntSz = theApp.progStyle.fntSz
    part = cat.parts[k]
    on_release = mkOnReleaseAsync(Bind(theApp.mkProg, part))
    clsDicts = [{"cls": ListItemLabel, "kwargs": {
        "size_hint_y": None, "height": szYpx, "font_size": fntSz,
        "deselected_color": kWHITE,
        "is_representing_cls": True, "size_hint_x": theApp.lstColNewW[x]}}
                for x in xrange(4)]
    clsDicts[0]["kwargs"]["text"] = part.XM_partName
    clsDicts[0]["kwargs"]["color"] = kXM_GREEN
    clsDicts[1]["kwargs"]["text"] = part.mfgName
    clsDicts[2]["kwargs"]["text"] = part.mfgPartName
    clsDicts[3]["kwargs"]["text"] = part.interface
    return {"text": "", "size_hint_y": None, "height": szYpx, "cls_dicts": clsDicts,
            "background_color": kWHITE, "on_release": on_release}


def partLstCatConv1(theApp, cat, row_index, k):
    fntSz = theApp.progStyle.fntSz
    part = cat.parts[k]
    colors = (kXM_LIST_BG[row_index % 2], k5_GREY)
    on_release = mkOnReleaseAsync(Bind(theApp.mkProg, part))
    clsDicts = [{"cls": Label, "kwargs": {
        "size_hint_y": None, "height": szYpx, "font_size": fntSz,
        "size_hint_x": theApp.lstColNewW[x], "color": kBLACK}}
                for x in xrange(4)]
    clsDicts[0]["kwargs"]["text"] = part.XM_partName
    clsDicts[0]["id"] = "XM_partName"
    clsDicts[1]["kwargs"]["text"] = part.mfgName
    clsDicts[1]["id"] = "mfgName"
    clsDicts[2]["kwargs"]["text"] = part.mfgPartName
    clsDicts[2]["id"] = "mfgPartName"
    clsDicts[3]["kwargs"]["text"] = part.interface
    clsDicts[3]["id"] = "interface"
    clsDicts[0]["kwargs"]["color"] = kXM_RED

    def onState(obj, val):
        val = fromState[val]
        obj.background_color = obj.selected_color = obj.deselected_color = colors[val]
        widgets = map(obj.get_widget, ["XM_partName", "mfgName", "mfgPartName", "interface"])
        color = kXM_GREEN1 if val else kBLACK
        for wid in widgets:
            wid.color = color
        if not val:
            widgets[0].color = kXM_RED

    return {"size_hint_y": None, "height": szYpx, "cls_dicts": clsDicts,
            "deselected_color": colors[0], "on_release": on_release,
            "selected_color": colors[0], "on_state": onState}


def catLstConv(theApp, row_index, cat):
    del row_index
    # colors = (kXM_LIST_BG[row_index % 2], k5_GREY)
    return {
        "text": str(cat), "size_hint_y": None, "height": szYpx,
        "is_representing_cls": True, "font_size": theApp.progStyle.fntSz,
        "on_release": mkOnReleaseAsync(Bind(theApp.goAddNew_PartList, cat))}


def catLstConv1(theApp, row_index, cat):
    colors = (kXM_LIST_BG[row_index % 2], k5_GREY)
    return {
        "text": str(cat), "size_hint_y": None, "height": szYpx, "normal_color": (0, 0, 0, 1),
        "down_color": kXM_GREEN1,
        "is_representing_cls": True, "font_size": theApp.progStyle.fntSz,
        "on_release": mkOnReleaseAsync(Bind(theApp.goAddNew_PartList, cat)),
        "background_down": "", "background_normal_color": colors[0],
        "background_normal": "", "background_down_color": colors[1]}


def convLstOptsRadio(group, row_index, opt):
    del row_index
    return {
        "size_hint_y": None, "height": 30,
        "selected_color": (0, 0, 0, 0),
        "cls_dicts": [
            {"cls": ListItemCheckBox,
             "kwargs": {
                 "group": group, "size_hint_x": None,
                 "width": 30, "allow_no_selection": False}},
            {"cls": Bind(sizedCls, ListItemClkLabel),
             "kwargs": {"text": opt[0], "pos_hint": {'x': 0.0, "top": .8}}}]}


def convLstOpts(row_index, opt):
    colors0 = (kXM_LIST_BG[row_index % 2], k3F_F_GREEN)
    colors1 = (k5_GREY, k3F_F_RED)
    color0, color1 = ((0, 0, 0, 1), kXM_GREEN1)
    return dict(
        text=opt[0], size_hint_y=None, height=30, background_normal="",
        background_down="",
        background_disabled_down="",
        background_disabled_normal="",
        deselected_attrs=dict(
            normal_color=color0,
            down_color=color0,
            disabled_color=color0[:3] + (0.5,),
            background_normal_color=colors0[0],
            background_down_color=colors0[1]),
        selected_attrs=dict(
            normal_color=color1,
            down_color=color1,
            disabled_color=color1[:3] + (0.5,),
            background_normal_color=colors1[0],
            background_down_color=colors1[1]),
        color=(0, 0, 0, 1), selected_color=(0, 0, 0, 0),
        deselected_color=(0, 0, 0, 0))


def boundCls(cls, dctBind, **kwargs):
    rtn = cls(**kwargs)
    rtn.bind(**dctBind)
    return rtn