from ..LibBaseProgPart import *

log = None

@initFunc(__name__.replace("ProgramIt.", ""))
def init(progLog):
    # noinspection PyGlobalUndefined
    global log
    log = progLog
def getKeysTxtData(txtData):
    if txtData[1] == "lst":
        return "sel" + txtData[0], "in" + txtData[0]
    elif txtData[1] == "num":
        return "num" + txtData[0], "txt" + txtData[0]
    elif txtData[1][:3] == "chk":
        return txtData[0:2]
    else: return "NONE", "NONE"
def getPLL_Data(obj):
    """
    :param BaseProgADF_PLL obj:
    :rtype: ValuePack
    """
    rtn = ValuePack()
    rtn.data = {}
    rtn.defRegs = []
    rtn.regDatas = {}
    rtn.defData = {}
    for txtData in obj.lstTxtDatas:
        datName, txtName = getKeysTxtData(txtData)
        rtn.data[datName] = obj.data[datName]
        if datName not in obj.regDatas:
            rtn.defData[datName] = obj.data[datName]
        else: rtn.regDatas[datName] = list(obj.regDatas[datName])
    for reg in obj.regs:
        if reg.isDual:
            orig = reg.curReg
            for c in xrange(reg.numDual):
                reg.curReg = c
                rtn.defRegs.append(reg.word.num)
            reg.curReg = orig
        else: rtn.defRegs.append(reg.word.num)
    return rtn
def fltLs(lst,inv=1):
    if inv: return lambda x: x not in lst
    else: return lambda x: x in lst
def fltrFuncName(remLst, cls):
    if not issubclass(cls, BaseProgADF_PLL):
        nm = cls.__name__
        log.Log("Possible misuse of function fltrFuncName on class:%s"%nm, 2)
    kRemLst = fltLs(remLst)
    lst0 = filter(lambda x: x[0] in remLst, cls.lstTxtDatas)
    remDatLst = map(lambda x: getKeysTxtData(x)[0], lst0)
    lstTxtDatas = filter(lambda x: x[0] not in remLst, cls.lstTxtDatas)
    lstEnterSets = filter(lambda x: x[1] not in remLst, cls.lstEnterSets)
    titles = Filter(cls.titles, kRemLst)
    useFuncs = Filter(cls.useFuncs, kRemLst)
    regDatas = Filter(cls.regDatas, fltLs(remDatLst))
    return lstTxtDatas, lstEnterSets, titles, useFuncs, regDatas
def fltrFuncName1(remLst, cls, whitelist = False):
    if not issubclass(cls, BaseProgADF_PLL):
        nm = cls.__name__
        log.Log("Possible misuse of function fltrFuncName1 on class:%s"%nm, 2)
    kRemLst = fltLs(remLst, not whitelist)
    lst0 = filter(lambda x: (x[0] in remLst) ^ whitelist, cls.lstTxtDatas)
    remDatLst = map(lambda x: getKeysTxtData(x)[0], lst0)
    lstTxtDatas = filter(
        lambda x: (x[0] not in remLst) ^ whitelist, cls.lstTxtDatas)
    lstEnterSets = filter(
        lambda x: (x[1] not in remLst) ^ whitelist, cls.lstEnterSets)
    titles = Filter(cls.titles, kRemLst)
    useFuncs = Filter(cls.useFuncs, kRemLst)
    regDatas = Filter(cls.regDatas, fltLs(remDatLst))
    return lstTxtDatas, lstEnterSets, titles, useFuncs, regDatas
def fltrDefRegs(cls, wordSize, chgDefRegs):
    wordMask = (1 << wordSize) - 1
    regDct = {}
    for val in cls.defRegs:
        regDct[val&wordMask] = val
    for val in chgDefRegs:
        regDct[val&wordMask] = val
    return map(regDct.__getitem__, sorted(regDct))
def chgEnterSet(lstEnterSets, enterSet, oldType = None):
    if oldType is not None:
        for c in xrange(len(lstEnterSets)):
            if lstEnterSets[c][:2] == (oldType, enterSet[1]):
                lstEnterSets[c] = enterSet
                break
        return
    for c in xrange(len(lstEnterSets)):
        if lstEnterSets[c][:2] == enterSet[:2]:
            lstEnterSets[c] = enterSet
            break
def fmtRegId(regId):
    if isinstance(regId, tuple): return "%u_%u" % regId
    else: return str(regId)
def getCfgMdLstFunc(cls):
    for k in cls.lstBindFuncs:
        v = cls.lstBindFuncs[k]
        if v == ("addSmallLstLine", "gridCfgMd"): return k
    cls.lstBindFuncs["addCfgMdLst"] = ("addSmallLstLine", "gridCfgMd")
    return "addCfgMdLst"
def getLstBindFunc(cls, matchTuple, defK):
    for k in cls.lstBindFuncs:
        v = cls.lstBindFuncs[k]
        if v == matchTuple: return k
    cls.lstBindFuncs[defK] = matchTuple
    return defK
def getFuncIdLst(cls, matchTuple, defK, Type="lst"):
    lstFuncs = "lst%sFuncs" % Type.title()
    fnName = getLstBindFunc(cls, matchTuple, defK)
    funcId = len(cls.lstLstFuncs)
    try: funcId = getattr(cls, lstFuncs).index(fnName)
    except ValueError: setattr(cls, lstFuncs, getattr(cls, lstFuncs) + [fnName])
    return funcId
def getFuncIdCfgMdLst(cls):
    fnName = getCfgMdLstFunc(cls)
    funcId = len(cls.lstLstFuncs)
    try: funcId = cls.lstLstFuncs.index(fnName)
    except ValueError: cls.lstLstFuncs = cls.lstLstFuncs + [fnName]
    return funcId
#each elem of lstUpd is of the same form as updTxtAttr
#  except with an insertion index prepended to it
def updTxtDataIfExist(cls, lstUpd):
    if not hasattr(cls, "lstTxtDatas"): return
    cls.lstTxtDatas = list(cls.lstTxtDatas)
    c = lstUpd[0]
    txtAttr = lstUpd[1:]
    for v0 in cls.lstTxtDatas:
        if v0[:2] == txtAttr[:2]: break
    else: cls.lstTxtDatas.insert(c, txtAttr)

#each elem of lstUpd is of the same form as updTxtAttr
#  except with an insertion index prepended to it
#this function, unlike updTxtDataIfExist will REPLACE existing txtData entries without reinsertion
#  and takes the txtData list directly
def updTxtDatas(lstTxtDatas, lstUpd):
    for v in lstUpd:
        c = v[0]
        if c == -1: c = len(lstTxtDatas)
        txtAttr = v[1:]
        for c0 in xrange(len(lstTxtDatas)):
            v0 = lstTxtDatas[c0]
            if v0[:2] == txtAttr[:2]:
                lstTxtDatas[c0] = txtAttr
                break
        else:
            lstTxtDatas.insert(c, txtAttr)
class PLL_Ramped(object):
    nRamps = 2
    rampAttrs = None
    RMP_ATTRS = [
        "Clk2Div%u", "FDevStep%u",
        "DevVal%u", "TotRamp%u",
        "DevOff%u", "TStep%u",
        "Step%u", "TRamp%u"]
    @classmethod
    def initCls(cls, numBuses):
        assert issubclass(cls, BaseProgADF_PLL)
        if cls.rampAttrs is None:
            cls.rampAttrs = [
                [RmpAttr%(x+1) for RmpAttr in cls.RMP_ATTRS]
                for x in xrange(cls.nRamps)]
        assert isinstance(cls.rampAttrs, list)
        if hasattr(cls, "lstEnterSets"):
            cls.lstEnterSets = list(cls.lstEnterSets)
            cls.lstEnterSets.extend([
                x for x in xrange(len(cls.RMP_ATTRS)*len(cls.rampAttrs))])
            cls.lstEnterSets.append(("lstInf", "AutoR", "updAutoR"))
        updDctIfExist(cls, "titles", {"AutoR": ("Autoset R",)})
        defData = reduce(
            list.__add__, [RmpAttrs[1::2] for RmpAttrs in cls.rampAttrs])
        updDctIfExist(cls, "defData", {k:0. for k in defData})
        if getattr(cls, "AutoAdd_PFDCfg", False):
            assert hasattr(cls, "lstLstFuncs")
            assert hasattr(cls, "lstBindFuncs")
            funcId = getFuncIdCfgMdLst(cls)
            updDctIfExist(cls, "useFuncs", {"AutoR": (funcId,)})
            updTxtDataIfExist(cls, (0, "AutoR", "lst"))
        super(PLL_Ramped, cls).initCls(numBuses)
    def showRampTabs(self, lstShow): pass
    def updRampN(self, n): pass
    def updRampAll(self): pass
class PLL_CalNVal(object):
    AutoAdd_NValCfg = True
    @classmethod
    def initCls(cls, numBuses):
        if hasattr(cls, "lstEnterSets"):
            cls.lstEnterSets = list(cls.lstEnterSets)
            cls.lstEnterSets.append(("lstInf", "AutoN", "updAutoN"))
        updDctIfExist(cls, "titles", {"AutoN": ("Autoset N From",)})
        updDctIfExist(cls, "defData", {"selAutoN":0})
        if cls.AutoAdd_NValCfg:
            funcId = getFuncIdCfgMdLst(cls)
            updDctIfExist(cls, "useFuncs", {"AutoN": (funcId,)})
            updTxtDataIfExist(cls, (0, "AutoN", "lst"))
        super(PLL_CalNVal, cls).initCls(numBuses)
    def updAutoNOrder(self):
        """
        :param BaseProgADF_PLL|PLL_Cal_NVal self:
        """
        assert self.data.selAutoN in [0, 1, 2]
        if self.data.selAutoN == 2:
            self.updFracInt()
            self.updNVal()
        elif self.data.selAutoN == 1:
            self.updNVal()
            self.updFracInt()
        elif self.data.selAutoN == 0:
            self.updNVal()
            self.updFracInt()
        self.updOutFreq()
    def disableFracInt(self, disabled):
        Str = "WARNING: default disableFracInt function called. CLASS %s"
        log.Log(Str % self.__class__.__name__, 3)
    def updAutoN(self):
        """
        :param BaseProgADF_PLL|PLL_Cal_NVal self:
        """
        sel = self.data.selAutoN
        self.txtRF_Out.disabled = sel != 0
        self.txtNVal.disabled = sel != 1
        self.disableFracInt(sel != 2)
    #translates to and from internal frequency
    def getIntFreq(self, freq): return freq
    def getExtFreq(self, freq): return freq
    def updOutFreq(self):
        """
        :param BaseProgADF_PLL|PLL_Cal_NVal self:
        """
        pfdFreq = self.data.numPFD_Freq * 10 ** self.pfdFreqShift
        nType = self.getAttrEnterSet1("NVal", "num")[0]
        nType = {"int": float, "float": float, "Decimal": Decimal}[nType]
        pfdFreq = nType(pfdFreq)
        self.data.numOutFreq = self.getExtFreq(self.data.numNVal * pfdFreq)
        self.loadTxtAttr(*self.kTxtData.OutFreq)
class PLL_CalModSpace(object):
    AutoAdd_ModCfg = True
    AutoAdd_ModIndex = 0
    @classmethod
    def initCls(cls, numBuses):
        if hasattr(cls, "lstEnterSets"):
            cls.lstEnterSets = list(cls.lstEnterSets)
            cls.lstEnterSets.append(("lstInf", "AutoMod", "updAutoMod"))
        updDctIfExist(cls, "titles", {"AutoMod": ("Autoset Modulus",)})
        updDctIfExist(cls, "defData", {"selAutoMod":1})
        if cls.AutoAdd_ModCfg:
            funcId = getFuncIdCfgMdLst(cls)
            updDctIfExist(cls, "useFuncs", {"AutoMod": (funcId,)})
            updTxtDataIfExist(cls, (cls.AutoAdd_ModIndex, "AutoMod", "lst"))
        super(PLL_CalModSpace, cls).initCls(numBuses)
    def disableMod(self, disabled):
        Str = "WARNING: default disableFracInt function called. CLASS %s"
        log.Log(Str % self.__class__.__name__, 3)
    def updAutoMod(self):
        """
        :param BaseProgADF_PLL&PLL_CalModSpace self:
        """
        self.txtUsrSpaceCh.disabled = not self.data.selAutoMod
        self.disableMod(self.data.selAutoMod)
    def updModSpace(self): pass
class PLL_MainMod(PLL_CalModSpace):
    lstAutoModOpts = map(isReserv,[
        "Modulus Value", "Desired Channel Spacing"])
    lstAutoModInfs = [
        "Modulus value is manually entered.",
        "Modulus value is calculated based on desired channel spacing."]
    def updModSpace(self):
        """
        :param BaseProgADF_PLL|PLL_MainMod self:
        """
        pfdFreq = self.data.numPFD_Freq * 1e3 * 10 ** self.pfdFreqShift
        if self.data.selAutoMod:
            mRange = self.getAttrEnterSet("ModVal", "int")[2]
            if not isinstance(mRange, BaseRange): mRange = NumRange(*mRange)
            minMax = mRange.getMinMax(self)
            val = int(pfdFreq / self.data.numUsrSpaceCh + .5)
            if minMax is not None: val = restrict(val, minMax[0], minMax[1])
            self.data.numModVal = val
            self.loadTxtAttr(*self.kTxtData.ModVal)
        self.data.numSpaceCh = pfdFreq / self.data.numModVal
        self.loadTxtAttr(*self.kTxtData.SpaceCh)
        self.updRegAttrDat(["numModVal"])
        if isinstance(self, PLL_CalNVal): self.updAutoNOrder()
    def disableMod(self, disabled):
        """
        :param bool disabled:
        """
        self.txtModVal.disabled = disabled
class PLL_AuxMod(PLL_CalModSpace):
    lstAutoModOpts = map(isReserv,[
        "Auxiliary Modulus Value", "Desired Frequency Step"])
    lstAutoModInfs = [
        "Auxiliary modulus value is manually entered",
        " ".join([
            "Auxiliary modulus value is calculated based on",
            "desired frequency step."])]
    def updModSpace(self):
        """
        :param BaseProgADF_PLL|PLL_AuxMod self:
        """
        pfdFreq = self.data.numPFD_Freq * 1e3 * 10 ** self.pfdFreqShift
        if self.data.selAutoMod:
            mRange = self.getAttrEnterSet("Mod2Val", "int")[2]
            if not isinstance(mRange, BaseRange): mRange = NumRange(*mRange)
            minMax = mRange.getMinMax(self)
            val = int(sFracBetter(pfdFreq, self.data.numUsrSpaceCh)[0])
            if minMax is not None: val = restrict(val, minMax[0], minMax[1])
            self.data.numMod2Val = val
            self.loadTxtAttr(*self.kTxtData.Mod2Val)
        self.data.numSpaceCh = pfdFreq / (
            self.data.numMod1Val * self.data.numMod2Val)
        self.loadTxtAttr(*self.kTxtData.SpaceCh)
        self.updRegAttrDat(["numMod2Val"])
        if isinstance(self, PLL_CalNVal): self.updAutoNOrder()
    def disableMod(self, disabled):
        """
        :param BaseProgADF_PLL|PLL_AuxMod self:
        """
        self.txtMod2Val.disabled = disabled
class DualPLL_Single_MainMod(PLL_CalModSpace):
    AutoAdd_ModIndex = 3
    lstAutoModOpts = list(PLL_MainMod.lstAutoModOpts)
    lstAutoModInfs = list(PLL_MainMod.lstAutoModInfs)
    @classmethod
    def initCls(cls, numBuses):
        super(DualPLL_Single_MainMod, cls).initCls(numBuses)
        cls.titles["AutoMod"] = ("Autoset RF Mod",)
    def updModSpace(self):
        """
        :param BaseProgADF_PLL|DualPLL_Single_MainMod self:
        """
        pfdFreq = self.data.numPFD_Freq2 * 1e3 * 10 ** self.pfdFreqShift
        if self.data.selAutoMod:
            mRange = self.getAttrEnterSet("ModVal", "int")[2]
            if not isinstance(mRange, BaseRange): mRange = NumRange(*mRange)
            minMax = mRange.getMinMax(self)
            val = int(pfdFreq / self.data.numUsrSpaceCh + .5)
            if minMax is not None: val = restrict(val, minMax[0], minMax[1])
            self.data.numModVal = val
            self.loadTxtAttr(*self.kTxtData.ModVal)
        self.data.numSpaceCh = pfdFreq / self.data.numModVal
        self.loadTxtAttr(*self.kTxtData.SpaceCh)
        self.updRegAttrDat(["numModVal"])
        #always update the 2nd pll part(of the 2 pll parts)
        #  because Mods, Fracs and Ints are only on RF
        if isinstance(self, DualPLL_CalNVal): self.updAutoNOrder(1)
    def disableMod(self, disabled):
        """
        :param BaseProgADF_PLL|DualPLL_Single_MainMod self:
        :param bool disabled:
        """
        self.txtModVal.disabled = disabled
class DualPLL_CalNVal(object):
    AutoAdd_NValCfg = True
    @classmethod
    def initCls(cls, numBuses):
        if hasattr(cls, "lstEnterSets"):
            cls.lstEnterSets = list(cls.lstEnterSets)
            cls.lstEnterSets.extend([
                ("lstInf", "AutoN1", "updAutoN"),
                ("lstInf", "AutoN2", "updAutoN")])
        updDctIfExist(cls, "titles", {
            "AutoN1": ("Autoset IF N from",), "AutoN2": ("Autoset RF N from",)})
        updDctIfExist(cls, "defData", {"selAutoN1":0,"selAutoN2":0})
        if cls.AutoAdd_NValCfg:
            funcId = getFuncIdCfgMdLst(cls)
            updDctIfExist(cls, "useFuncs", {
                "AutoN1": (funcId,), "AutoN2": (funcId,)})
            updTxtDataIfExist(cls, (0, "AutoN1", "lst"))
            updTxtDataIfExist(cls, (3, "AutoN2", "lst"))
        super(DualPLL_CalNVal, cls).initCls(numBuses)
    def updAutoNOrder(self, pllIndex):
        """
        :param BaseProgADF_PLL|DualPLL_CalNVal self:
        :param int pllIndex:
        """
        selAutoN = self.data["selAutoN%u"%(pllIndex+1)]
        assert selAutoN in [0, 1, 2]
        if selAutoN == 2:
            self.updFracInt(pllIndex)
            self.updNVal(pllIndex)
        elif selAutoN == 1:
            self.updNVal(pllIndex)
            self.updFracInt(pllIndex)
        elif selAutoN == 0:
            self.updNVal(pllIndex)
            self.updFracInt(pllIndex)
        self.updOutFreq(pllIndex)
    def updAutoNOrder1(self): self.updAutoNOrder(0)
    def updAutoNOrder2(self): self.updAutoNOrder(1)
    def disableFracInt(self, pllIndex, disabled):
        Str = "WARNING: default disableFracInt function called. CLASS %s"
        log.Log(Str % self.__class__.__name__, 3)
    def updAutoN(self):
        """
        :param BaseProgADF_PLL&DualPLL_CalNVal self:
        """
        sel0 = self.data.selAutoN1
        sel1 = self.data.selAutoN2
        self.txtRF_Out1.disabled = sel0 != 0
        self.txtNVal1.disabled = sel0 != 1
        self.disableFracInt(0, sel0 != 2)
        self.txtRF_Out2.disabled = sel1 != 0
        self.txtNVal2.disabled = sel1 != 1
        self.disableFracInt(1, sel1 != 2)
    def getIntFreq(self, freq, pllIndex): return freq
    def getExtFreq(self, freq, pllIndex): return freq
    def updOutFreq(self, pllIndex):
        """
        :param BaseProgADF_PLL&DualPLL_CalNVal self:
        """
        si = "%u"%(pllIndex+1)
        nVal = self.data["numNVal"+si]
        pfdFreq = self.data["numPFD_Freq"+si] * 10 ** self.pfdFreqShift
        self.data["numOutFreq"+si] = self.getExtFreq(pfdFreq*nVal,pllIndex)
        self.loadTxtAttr(*self.kTxtData["OutFreq"+si])
class DualPLL_IntAB(DualPLL_CalNVal):
    useAB_Range_NVal = True
    lstAutoN1Opts = map(isReserv,[
        "Desired Frequency", "N Value", "A & B Counters"])
    lstAutoN1Infs = [
        " ".join([
            "The N, A and B Counter values",
            "are calculated from the desired Frequency",
            "and the actual Output frequency is",
            "calculated based on the calculated N value."]),
        " ".join([
            "The N value is entered and",
            "the A and B Counter values",
            "are calculated to match it. The actual",
            "N value is placed in the entry box."]),
        " ".join([
            "The A and B Counter values are manually entered",
            "and the N value and output frequency are calculated."])]
    lstAutoN2Opts = lstAutoN1Opts
    lstAutoN2Infs = lstAutoN1Infs
    def disableFracInt(self, pllIndex, disabled):
        """
        :param BaseProgADF_PLL&DualPLL_IntAB self:
        """
        if pllIndex == 0:
            self.txtBCntr1.disabled = disabled
            self.txtACntr1.disabled = disabled
        elif pllIndex == 1:
            self.txtBCntr2.disabled = disabled
            self.txtACntr2.disabled = disabled
    def getPreSclDiv(self, pllIndex):
        Str = "WARNING: default getPreSclDiv function called. CLASS %s"
        log.Log(Str % self.__class__.__name__, 3)
        return 4
    def updFracInt(self, pllIndex):
        """
        :param BaseProgADF_PLL&DualPLL_IntAB self:
        """
        si = "%u"%(pllIndex+1)
        if self.data["selAutoN"+si] in [1, 0]:
            aRange = self.getAttrEnterSet("ACntr"+si, "int")[2]
            bRange = self.getAttrEnterSet("BCntr"+si, "int")[2]
            aRange, bRange= map(
                lambda x: x if isinstance(x, BaseRange) else NumRange(*x),
                [aRange, bRange])
            b, a = divmod(self.data["numNVal"+si],self.getPreSclDiv(pllIndex))
            minMaxA = aRange.getMinMax(self)
            minMaxB = bRange.getMinMax(self)
            if minMaxA is not None: a = restrict(a, minMaxA[0], minMaxA[1])
            if minMaxB is not None: b = restrict(b, minMaxB[0], minMaxB[1])
            self.data["numACntr"+si] = a
            self.data["numBCntr"+si] = b
            self.loadTxtAttr(*self.kTxtData["ACntr"+si])
            self.loadTxtAttr(*self.kTxtData["BCntr"+si])
        self.updRegAttrDat(["numACntr"+si, "numBCntr"+si])
    def updNVal(self, pllIndex):
        """
        :param BaseProgADF_PLL&DualPLL_IntAB self:
        """
        pMod = self.getPreSclDiv(pllIndex)
        si = "%u" % (pllIndex + 1)
        rfOut = self.data["numRF_Out" + si]
        pfdFreq = self.data["numPFD_Freq" + si] * 10 ** self.pfdFreqShift
        selAutoN = self.data["selAutoN" + si]
        nVal = int(float(self.data["numNVal" + si]) + .5)
        if selAutoN == 0:
            nVal = int(rfOut / pfdFreq + .5)
        elif selAutoN == 2:
            nVal = self.data["numACntr" + si] + self.data["numBCntr" + si] * pMod
        Range = self.getAttrEnterSet("NVal" + si, "int")[2]
        if not isinstance(Range, BaseRange): Range = NumRange(*Range)
        minMax0 = Range.getMinMax(self)
        if self.useAB_Range_NVal:
            aRange = self.getAttrEnterSet("ACntr" + si, "int")[2]
            bRange = self.getAttrEnterSet("BCntr" + si, "int")[2]
            aRange, bRange= map(
                lambda x: x if isinstance(x, BaseRange) else NumRange(*x),
                [aRange, bRange])
            minMaxA = aRange.getMinMax(self)
            minMaxB = bRange.getMinMax(self)
            minMax = None
            if minMax0 is not None or not (minMaxA is None or minMaxB is None):
                if minMax0 is None:
                    minMax = (
                        minMaxA[0] + pMod * minMaxB[0],
                        minMaxA[1] + pMod * minMaxB[1])
                elif minMaxA is None or minMaxB is None:
                    minMax = minMax0
                else:
                    minMax = (
                        max(minMax0[0], minMaxA[0] + pMod * minMaxB[0]),
                        min(minMax0[1], minMaxA[1] + pMod * minMaxB[1]))
            if minMax is not None: nVal = restrict(nVal, minMax[0], minMax[1])
        else:
            if minMax0 is not None: nVal = restrict(nVal, minMax0[0], minMax0[1])
        self.data["numNVal" + si] = nVal
        if selAutoN != 2: self.loadTxtAttr(*self.kTxtData["NVal" + si])
class DualPLL_IntABFrac(DualPLL_CalNVal):
    useAB_Range_NVal1 = True
    lstAutoN1Opts = map(isReserv,[
        "Desired Frequency", "N Value", "A & B Counters"])
    lstAutoN1Infs = [
        " ".join([
            "The N, A and B Counter values",
            "are calculated from the desired Frequency",
            "and the actual Output frequency is",
            "calculated based on the calculated N value."]),
        " ".join([
            "The N value is entered and",
            "the A and B Counter values",
            "are calculated to match it. The actual",
            "N value is placed in the entry box."]),
        " ".join([
            "The A and B Counter values are manually entered",
            "and the N value and output frequency are calculated."])]
    lstAutoN2Opts = map(isReserv,[
        "Desired Frequency", "N Value", "Fraction & Integer"])
    lstAutoN2Infs = [
        " ".join([
            "The N, Fraction and Integer values",
            "are calculated from the desired Frequency",
            "and the actual Output frequency is",
            "calculated based on the N value."]),
        " ".join([
            "The N value is entered and",
            "the Fraction and Integer values",
            "are calculated to match it. The actual",
            "N value is placed in the entry box."]),
        " ".join([
            "The Fraction and Integer values are manually entered",
            "and the N value and output frequency are calculated."])]
    def disableFracInt(self, pllIndex, disabled):
        """
        :param BaseProgADF_PLL&DualPLL_IntABFrac self:
        """
        if pllIndex == 0:
            self.txtBCntr.disabled = disabled
            self.txtACntr.disabled = disabled
        elif pllIndex == 1:
            self.txtIntVal.disabled = disabled
            self.txtFracVal.disabled = disabled
    def getPreSclDiv(self, pllIndex):
        Str = "WARNING: default getPreSclDiv function called. CLASS %s"
        log.Log(Str % self.__class__.__name__, 3)
        return 4
    def updFracInt1(self):
        """
        :param BaseProgADF_PLL&DualPLL_IntABFrac self:
        """
        if self.data.selAutoN1 in [1, 0]:
            aRange = self.getAttrEnterSet("ACntr", "int")[2]
            bRange = self.getAttrEnterSet("BCntr", "int")[2]
            aRange, bRange= map(
                lambda x: x if isinstance(x, BaseRange) else NumRange(*x),
                [aRange, bRange])
            b, a = divmod(self.data.numNVal1,self.getPreSclDiv(0))
            minMaxA = aRange.getMinMax(self)
            minMaxB = bRange.getMinMax(self)
            if minMaxA is not None: a = restrict(a, minMaxA[0], minMaxA[1])
            if minMaxB is not None: b = restrict(b, minMaxB[0], minMaxB[1])
            self.data.numACntr = a
            self.data.numBCntr = b
            self.loadTxtAttr(*self.kTxtData.ACntr)
            self.loadTxtAttr(*self.kTxtData.BCntr)
        self.updRegAttrDat(["numACntr", "numBCntr"])
    def updFracInt2(self):
        """
        :param BaseProgADF_PLL&DualPLL_IntABFrac self:
        """
        if self.data.selAutoN2 in [1, 0]:
            mod = self.data.numModVal
            Int, frac = divmod(int(self.data.numNVal2 * mod + .5), mod)
            iRange = self.getAttrEnterSet("IntVal", "int")[2]
            fRange = self.getAttrEnterSet("FracVal", "int")[2]
            iRange, fRange= map(
                lambda x: x if isinstance(x, BaseRange) else NumRange(*x),
                [iRange, fRange])
            minMaxI = iRange.getMinMax(self)
            minMaxF = fRange.getMinMax(self)
            if minMaxI is not None: Int = restrict(Int, minMaxI[0], minMaxI[1])
            if minMaxF is not None: frac = restrict(frac, minMaxF[0], minMaxF[1])
            # preInt = int(Int)
            # Int = restrict(int(Int), iRange.Min, iRange.Max)
            # if preInt > iRange.Max: frac += (preInt - Int) * mod
            # frac = int(restrict(frac, fRange.Min, min(fRange.Max, mod)))
            if frac > mod: frac = mod
            self.data.numIntVal = Int
            self.data.numFracVal = frac
            self.loadTxtAttr(*self.kTxtData.IntVal)
            self.loadTxtAttr(*self.kTxtData.FracVal)
        self.updRegAttrDat(["numIntVal", "numFracVal"])
    def updFracInt(self, pllIndex):
        """
        :param BaseProgADF_PLL&DualPLL_IntABFrac self:
        """
        [self.updFracInt1, self.updFracInt2][pllIndex]()
    def updNVal1(self):
        """
        :param BaseProgADF_PLL&DualPLL_IntABFrac self:
        """
        pMod = self.getPreSclDiv(0)
        nVal = int(self.data.numNVal1 + .5)
        if self.data.selAutoN1 == 0:
            pfdFreq = self.data.numPFD_Freq1 * 10 ** self.pfdFreqShift
            nVal = int(self.getIntFreq(self.data.numRF_Out1, 0) / pfdFreq + .5)
        elif self.data.selAutoN1 == 2:
            nVal = (self.data.numACntr + self.data.numBCntr*pMod)
        Range = self.getAttrEnterSet("NVal1", "int")[2]
        if not isinstance(Range, BaseRange): Range = NumRange(*Range)
        minMax0 = Range.getMinMax(self)
        if self.useAB_Range_NVal1:
            aRange = self.getAttrEnterSet("ACntr", "int")[2]
            bRange = self.getAttrEnterSet("BCntr", "int")[2]
            aRange, bRange= map(
                lambda x: x if isinstance(x, BaseRange) else NumRange(*x),
                [aRange, bRange])
            minMaxA = aRange.getMinMax(self)
            minMaxB = bRange.getMinMax(self)
            minMax = None
            if minMax0 is not None or not (minMaxA is None or minMaxB is None):
                if minMax0 is None:
                    minMax = (
                        minMaxA[0] + pMod * minMaxB[0],
                        minMaxA[1] + pMod * minMaxB[1])
                elif minMaxA is None or minMaxB is None:
                    minMax = minMax0
                else:
                    minMax = (
                        max(minMax0[0], minMaxA[0] + pMod * minMaxB[0]),
                        min(minMax0[1], minMaxA[1] + pMod * minMaxB[1]))
            if minMax is not None: nVal = restrict(nVal, minMax[0], minMax[1])
            self.data.numNVal1 = restrict(nVal, minMax[0], minMax[1])
        else:
            if minMax0 is not None:
                self.data.numNVal1 = restrict(nVal, minMax0[0], minMax0[1])
        self.loadTxtAttr(*self.kTxtData.NVal1)
    def updNVal2(self):
        """
        :param BaseProgADF_PLL&DualPLL_IntABFrac self:
        """
        mod = float(self.data.numModVal)
        nVal = self.data.numNVal2
        if self.data.selAutoN2 == 0:
            pfdFreq = self.data.numPFD_Freq2 * 10 ** self.pfdFreqShift
            nVal = self.getIntFreq(self.data.numRF_Out2, 1) / pfdFreq
        elif self.data.selAutoN2 == 2:
            nVal = self.data.numIntVal + self.data.numFracVal / mod
        self.data.numNVal2 = int(nVal * mod + .5) / mod
        Range = self.getAttrEnterSet("NVal2", "float")[2]
        if not isinstance(Range, BaseRange): Range = NumRange(*Range)
        if self.data.selAutoN2 != 2:
            minMax = Range.getMinMax(self)
            if minMax is not None:
                self.data.numNVal2 = restrict(self.data.numNVal2, minMax[0], minMax[1])
        self.loadTxtAttr(*self.kTxtData.NVal2)
    def updNVal(self, pllIndex):
        """
        :param BaseProgADF_PLL&DualPLL_IntABFrac self:
        """
        [self.updNVal1, self.updNVal2][pllIndex]()
class PLL_CalPFD_Freq(object):
    AutoAdd_PFDCfg = True
    lstAutoROpts = map(isReserv,[
        "R Counter", "Desired PFD Frequency"])
    lstAutoRInfs = [
        "R counter is manually entered.",
        "R counter is calculated from desired PFD frequency."]
    pfdFreqShift = 0
    @classmethod
    def initCls(cls, numBuses):
        if hasattr(cls, "lstEnterSets"):
            cls.lstEnterSets = list(cls.lstEnterSets)
            cls.lstEnterSets.append(("lstInf", "AutoR", "updAutoR"))
        updDctIfExist(cls, "titles", {"AutoR": ("Autoset R",)})
        updDctIfExist(cls, "defData", {"selAutoR":1})
        if cls.AutoAdd_PFDCfg:
            funcId = getFuncIdCfgMdLst(cls)
            updDctIfExist(cls, "useFuncs", {"AutoR": (funcId,)})
            updTxtDataIfExist(cls, (0, "AutoR", "lst"))
        super(PLL_CalPFD_Freq, cls).initCls(numBuses)
    def updAutoR(self):
        """
        :param BaseProgADF_PLL&PLL_CalPFD_Freq self:
        """
        self.txtR_Count.disabled = self.data.selAutoR
        self.txtUsrPFD_Freq.disabled = not self.data.selAutoR
    def preDivR_Freq(self, rFreq):
        return rFreq
    def updPFD_Freq(self):
        """
        :param BaseProgADF_PLL|PLL_CalPFD_Freq self:
        """
        rFreq = self.preDivR_Freq(self.data.numR_Freq)
        if self.data.selAutoR:
            theRange = self.getAttrEnterSet("R_Count", "int")[2]
            if not isinstance(theRange, BaseRange): theRange = NumRange(*theRange)
            minMax = theRange.getMinMax(self)
            pfdFreq = self.data.numUsrPFD_Freq * 10 ** self.pfdFreqShift
            val = int(rFreq / pfdFreq + .5)
            if minMax is not None: val = restrict(val, minMax[0], minMax[1])
            self.data.numR_Count = val
            self.loadTxtAttr(*self.kTxtData.R_Count)
        self.data.numPFD_Freq = (rFreq / self.data.numR_Count) / 10 ** self.pfdFreqShift
        self.loadTxtAttr(*self.kTxtData.PFD_Freq)
        self.updRegAttrDat(["numR_Count"])
        if isinstance(self, PLL_CalModSpace): self.updModSpace()
        elif isinstance(self, PLL_CalNVal): self.updAutoNOrder()
class PLL_CalPFD_Freq0(object):
    AutoAdd_PFDCfg = True
    lstAutoROpts = map(isReserv, [
        "R Counter", "Desired PFD Frequency"])
    lstAutoRInfs = [
        "R counter is manually selected.",
        "R counter is calculated from desired PFD frequency."]
    pfdFreqShift = 0

    @classmethod
    def initCls(cls, numBuses):
        if hasattr(cls, "lstEnterSets"):
            cls.lstEnterSets = list(cls.lstEnterSets)
            cls.lstEnterSets.append(("lstInf", "AutoR", "updAutoR"))
        updDctIfExist(cls, "titles", {"AutoR": ("Autoset R",)})
        updDctIfExist(cls, "defData", {"selAutoR":1})
        if cls.AutoAdd_PFDCfg:
            funcId = getFuncIdCfgMdLst(cls)
            updDctIfExist(cls, "useFuncs", {"AutoR": (funcId,)})
            updTxtDataIfExist(cls, (0, "AutoR", "lst"))
        super(PLL_CalPFD_Freq0, cls).initCls(numBuses)
    def updAutoR(self):
        """
        :param BaseProgADF_PLL&PLL_CalPFD_Freq0 self:
        """
        self.inR_Count.disabled = self.data.selAutoR
        self.txtUsrPFD_Freq.disabled = not self.data.selAutoR
    def preDivR_Freq(self, rFreq):
        return rFreq

    def getBestDivIndex(self, rFreq, pfdFreq):
        return 2
    def calcPfdFreq(self, rFreq):
        return 2.0
    def updPFD_Freq(self):
        """
        :param BaseProgADF_PLL&PLL_CalPFD_Freq0 self:
        """
        rFreq = self.preDivR_Freq(self.data.numR_Freq)
        if self.data.selAutoR:
            pfdFreq = self.data.numUsrPFD_Freq * 10 ** self.pfdFreqShift
            self.data.selR_Count = self.getBestDivIndex(rFreq, pfdFreq)
            self.loadTxtAttr(*self.kTxtData.R_Count)
        self.data.numPFD_Freq = self.calcPfdFreq(rFreq) / 10 ** self.pfdFreqShift
        self.loadTxtAttr(*self.kTxtData.PFD_Freq)
        self.updRegAttrDat(["selR_Count"])
        if isinstance(self, PLL_CalModSpace):
            self.updModSpace()
        elif isinstance(self, PLL_CalNVal):
            self.updAutoNOrder()
class PLL_Div2PFD(PLL_CalPFD_Freq):
    def updPFD_Freq(self):
        """
        :param BaseProgADF_PLL&PLL_Div2PFD self:
        """
        super(PLL_Div2PFD, self).updPFD_Freq()
        self.updRegAttrDat(["bRefDiv"])
    def preDivR_Freq(self, rFreq):
        """
        :param BaseProgADF_PLL&PLL_Div2PFD self:
        """
        #if self.data.bRefDbl: rFreq *= 2
        if self.data.bRefDiv: rFreq /= 2
        return rFreq
class PLL_Mul2PFD(PLL_CalPFD_Freq):
    def updPFD_Freq(self):
        """
        :param BaseProgADF_PLL&PLL_Mul2PFD self:
        """
        super(PLL_Mul2PFD, self).updPFD_Freq()
        self.updRegAttrDat(["bRefDbl"])
    def preDivR_Freq(self, rFreq):
        """
        :param BaseProgADF_PLL&PLL_Mul2PFD self:
        """
        if self.data.bRefDbl: rFreq *= 2
        #if self.data.bRefDiv: rFreq /= 2
        return rFreq
class PLL_MulDivPFD(PLL_CalPFD_Freq):
    def updPFD_Freq(self):
        """
        :param BaseProgADF_PLL&PLL_MulDivPFD self:
        """
        super(PLL_MulDivPFD, self).updPFD_Freq()
        self.updRegAttrDat(["bRefDiv", "bRefDbl"])
    def preDivR_Freq(self, rFreq):
        """
        :param BaseProgADF_PLL&PLL_MulDivPFD self:
        """
        if self.data.bRefDbl: rFreq *= 2
        if self.data.bRefDiv: rFreq /= 2
        return rFreq
class DualPLL_CalPFD_Freq(object):
    AutoAdd_PFDCfg = True
    lstAutoR1Opts = list(PLL_CalPFD_Freq.lstAutoROpts)
    lstAutoR1Infs = list(PLL_CalPFD_Freq.lstAutoRInfs)
    lstAutoR2Opts = lstAutoR1Opts
    lstAutoR2Infs = lstAutoR1Infs
    pfdFreqShift = 0
    @classmethod
    def initCls(cls, numBuses):
        if hasattr(cls, "lstEnterSets"):
            cls.lstEnterSets = list(cls.lstEnterSets)
            cls.lstEnterSets.extend([
                ("lstInf", "AutoR1", "updAutoR"),
                ("lstInf", "AutoR2", "updAutoR")])
        updDctIfExist(cls, "titles", {
            "AutoR1": ("Autoset IF R",), "AutoR2": ("Autoset RF R",)})
        updDctIfExist(cls, "defData", {"selAutoR1":1,"selAutoR2":1})
        if cls.AutoAdd_PFDCfg:
            funcId = getFuncIdCfgMdLst(cls)
            updDctIfExist(cls, "useFuncs", {
                "AutoR1": (funcId,), "AutoR2": (funcId,)})
            updTxtDataIfExist(cls, (0, "AutoR1", "lst"))
            updTxtDataIfExist(cls, (3, "AutoR2", "lst"))
        super(DualPLL_CalPFD_Freq, cls).initCls(numBuses)
    def updAutoR(self):
        """
        :param BaseProgADF_PLL&DualPLL_CalPFD_Freq self:
        """
        self.txtR_Count1.disabled = self.data.selAutoR1
        self.txtUsrPFD_Freq1.disabled = not self.data.selAutoR1
        self.txtR_Count2.disabled = self.data.selAutoR2
        self.txtUsrPFD_Freq2.disabled = not self.data.selAutoR2
    def preDivR_Freq1(self, rFreq): return rFreq
    def preDivR_Freq2(self, rFreq): return rFreq
    def updPFD_Freq(self):
        self.updPFD_Freq1()
        self.updPFD_Freq2()
    def updPFD_Freq1(self):
        """
        :param BaseProgADF_PLL&DualPLL_CalPFD_Freq self:
        """
        rFreq = self.preDivR_Freq1(self.data.numR_Freq)
        if self.data.selAutoR1:
            theRange = self.getAttrEnterSet("R_Count1", "int")[2]
            if not isinstance(theRange, BaseRange): theRange = NumRange(*theRange)
            minMax = theRange.getMinMax(self)
            pfdFreq = self.data.numUsrPFD_Freq1 * 10 ** self.pfdFreqShift
            val = int(rFreq/pfdFreq + .5)
            val = restrict(val, minMax[0], minMax[1])
            self.data.numR_Count1 = val
            self.loadTxtAttr(*self.kTxtData.R_Count1)
        self.data.numPFD_Freq1 = rFreq / self.data.numR_Count1 * .1 ** self.pfdFreqShift
        self.loadTxtAttr(*self.kTxtData.PFD_Freq1)
        self.updRegAttrDat(["numR_Count1"])
        """if isinstance(self, DualPLL_CalModSpace): self.updModSpace1()
        elif isinstance(self, DualPLL_CalNVal): self.updAutoNOrder1()"""
        if isinstance(self, DualPLL_CalNVal): self.updAutoNOrder1()
    def updPFD_Freq2(self):
        """
        :param BaseProgADF_PLL&DualPLL_CalPFD_Freq self:
        """
        rFreq = self.preDivR_Freq2(self.data.numR_Freq)
        if self.data.selAutoR2:
            theRange = self.getAttrEnterSet("R_Count2", "int")[2]
            if not isinstance(theRange, BaseRange): theRange = NumRange(*theRange)
            minMax = theRange.getMinMax(self)
            pfdFreq = self.data.numUsrPFD_Freq2 * 10 ** self.pfdFreqShift
            val = int(rFreq / pfdFreq + .5)
            val = restrict(val, minMax[0], minMax[1])
            self.data.numR_Count2 = val
            self.loadTxtAttr(*self.kTxtData.R_Count2)
        self.data.numPFD_Freq2 = rFreq / self.data.numR_Count2 * .1 ** self.pfdFreqShift
        self.loadTxtAttr(*self.kTxtData.PFD_Freq2)
        self.updRegAttrDat(["numR_Count2"])
        """if isinstance(self, DualPLL_CalModSpace): self.updModSpace2()
        elif isinstance(self, DualPLL_CalNVal): self.updAutoNOrder2()"""
        if isinstance(self, DualPLL_CalNVal): self.updAutoNOrder2()
class DualPLL_Mul2PFD(DualPLL_CalPFD_Freq):
    def updPFD_Freq1(self):
        """
        :param BaseProgADF_PLL&DualPLL_Mul2PFD self:
        """
        super(DualPLL_Mul2PFD, self).updPFD_Freq1()
        self.updRegAttrDat(["bRefDbl1"])
    def updPFD_Freq2(self):
        """
        :param BaseProgADF_PLL&DualPLL_Mul2PFD self:
        """
        super(DualPLL_Mul2PFD, self).updPFD_Freq2()
        self.updRegAttrDat(["bRefDbl2"])
    def preDivR_Freq1(self, rFreq):
        """
        :param BaseProgADF_PLL&DualPLL_Mul2PFD self:
        """
        if self.data.bRefDbl1: rFreq *= 2
        return rFreq
    def preDivR_Freq2(self, rFreq):
        """
        :param BaseProgADF_PLL&DualPLL_Mul2PFD self:
        """
        if self.data.bRefDbl2: rFreq *= 2
        return rFreq
class PLL_IntAB(PLL_CalNVal):
    nMul = 1
    useAB_Range_NVal = True
    lstAutoNOpts = map(isReserv,[
        "Desired Frequency", "N Value", "A & B Counters"])
    lstAutoNInfs = [
        " ".join([
            "The N, A and B Counter values",
            "are calculated from the desired Frequency",
            "and the actual Output frequency is",
            "calculated based on the calculated N value."]),
        " ".join([
            "The N value is entered and",
            "the A and B Counter values",
            "are calculated to match it. The actual",
            "N value is placed in the entry box."]),
        " ".join([
            "The A and B Counter values are manually entered",
            "and the N value and output frequency are calculated."])]
    def disableFracInt(self, disabled):
        """
        :param BaseProgADF_PLL&PLL_IntAB self:
        """
        self.txtBCntr.disabled = disabled
        self.txtACntr.disabled = disabled
    def getPreSclDiv(self):
        Str = "WARNING: default getPreSclDiv function called. CLASS %s"
        log.Log(Str % self.__class__.__name__, 3)
        return 4
    def updFracInt(self):
        """
        :param BaseProgADF_PLL&PLL_IntAB self:
        """
        if self.data.selAutoN in [1, 0]:
            aRange = self.getAttrEnterSet("ACntr", "int")[2]
            bRange = self.getAttrEnterSet("BCntr", "int")[2]
            aRange, bRange= map(
                lambda x: x if isinstance(x, BaseRange) else NumRange(*x),
                [aRange, bRange])
            b, a = divmod(
                int(self.data.numNVal/float(self.nMul)+.5),self.getPreSclDiv())
            minMaxA = aRange.getMinMax(self)
            minMaxB = bRange.getMinMax(self)
            if minMaxA is not None: a = restrict(a, minMaxA[0], minMaxA[1])
            if minMaxB is not None: b = restrict(b, minMaxB[0], minMaxB[1])
            self.data.numACntr = a
            self.data.numBCntr = b
            self.loadTxtAttr(*self.kTxtData.ACntr)
            self.loadTxtAttr(*self.kTxtData.BCntr)
        self.updRegAttrDat(["numACntr", "numBCntr"])
    def updNVal(self):
        """
        :param BaseProgADF_PLL&PLL_IntAB self:
        """
        pMod = self.getPreSclDiv()
        nMul = self.nMul
        if self.data.selAutoN == 0:
            pfdFreq = self.data.numPFD_Freq * 10 ** self.pfdFreqShift
            self.data.numNVal = int(
                self.getIntFreq(self.data.numRF_Out)/pfdFreq/nMul+.5)*nMul
        elif self.data.selAutoN == 2:
            nVal = (self.data.numACntr + self.data.numBCntr*pMod)*nMul
            self.data.numNVal = nVal
        self.data.numNVal = int(float(self.data.numNVal)/nMul + .5)*nMul
        Range = self.getAttrEnterSet("NVal", "int")[2]
        if not isinstance(Range, BaseRange): Range = NumRange(*Range)
        minMax0 = Range.getMinMax(self)
        if self.data.selAutoN != 2:
            nVal = self.data.numNVal
            if self.useAB_Range_NVal:
                aRange = self.getAttrEnterSet("ACntr", "int")[2]
                bRange = self.getAttrEnterSet("BCntr", "int")[2]
                aRange, bRange = map(
                    lambda x: x if isinstance(x, BaseRange) else NumRange(*x),
                    [aRange, bRange])
                minMaxA = aRange.getMinMax(self)
                minMaxB = bRange.getMinMax(self)
                minMax = None
                if minMax0 is not None or not (minMaxA is None or minMaxB is None):
                    if minMax0 is None:
                        minMax = (
                            minMaxA[0] + pMod * minMaxB[0],
                            minMaxA[1] + pMod * minMaxB[1])
                    elif minMaxA is None or minMaxB is None:
                        minMax = minMax0
                    else:
                        minMax = (
                            max(minMax0[0], minMaxA[0] + pMod * minMaxB[0]),
                            min(minMax0[1], minMaxA[1] + pMod * minMaxB[1]))
                if minMax is not None: nVal = restrict(nVal, minMax[0], minMax[1])
                self.data.numNVal = restrict(nVal, minMax[0], minMax[1])
            else:
                if minMax0 is not None:
                    self.data.numNVal = restrict(nVal, minMax0[0], minMax0[1])
        self.loadTxtAttr(*self.kTxtData.NVal)
    """def updOutFreq(self):
        pfdFreq = self.data.numPFD_Freq * 10 ** self.pfdFreqShift
        self.data.numOutFreq = self.getExtFreq(
            self.data.numNVal * pfdFreq)
        self.loadTxtAttr(*self.kTxtData.OutFreq)"""
class PLL_IntB(PLL_CalNVal):
    lstAutoNOpts = map(isReserv,[
        "Desired Frequency", "N Value", "B Counter"])
    lstAutoNInfs = [
        " ".join([
            "The N and B Counter values are",
            "calculated from the desired Frequency",
            "and the actual Output frequency is",
            "calculated based on the calculated N value."]),
        " ".join([
            "The N value is entered and the B",
            "Counter value is calculated to match it.",
            "The actual N value is placed in the entry box."]),
        " ".join([
            "The B Counter value is manually entered",
            "and the N value and output frequency are calculated."])]
    def disableFracInt(self, disabled):
        """
        :param BaseProgADF_PLL&PLL_IntB self:
        """
        self.txtBCntr.disabled = disabled
    def getPreSclDiv(self):
        Str = "WARNING: default getPreSclDiv function called. CLASS %s"
        log.Log(Str % self.__class__.__name__, 3)
        return 4
    def updFracInt(self):
        """
        :param BaseProgADF_PLL&PLL_IntB self:
        """
        if self.data.selAutoN in [1, 0]:
            bRange = self.getAttrEnterSet("BCntr", "int")[2]
            if not isinstance(bRange,BaseRange): bRange = NumRange(*bRange)
            b, a = divmod(int(self.data.numNVal + .5), self.getPreSclDiv())
            minMaxB = bRange.getMinMax(self)
            if minMaxB is not None: b = restrict(b, minMaxB[0], minMaxB[1])
            self.data.numBCntr = b
            self.loadTxtAttr(*self.kTxtData.BCntr)
        self.updRegAttrDat(["numBCntr"])
    def updNVal(self):
        """
        :param BaseProgADF_PLL&PLL_IntB self:
        """
        pMod = self.getPreSclDiv()
        if self.data.selAutoN == 0:
            pfdFreq = self.data.numPFD_Freq * 10 ** self.pfdFreqShift
            self.data.numNVal = int(
                self.getIntFreq(self.data.numRF_Out) / pfdFreq + .5)
        elif self.data.selAutoN == 2:
            self.data.numNVal = self.data.numBCntr * pMod
        self.data.numNVal = int(float(self.data.numNVal) / pMod + .5) * pMod
        Range = self.getAttrEnterSet("NVal", "int")[2]
        if not isinstance(Range, BaseRange): Range = NumRange(*Range)
        minMax = Range.getMinMax(self)
        if self.data.selAutoN != 2:
            self.data.numNVal = restrict(self.data.numNVal, minMax[0], minMax[1])
        self.loadTxtAttr(*self.kTxtData.NVal)
class PLL_IntFrac(PLL_CalNVal):
    lstAutoNOpts = map(isReserv,[
        "Desired Frequency", "N Value", "Fraction & Integer"])
    lstAutoNInfs = [
        " ".join([
            "The N, Fraction and Integer values",
            "are calculated from the desired Frequency",
            "and the actual Output frequency is",
            "calculated based on the N value."]),
        " ".join([
            "The N value is entered and",
            "the Fraction and Integer values",
            "are calculated to match it. The actual",
            "N value is placed in the entry box."]),
        " ".join([
            "The Fraction and Integer values are manually entered",
            "and the N value and output frequency are calculated."])]
    """@classmethod
    def initCls(cls, numBuses):
        super(PLL_IntFrac, cls).initCls(numBuses)
    def __init__(self, *args, **kwargs):
        super(PLL_IntFrac, self).__init__(*args, **kwargs)
        #self.data"""
    def disableFracInt(self, disabled):
        """
        :param BaseProgADF_PLL&PLL_IntFrac self:
        """
        self.txtIntVal.disabled = disabled
        self.txtFracVal.disabled = disabled
    def updFracInt(self):
        """
        :param BaseProgADF_PLL&PLL_IntFrac self:
        """
        if self.data.selAutoN in [1, 0]:
            mod = self.data.numModVal
            Int, frac = divmod(int(self.data.numNVal * mod + .5), mod)
            iRange = self.getAttrEnterSet("IntVal", "int")[2]
            fRange = self.getAttrEnterSet("FracVal", "int")[2]
            iRange, fRange= map(
                lambda x: x if isinstance(x, BaseRange) else NumRange(*x),
                [iRange, fRange])
            minMaxI = iRange.getMinMax(self)
            minMaxF = fRange.getMinMax(self)
            if minMaxI is not None: Int = restrict(Int, minMaxI[0], minMaxI[1])
            if minMaxF is not None: frac = restrict(frac, minMaxF[0], minMaxF[1])
            # preInt = int(Int)
            # Int = restrict(int(Int), iRange.Min, iRange.Max)
            # if preInt > iRange.Max: frac += (preInt - Int) * mod
            # frac = int(restrict(frac, fRange.Min, min(fRange.Max, mod)))
            if frac > mod: frac = mod
            self.data.numIntVal = Int
            self.data.numFracVal = frac
            self.loadTxtAttr(*self.kTxtData.IntVal)
            self.loadTxtAttr(*self.kTxtData.FracVal)
        self.updRegAttrDat(["numIntVal", "numFracVal"])
    def updNVal(self):
        """
        :param BaseProgADF_PLL&PLL_IntFrac self:
        """
        mod = float(self.data.numModVal)
        if self.data.selAutoN == 0:
            pfdFreq = self.data.numPFD_Freq * 10 ** self.pfdFreqShift
            self.data.numNVal = self.getIntFreq(self.data.numRF_Out) / pfdFreq
        elif self.data.selAutoN == 2:
            self.data.numNVal = self.data.numIntVal + self.data.numFracVal/mod
        self.data.numNVal = int(self.data.numNVal * mod + .5) / mod
        Range = self.getAttrEnterSet("NVal", "float")[2]
        if not isinstance(Range, BaseRange): Range = NumRange(*Range)
        minMax = Range.getMinMax(self)
        if self.data.selAutoN != 2 and minMax is not None:
            self.data.numNVal = restrict(
                self.data.numNVal, minMax[0], minMax[1])
        self.loadTxtAttr(*self.kTxtData.NVal)
class PLL_IntFrac2(PLL_CalNVal):
    lstAutoNOpts = map(isReserv,[
        "Desired Frequency", "N Value", "Integer & Fraction"])
    lstAutoNInfs = [
        " ".join([
            "The N, Fraction and Integer values",
            "are calculated from the desired Frequency",
            "and the actual Output frequency is",
            "calculated based on the N value."]),
        " ".join([
            "The N value is entered and",
            "the Fraction and Integer values",
            "are calculated to match it. The actual",
            "N value is placed in the entry box."]),
        " ".join([
            "The Fraction and Integer values are manually entered",
            "and the N value and output frequency are calculated."])]
    def disableFracInt(self, disabled):
        """
        :param BaseProgADF_PLL&PLL_IntFrac2 self:
        """
        self.txtIntVal.disabled = disabled
        self.txtFrac1Val.disabled = disabled
        self.txtFrac2Val.disabled = disabled
    def updFracInt(self):
        """
        :param BaseProgADF_PLL&PLL_IntFrac2 self:
        """
        if self.data.selAutoN in [1, 0]:
            enterSet_NVal = self.getAttrEnterSet1("NVal", "num")
            nType = enterSet_NVal[0]
            toNum = {"int": int, "float": float, "Decimal": Decimal}[nType]
            mod1, mod2 = map(toNum, [self.data.numMod1Val, self.data.numMod2Val])
            Int, frac = divmod(self.data.numNVal * mod1 + toNum(.5) / mod2, mod1)
            iRange = self.getAttrEnterSet("IntVal", "int")[2]
            f1Range = self.getAttrEnterSet("Frac1Val", "int")[2]
            f2Range = self.getAttrEnterSet("Frac2Val", "int")[2]
            iRange, f1Range, f2Range = map(
                lambda x: x if isinstance(x, BaseRange) else NumRange(*x),
                [iRange, f1Range, f2Range])
            minMaxI = iRange.getMinMax(self)
            minMaxF1 = f1Range.getMinMax(self)
            minMaxF2 = f2Range.getMinMax(self)
            frac1, frac2 = divmod(int(frac*mod2), mod2)
            Int = int(Int)
            if minMaxI is not None: Int = restrict(Int, minMaxI[0], minMaxI[1])
            if minMaxF1 is not None: frac1 = restrict(frac1, minMaxF1[0], minMaxF1[1])
            if minMaxF2 is not None: frac2 = restrict(frac2, minMaxF2[0], minMaxF2[1])
            #preInt = int(Int)
            #Int = restrict(int(Int), iRange.Min, iRange.Max)
            #if preInt > iRange.Max: frac += (preInt - Int) * mod1
            # preFrac1 = int(frac1)
            # frac1 = int(restrict(frac1, f1Range.Min, min(f1Range.Max, mod1)))
            # if preFrac1 > f1Range.Max: frac2 += (preFrac1 - frac1) * mod2
            # frac2 = int(restrict(frac2, f2Range.Min, min(f2Range.Max, mod2)))
            if frac1 > mod1: frac1 = mod1
            if frac2 > mod2: frac2 = mod2
            self.data.numIntVal = int(Int)
            self.data.numFrac1Val = int(frac1)
            self.data.numFrac2Val = int(frac2)
            self.loadTxtAttr(*self.kTxtData.IntVal)
            self.loadTxtAttr(*self.kTxtData.Frac1Val)
            self.loadTxtAttr(*self.kTxtData.Frac2Val)
        self.updRegAttrDat(["numIntVal", "numFrac1Val", "numFrac2Val"])
    def updNVal(self):
        """
        :param BaseProgADF_PLL&PLL_IntFrac2 self:
        """
        enterSet_NVal = self.getAttrEnterSet1("NVal", "num")
        nType = enterSet_NVal[0]
        Range = enterSet_NVal[2]
        toNum = {"int": float, "float": float, "Decimal": Decimal}[nType]
        mod1, mod2 = map(toNum, [self.data.numMod1Val, self.data.numMod2Val])
        if self.data.selAutoN == 0:
            pfdFreq = toNum(self.data.numPFD_Freq * 10 ** self.pfdFreqShift)
            self.data.numNVal = self.getIntFreq(self.data.numRF_Out) / pfdFreq
        elif self.data.selAutoN == 2:
            nVal = self.data.numIntVal
            nVal = nVal + (self.data.numFrac1Val + self.data.numFrac2Val/mod2) / mod1
            self.data.numNVal = nVal
        self.data.numNVal = int(self.data.numNVal * mod1 * mod2 + toNum(.5)) / (mod1 * mod2)
        if not isinstance(Range, BaseRange): Range = NumRange(*Range)
        minMax = Range.getMinMax(self)
        if self.data.selAutoN != 2 and minMax is not None:
            self.data.numNVal = restrict(self.data.numNVal, minMax[0], minMax[1])
        self.loadTxtAttr(*self.kTxtData.NVal)
def isUpdRegFunc(fnName):
    return fnName.startswith("updReg") and fnName.endswith("Dat")
def verifRegVal(numBits, regDataFunc, v):
    if regDataFunc is not None:
        if len(regDataFunc) > 2 and regDataFunc[2]:
            v = regDataFunc[0](v, None)
        else:
            v = regDataFunc[0](v)
    if not isinstance(v, (long, int, bool)):
        clsName = None
        try: clsName = v.__class__.__name__
        except AttributeError:
            try: clsName = type(v).__name__
            except AttributeError: clsName = "<Unknown>"
        return 1, "Only int/long/bool allowed. Got %s of type '%s'" % (
            repr(v), clsName)
    if v.bit_length() > numBits: return 2, "Too many bits %s" % repr(v)
    return 0, ""
def getNumBitsRegData(regs, lstWriteData):
    rtn = 0
    for v in lstWriteData:
        if len(v) == 2: rtn += 1
        else:
            regId = v[0]
            if isinstance(regId, (tuple, list)): regId = regId[0]
            rtn += len(xrange(*slice(*v[1:]).indices(len(regs[regId]))))
    return rtn

dct_enterSetTypes = {
    "lst":"lst", "lstInf":"lst", "float":"num",
    "int":"num", "hex":"num", "Decimal":"num",
    "num":"num"}
"""
Base class for all Analog Devices and Hittite PLLs
    It does a lot for you and in order to do so requires you to define data
    in a specific format

    Wants Summary:
        titles -> dict
        regDatas -> dict
        useFuncs -> dict
        defData -> dict
        lstTxtDatas -> list
        lstEnterSets -> list
        OPT regDataFuncs -> dict
        OPT lstBindFuncs -> dict
        OPT lstLstBig -> list
        OPT lstLstFuncs -> list
        OPT lstLineBig -> list
        OPT lstLineFuncs -> list
        OPT lstChkBig -> list
        OPT lstChkBigger -> list
        OPT lstChkFuncs -> list
        OPT(resetToDefs) defRegs -> list
    titles Specifics:
        a dictionary keyed with the datanames given in lstTxtDatas
        values v are tuples where v[0] is the shorter title
          and v[-1] is the more descriptive title for a popup
    regDatas Specifics:
        a dictionary keyed with the attributes in self.data
        NOTE: not all self.data attributes must have an entry in regDatas
          although if they are not specified in regDatas they should be
          specified in defData
        format of each value (v):
            v is an iterable of register locations
            single bit register locations are represented by a 2-tuple
              (regId, bit_index)
            multi bit (numberic) register locations are 3-tuples or 4-tuples
              (regId, ...args for range or xrange)
            the order of register locations is LSB first (0 index is LSB)
            regId is a number to refer to non-dual registers or
              reg.both on dual registers
            regId is a 2-tuple of (register index in self.regs, reg.curReg)
              to refer to a dual register
    useFuncs Specifics:
        a dictionary keyed with the datanames given in lstTxtDatas
        values v are tuples of arguments for a builder function func for build
          the type of widget specified in the entry in lstTxtDatas
          ("num", "lst", "chk...", ...)
          where v[0] is the specific builder id
          builders are used to designate which tab, style, and SI unit variant
          v[1:] are arguments for that builder function
    defData Specifics:
        a dictionary keyed (k) with the attribute names for self.data
        the values specify what self.data[k[ is initialized to if k is not
          in regDatas
    lstTxtDatas Specifics:
        a list that specifies the order in which widgets are created and added
        each element in the list is a tuple of arguments for the buildTxtAttr
          and loadTxtAttr functions
    lstEnterSets Specifics:
        a list that specifies the appearance of entry lines and selection boxes
        NOTE: checkboxes do not use this
        a list of tuples where each tuple (t) is in the format
          t = (Type, funcName, *specifics)
          Type must be one of the following: "lst", "int", "float", "hex"
          funcName is the base name used in lstTxtDatas[n][0]
          specifics as per each Type
            for "lst": len(specifics) = 1 or 0 and specifics[0] is the string
              name of the attribute to call when the user hits done or None
            for "int", "float", "hex": len(specifics) = 2
              specifics[0] is an instance of BaseRange or a (min, max) tuple to
              construct a VarRange with
              specifics[1] is the name of the attribute to call when the
              user hits done
        additional wants for Type "lst"
            self.lst<funcName>Opts: an indexable iterable where each item is a
              2-tuple of (isDisp, dispText)
            to statically construct this object use the result of
              map(isReserv,list of strings) to generate the list
            to dynamically use a changing option set use the result of
              DynamicMap(isReserv,list-like-object)
              NOTE: if the options change you must update the widget-data item
    regDataFuncs Specifics:
        GOTO: formating info can be found near the top of class BaseProgADF_PLL
    lstBindFuncs Specifics:
        dictionary that will be processed in __init__ as so
        getter = Bind(getattr, self)
        for k in self.lstBindFuncs:
            v = self.lstBindFuncs[k]
            f = Bind(getter(v[0]), *map(getter, v[1:]))
            setattr(self, k, f)
    lst<TYPE>Funcs Specifics:
        list of attribute names that are valid k values in getattr(self, k)
        these attributes must be functions that conform to their types
    lst<TYPE>Big Specifics:
        list of indices of functions in lst<Type>Funcs that have an extra label
          for a unit
    lstChkBigger:
        list of indices of functions that take a kwargs and a on_state argument
        only for checkboxes
    lstLstFuncs Specifics:
        function prototypes:
            big: txt1, txt3, funcName, editable=True
            default: txt1, funcName, editable=True
        useFuncs value format:
            default|big: [funcId, editable]
    lstLineFuncs Specifics:
        function prototypes:
            big: txt1, txt2, txt3, attrName, on_release
            default: txt1, txt2, attrName, on_release
        useFuncs value format:
            big: [funcId, unit, editable]
            default: [funcId, editable]
    lstChkFuncs Specifics:
        function prototypes:
            bigger&big: txt1, kwargs2, txt3, attrName, on_state
            bigger: txt1, kwargs2, attrName, on_state
            big: txt1, txt3, datName, attrName, kwargs2=None, updFunc=None
            default: txt1, datName, attrName, kwargs2=None, updFunc=None
        useFuncs value format:
            bigger&big: [funcId, txt3, on_state Str]
            bigger: [funcId, on_state Str]
            big: [funcId, txt3, updFunc Str]
            default: [funcId, updFunc Str]
    Warnings Summary:
        mismatch update function
        register bit field overlap
        BUILD UNUSED: (unused keys and elems for enterSets, useFuncs and titles
    Error Summary:
        ERROR (nonfatal) - error that occurs in loadTxtData
        ERROR BUILD (nonfatal) - error that occurs in buildTxtData
"""
class BaseProgADF_PLL(BaseProgPart):
    mfgName = "Analog Devices"
    interface = "3-wire"
    XM_partName = "Unknown"
    catId = CAT_PLL
    lstBindFuncs = {
        "addVCO_Line": ("addLine", "gridVCO"),
        "addVCO_LineM": ("addLineM", "gridVCO"),
        "addVCO_Lst": ("addLstLine", "gridVCO"),
        "addRefLine": ("addLine", "gridRef"),
        "addRefLineM": ("addLineM", "gridRef"),
        "addRefChk": ("addChkBoxLine", "gridRef"),
        "mkRefChk": ("addChkLine", "gridRef"),
        "addCfgLine": ("addSmallLine", "gridCfg"),
        "addCfgChk": ("addSmallChkLine", "gridCfg"),
        "mkSmCfgChk": ("addSmChkLine", "gridCfg"),
        "mkSmCfgLst": ("addSmallLstLine", "gridCfg"),
        "mkSmChrgChk": ("addSmChkLine", "gridChrg"),
        "addChrgChk": ("addSmallChkLine", "gridChrg"),
        "addChrgLine": ("addSmallLine", "gridChrg"),
        "mkSmChrgLst": ("addSmallLstLine", "gridChrg"),
        "mkSmOutChk": ("addSmChkLine", "gridOut"),
        "addOutChk": ("addSmallChkLine", "gridOut"),
        "addOutLine": ("addSmallLine", "gridOut"),
        "mkSmOutLst": ("addSmallLstLine", "gridOut"),
        "addOtherLine": ("addLine", "gridOther")}
    #lst...Big is funcId's that build 3 widgets (Title,Value,UNIT) instead of 2
    lstLstBig = [0]
    lstLineBig = [0, 1, 2, 3, 7]
    lstLineFuncs = [
        "addVCO_Line", "addVCO_LineM", "addRefLine", "addRefLineM",
        "addCfgLine", "addChrgLine", "addOutLine", "addOtherLine"]
    lstChkBig = []
    #funcId list of funcs that take an on_state parameter
    lstChkBigger = [0, 1, 3, 5]
    lstChkFuncs = [
        "mkRefChk", "addCfgChk", "mkSmCfgChk", "addChrgChk",
        "mkSmChrgChk", "addOutChk", "mkSmOutChk"]
    lstLstFuncs = ["addVCO_Lst", "mkSmCfgLst", "mkSmChrgLst", "mkSmOutLst"]
    #dictionary of format {k:(f0,f1) ...}
    #  k is the key of the data name (self.data[k])
    #  f0 and f1 are functions
    #  f0 takes data from self.data[k] and turns it into a
    #    number that can be directly converted into bits
    #  f1 takes data from the register (after bit masking and combining)
    #    and turns it into data for the self.data[k] attribute
    #not required to have a regDataFuncs[k] for every self.data[k]
    regDataFuncs = {}
    diagData = None
    overrideDiagData = True # set to false to enable test data collection
    postInitDiag = None
    mkDefaultTabs = False
    defDataPacker = DataPacker(DataArray(
        DataObj(
            DataVarBytes(1, 1),
            DataDirect(SaveWithT_Info, LoadWithT_Info, headLen=2, encoding='utf-8'))))
    defRegsPacker = DataPacker(DataArray(
        DataInt()))
    lstEnterSets = []
    titles = {}
    useFuncs = {}
    lstTxtDatas = []
    defData = {}
    regDatas = {}
    defRegs = []
    custom_name_txt_in = None
    @classmethod
    def initCls(cls, numBuses):
        if cls.diagData is None: cls.diagData = {"updateFuncs": set()}
        super(BaseProgADF_PLL, cls).initCls(numBuses)
        lstTmp = ["float", "Decimal", "int", "hex", "num"]
        lstFuncs = [get_enterSetFloat, get_enterSetDecimal, get_enterSetInt, get_enterSetHex, get_enterSetGeneric]
        for enterSet in cls.lstEnterSets:
            Type, enterSet = enterSet[0], enterSet[1:]
            if Type == "lst":
                if len(enterSet) >= 2:
                    updName = enterSet[1]
                    if updName is not None and not cls.overrideDiagData:
                        cls.diagData["updateFuncs"].add(updName)
                get_enterSetLst(cls, *enterSet)
            elif Type in lstTmp:
                pos = lstTmp.index(Type)
                fPopup = lstFuncs[pos]
                funcName, varRange = enterSet[:2]
                title = cls.titles[funcName][-1]
                extArgs = list(enterSet[2:])
                if pos in [0, 1, 4]:
                    enterSetI = 4 if pos == 4 else 3
                    #unit = None if len(enterSet) <= enterSetI else enterSet[enterSetI]
                    if len(enterSet) <= enterSetI:
                        useFunc = cls.useFuncs[funcName]
                        if useFunc[0] in cls.lstLineBig and useFunc[1] != "":
                            extArgs.extend([None] * (enterSetI - len(enterSet)) + [useFunc[1]])
                ##enterSet[2:] is optional but includes [updName, unit, ...] for Decimal and float
                ##  and [updName, ...] for hex and int
                #fPopup(cls, funcName, varRange, title, *enterSet[2:])
                fPopup(cls, funcName, varRange, title, *extArgs)
            elif Type == "lstInf":
                if len(enterSet) >= 2:
                    updName = enterSet[1]
                    if updName is not None and not cls.overrideDiagData:
                        cls.diagData["updateFuncs"].add(updName)
                get_enterSetLstInf(cls, *enterSet)
            else:
                fmtDat = (Type, repr((Type,)+enterSet))
                raise ValueError(
                    "Invalid type string %s for enterSet entry: %s" % fmtDat)
        if not cls.overrideDiagData:
            for txtData in cls.lstTxtDatas:
                if txtData[1].startswith("chk"):
                    updName = cls.useFuncs[txtData[0]][-1]
                    if updName is not None:
                        cls.diagData["updateFuncs"].add(updName)
        if cls.postInitDiag is not None:
            for k in cls.postInitDiag: cls.postInitDiag[k](cls.diagData[k])
    def funcBinder(self, funcName, lstArgsSelf):
        def theFunc(*args):
            curArgs = list(map(self.attrGet, lstArgsSelf)) + list(args)
            return self.attrGet(funcName)(*curArgs)
        return theFunc
    def doTest(self):
        clsName = self.__class__.__name__
        for updName in sorted(self.diagData["updateFuncs"]):
            log.Log("%s Testing %s" % (clsName, updName), 3)
            if not hasattr(self, updName):
                log.Log("%s Failed to find %s" % (clsName, updName), 2)
                continue
            try: self.attrGet(updName)()
            except StandardError: log.Log("%s Testing failed for %s Exception:%s"%(
                clsName, updName, traceback.format_exc()[:-1]), 2)
            else: log.Log("%s Testing succeded for %s" % (clsName, updName), 3)
        fakeProgBtn = not hasattr(self, "progBtn")
        if fakeProgBtn:
            self.progBtn = ValuePack({"color":StrRGB("F00")+(1.,)})
        log.Log("%s Testing programIt" % clsName, 3)
        programItFunc = self.attrGet("programIt", None)
        if programItFunc is None:
            log.Log("%s Failed to find programIt" % clsName, 2)
        else:
            if programItFunc == super(BaseProgADF_PLL, self).programIt:log.Log(
                "%s.programIt is the same as BaseProgPart.programIt"%clsName, 2)
            try: programItFunc()
            except StandardError: log.Log("%s Testing failed for programIt Exception:%s"%(
                clsName, traceback.format_exc()[:-1]), 2)
            else:
                log.Log("%s Testing succeded for programIt" % clsName, 3)
        if fakeProgBtn:
            del self.progBtn
    def postInitAssert(self, dt=None):
        for k in self.defData:
            v0 = self.defData[k]
            v1 = self.data[k]
            logIt = False
            if isinstance(v0, float) and isinstance(v1, float):
                if not closeEnough(v0, v1):
                    self.defData[k] = v1
                    logIt = True
            elif v0 != v1:
                self.defData[k] = v1
                logIt = True
            if logIt: log.Log("DEFAULT INCORRECT: CLASS: %s, k=%s, bad v=%s, correct v=%s, "%(
                self.__class__.__name__, k,repr(v0), repr(v1)), 2)
    def setSpiBus(self, spiBus):
        super(BaseProgADF_PLL, self).setSpiBus(spiBus)
        self.spiBus.cshigh = True
    def fillGridHist(self):
        assert hasattr(self, "gridHist")
        assert isinstance(self.gridHist, GridLayout)
        self.gridHist.add_widget(self.userLog.widget)
        self.gridHistBtns = GridLayout(spacing=[5, 5], rows=1, size_hint=(1., .1))
        self.gridHistBtns.add_widget(Button(
            text="Clear", on_release=lambda obj: self.userLog.clear()))
        self.gridHistBtns.add_widget(Button(
            text="Save", on_release=lambda obj: self.userLog.saveDialog()))
        """self.gridHistBtns.add_widget(Button(
            text="Load", on_release=lambda obj: self.userLog.loadDialog()))"""
        self.gridHist.add_widget(self.gridHistBtns)
    def build(self, app):
        rtn = super(BaseProgADF_PLL, self).build(app)
        if hasattr(self, "tabPanel"):
            self.curTabEvt(self.tabPanel, self.tabPanel.current_tab)
        return rtn
    def __init__(self, fl=None, ver=0):
        self.userLog = UserLog(size_hint=(1.0, .9))
        self.regOutFmt = "Writing 0x%%0%uX to "%((self.regs[0].wordSz+3)/4)
        super(BaseProgADF_PLL, self).__init__(fl, ver)
        # to run tests on plls comment out 'self.data = ValuePack()',
        #  set overrideDiagData to False (above in this class namespace),
        #  and uncomment all the lines after that until Clock.schedule_once
        #  (inclusive) before 'self.attrGet = Bind(getattr, self)'
        #  these tests will try to run the update functions provided in
        #  lstEnterSets (or useFuncs for checkboxes)
        if self.overrideDiagData: self.data = ValuePack()
        else:
            self.data = SlowerValuePack(StrictDict({
                k:{Bind(
                    verifRegVal, getNumBitsRegData(self.regs, self.regDatas[k]),
                    self.regDataFuncs.get(k, None))}
                for k in self.regDatas}), True)
            Clock.schedule_once(lambda dt=None:self.doTest(), 0)
            #below is the defData tester
            Clock.schedule_once(self.postInitAssert, 0)
        self.attrGet = Bind(getattr, self)
        for k in self.lstBindFuncs:
            func = self.lstBindFuncs[k]
            setattr(self, k, self.funcBinder(func[0], func[1:]))
        if isinstance(self.regs, dict):
            usedBits = {k: {} for k in self.regs}
            self.lstRegDats = {x:[] for x in self.regs}
        else:
            usedBits = [{} for x in xrange(len(self.regs))]
            self.lstRegDats = [[] for x in xrange(len(self.regs))]
        self.lstRegDatsDual = {}
        usedBitsDual = {}
        self.tabNoWrite = set()
        self.mainParent = None
        def dctUsedChk(used, regId, ws, kName, bits):
            for k in used:
                for index in bits:
                    if index in used[k]:
                        prn = "WARNING: Register bit field overlap\n  "
                        prn += "%s and %s in %s and CLASS: %s" % (
                            k, kName, self.fmtReg((regId, ws)),
                            self.__class__.__name__)
                        log.Log(prn,3)
                        break
        def usedBitsChecker(lstUsed, dctUsed, regId, ws, kName, writeData):
            bits = [writeData[0]]
            if len(writeData) != 1:
                bits = range(*slice(*writeData).indices(len(self.regs[regId])))
            dctUsedChk(lstUsed[regId], regId, ws, kName, bits)
            if regId in dctUsed:
                if ws == -1:
                    for used in dctUsed[regId]:
                        dctUsedChk(used, regId, ws, kName, bits)
                else:
                    dctUsedChk(dctUsed[regId][ws], regId, ws, kName, bits)
            if ws == -1:
                lstUsed[regId][kName] = bits
            else:
                if regId not in dctUsed:
                    dctUsed[regId] = [
                        {} for x in xrange(self.regs[regId].numDual)]
                dctUsed[regId][ws][kName] = bits
        for k in self.regDatas:
            for write in self.regDatas[k]:
                regId = write[0]
                ws = -1
                if not isinstance(regId, (int, long)):
                    regId, ws = regId
                    if not self.lstRegDatsDual.has_key(regId):
                        self.lstRegDatsDual[regId] = [
                            [] for x in xrange(self.regs[regId].numDual)]
                    self.lstRegDatsDual[regId][ws].append(k)
                usedBitsChecker(usedBits, usedBitsDual, regId, ws, k, write[1:])
                if k not in self.lstRegDats[regId]:
                    self.lstRegDats[regId].append(k)
        Iter = self.regs if isinstance(self.regs, dict) else xrange(len(self.regs))
        for c in Iter:
            reg = self.regs[c]
            if reg.isDual:
                fmt = "updReg%u_%%uDat"%c
                for c0 in xrange(reg.numDual):
                    setattr(self, fmt%c0, Bind(self.updRegNDat, c, c0))
            setattr(self, "updReg%uDat"%c, Bind(self.updRegNDat, c))
        self.kTxtData = ValuePack()
        self.kEnterSets = ValuePack()
        self.kEnterSets1 = ValuePack()
        for c in xrange(len(self.lstEnterSets)):
            self.kEnterSets["%s_%s" % self.lstEnterSets[c][0:2]] = c
            Typ = dct_enterSetTypes[self.lstEnterSets[c][0]]
            self.kEnterSets1["%s_%s"%(Typ,self.lstEnterSets[c][1])] = c
        for txtData in self.lstTxtDatas:
            k = txtData[0]
            try:
                self.kTxtData[k] = txtData
                k0, k1 = getKeysTxtData(txtData)
                if (k0 in self.regDatas) and (k in self.useFuncs):
                    fnName = None
                    if txtData[1][:3] == "chk": fnName = self.useFuncs[k][-1]
                    elif txtData[1] in ["num", "lst"]:
                        index = self.kEnterSets1["%s_%s"%(txtData[1],k)]
                        fnName = self.lstEnterSets[index][-1]
                    else:
                        prn = "Unrecognized type of data present in regDatas"
                        prn += " and txtDatas\n  funcName: %s, datName: %s"%(k,k0)
                        log.Log(prn, 2)
                        continue
                    if isUpdRegFunc(fnName):
                        rNum = -1
                        for reg in self.regDatas[k0]:
                            if rNum != -1 and rNum != reg[0]:
                                rNum = -2
                                break
                            else: rNum = reg[0]
                        prn = "WARNING: "
                        prn += "For %s,\n  " % k
                        prn += "mismatch update function %s " % fnName
                        if rNum == -1: prn += "for data in no regs"
                        elif rNum == -2: prn += "for data in multiple regs"
                        elif "updReg%sDat"%fmtRegId(rNum) != fnName:
                            prn += "for data in reg %u" % rNum
                        else: prn = None
                        if prn is not None:
                            prn += " CLASS: " + self.__class__.__name__
                            log.Log(prn,3)
            except:
                log.Log("Error: k=%r, txtData=%r"%(k,txtData), 2)
                raise
        if fl is None: self.initData()
        else: #TODO Test
            defData = {k: v for k, v in self.defDataPacker.Unpack(fl)[0]}
            defRegs = self.defRegsPacker.Unpack(fl)[0]
            self.initData(defRegs, defData)
    def serialize(self, fl, ver):
        super(BaseProgADF_PLL, self).serialize(fl, ver)
        defRegs = self.dumpRegs()
        keys = filter(self.defData.__contains__, sorted(self.data))
        lstPairs = list(map(lambda k: [k, self.data[k]], keys))
        self.defDataPacker.Pack([lstPairs], fl)
        self.defRegsPacker.Pack([defRegs], fl)
    def setReg(self, regNum): pass
    def getTabPanel(self):
        if not self.mkDefaultTabs:
            return TabbedPanel(
                pos_hint={"top":1.0586,'x':0.01},size_hint=(.98,.85),
                default_tab_cls=SnappedTabbedPanelHeader)
        tabPanel, dctNames = getTabPanel(self.tabLayout)
        for k in dctNames:
            setattr(self, k, dctNames[k])
        return tabPanel
    def updRegNDat(self, n, ws=-1):
        lstRegInf = self.lstRegDats[n] if ws==-1 else self.lstRegDatsDual[n][ws]
        for k in lstRegInf: self.writeDataPart(k, self.regDatas[k])
        self.onProgChg()
    def onProgChg(self):
        try:super(BaseProgADF_PLL, self).onProgChg()
        except StandardError:pass
    def initData(self, defRegs=None, defData=None):
        defData = self.defData if defData is None else dict(self.defData, **defData)
        defRegs = self.defRegs if defRegs is None else (self.defRegs + defRegs)
        for k in defData: self.data[k] = defData[k]
        for val in defRegs: self.setReg(val)
        self.loadDataFromRegs()
    #constructs a new tab and adds it to the tabbed panel
    #  tabAttr: attribute name of the new tab
    #  gridAttr: attribute name of the grid where other widgets may be placed
    #  tabName: displayed name at the tab header
    #  kwargs: dictionary that the BorderedGridLayout is constructed with
    def mkTab(self, tabAttr, gridAttr, tabName, **kwargs):
        defs = dict(cols=4, spacing=[10,10], padding=[20, 10, 5, 5])
        kwargs = dict(defs, **kwargs)
        grid = BorderedGridLayout(**kwargs)
        tab = SnappedTabbedPanelHeader(text=tabName, content=grid)
        self.tabPanel.add_widget(tab)
        setattr(self, tabAttr, tab)
        setattr(self, gridAttr, grid)
    def addSmallLstLine(self, content, txt1, funcName, editable=True):
        optName = "lst" + funcName + "Opts"
        datName = "sel" + funcName
        enterName = "enter" + funcName
        attrName = "in" + funcName
        lstOpts = getattr(self, optName)
        curTxt = "Reserved"
        if isinstance(lstOpts, (list, tuple)):
            curTxt = lstOpts[self.data[datName]][1]
        elif isinstance(lstOpts, dict):
            curTxt = lstOpts.get(self.data[datName], curTxt)
        else:
            raise TypeError("lstOpts must be instance of dict, tuple or list")
        enterFunc = None
        if editable: enterFunc = getattr(self,enterName)
        self.addSmallLine(content,txt1,curTxt,attrName,enterFunc)
    def addSmChkLine(self, content, txt1, datName, attrName, kwargs2=None, updFunc=None):
        if kwargs2 is None:
            kwargs2 = dict(state=toState[self.data[datName]])
        else:
            kwargs2 = dict(kwargs2, state=toState[self.data[datName]])
        def on_state(obj, val):
            self.data[datName] = fromState[val]
            if updFunc is not None: updFunc()
        self.addSmallChkLine(content, txt1, kwargs2, attrName, on_state)
    def addLine(self, content, txt1, txt2, txt3, attrName, on_release):
        self.addSmallLine(content, txt1, txt2, attrName, on_release)
        content.add_widget(sizedLabel(text=txt3, size_hint=(None, None)))
    def addUnitSmLine(self, content, txt1, txt2, txt3, attrName, on_release):
        content.add_widget(sizedLabel(text=txt1, size_hint=(None, None)))
        defStyle = dict(size_hint_x=1., size_hint_y=None, height=32)
        gridUnitLine = GridLayout(cols=2, spacing=[10, 0], **defStyle)
        content.add_widget(gridUnitLine)
        self.addLineObj(gridUnitLine, txt2, attrName, on_release)
        gridUnitLine.add_widget(sizedLabel(text=txt3, size_hint=(None, None)))
    def addSmallLine(self, content, txt1, txt2, attrName, on_release):
        content.add_widget(sizedLabel(text=txt1, size_hint=(None, None)))
        self.addLineObj(content, txt2, attrName, on_release)
    def addLineObj(self, content, txt2, attrName, on_release):
        obj = None
        defStyle = dict(size_hint_y=None, height=32)
        if on_release is None: obj = BrdLabel(text=txt2, **defStyle)
        else: obj = ClkTxtIn(text=txt2, on_release=on_release, **defStyle)
        setattr(self, attrName, obj)
        content.add_widget(obj)
    def addSmallChkLine(self, content, txt1, kwargs2, attrName, on_state):
        content.add_widget(sizedLabel(text=txt1, size_hint=(None, None)))
        obj = CheckBox(size_hint_y=None, height=32, **kwargs2)
        obj.bind(state=on_state)
        setattr(self, attrName, obj)
        content.add_widget(obj)
    def addLstLineObj(self, content, funcName, editable=True):
        optName = "lst" + funcName + "Opts"
        datName = "sel" + funcName
        enterName = "enter" + funcName
        attrName = "in" + funcName
        lstOpts = getattr(self,optName)
        curTxt = "Reserved"
        if isinstance(lstOpts, (list, tuple)):
            curTxt = lstOpts[self.data[datName]][1]
        elif isinstance(lstOpts, dict):
            curTxt = lstOpts.get(self.data[datName], curTxt)
        else:
            raise TypeError("lstOpts must be instance of dict, tuple or list")
        enterFunc = None
        if editable: enterFunc = getattr(self,enterName)
        self.addLineObj(content, curTxt, attrName, enterFunc)
    def dumpRegs(self):
        rtn = []
        for reg in self.regs:
            for c in xrange(len(reg.dualLst)):
                reg.curReg = c
                rtn.append(reg.word.num)
        return rtn
    def addLstLine(self, content, txt1, txt3, funcName, editable=True):
        optName = "lst" + funcName + "Opts"
        datName = "sel" + funcName
        enterName = "enter" + funcName
        attrName = "in" + funcName
        lstOpts = getattr(self,optName)
        curTxt = "Reserved"
        if isinstance(lstOpts, (list, tuple)):
            curTxt = lstOpts[self.data[datName]][1]
        elif isinstance(lstOpts, dict):
            curTxt = lstOpts.get(self.data[datName], curTxt)
        else:
            raise TypeError("lstOpts must be instance of dict, tuple or list")
        enterFunc = None
        if editable: enterFunc = getattr(self,enterName)
        self.addLine(content, txt1, curTxt, txt3, attrName, enterFunc)
    def addLineM(self, content, txt1, txt2, txt3, attrName, on_release):
        content.add_widget(sizedLabel(
            text=txt1, size_hint=(None, None), markup=True))
        self.addLineObj(content, txt2, attrName, on_release)
        content.add_widget(sizedLabel(text=txt3, size_hint=(None, None)))
    def addChkBoxLine(self, content, txt1, kwargs2, txt3, attrName, on_state):
        content.add_widget(sizedLabel(text=txt1, size_hint=(None, None)))
        obj = CheckBox(size_hint_y=None, height=32, **kwargs2)
        obj.bind(state=on_state)
        setattr(self, attrName, obj)
        content.add_widget(obj)
        content.add_widget(sizedLabel(text=txt3, size_hint=(None, None)))
    def addChkLine(self, content, txt1, txt3, datName, attrName, kwargs2=None, updFunc=None):
        if kwargs2 is None: kwargs2 = {}
        def on_state(inst, val):
            self.data[datName] = fromState[val]
            if updFunc is not None: updFunc()
        self.addChkBoxLine(content, txt1, kwargs2, txt3, attrName, on_state)
    #gets the value that is in the registers that would represent datName
    #  without overwriting self.data[datName]
    def getRegVal(self, datName):
        num = 0
        numShift = 0
        for write in self.regDatas[datName]:
            origReg = None
            regId = write[0]
            if isinstance(regId, (int, long)):
                reg = self.regs[regId]
            else:
                reg = self.regs[regId[0]]
                origReg = reg.curReg
                reg.curReg = regId[1]
            if len(write) == 2:
                num |= reg[write[1]] << numShift
                numShift += 1
            else:
                slice_ = slice(*write[1:])
                num |= reg[slice_] << numShift
                numShift += len(xrange(*slice_.indices(len(reg))))
            if origReg is not None: reg.curReg = origReg
        regDataFunc = self.regDataFuncs.get(datName, None)
        if regDataFunc is not None:
            From = regDataFunc[1]
            if len(regDataFunc) > 2 and regDataFunc[2]:
                num = From(num, self)
            else:
                num = From(num)
        return num
    def loadDataFromRegs(self):
        for k in self.regDatas: self.data[k] = self.getRegVal(k)
    """
    argument Meanings:
    funcName: the simple data name that will be used to name the
      data attribute, and the corresponding set/enter/get function
      attributes
    Type: "lst", "num", or an attribute name starting with "chk"
      Type is used for the attr string in getattr(self, attr)
      and the attribute name in self.data
      for Type=="lst":
          datName = "sel" + funcName
          attr = "in" + funcName
      for Type=="num":
          datName = "num" + funcName
          attr = "txt" + funcName
      for Type[:3]=="chk":
          datName = funcName
          attr = Type
      for Type[:6]=="blank_": NOTE: SPECIAL
          funcName is the attribute name of the layout widget
          int(Type[6:]) is the number of blank labels to add to the layout
    conv: formatable string or a callable that will return the formatted string
    """
    def buildTxtAttr(self, funcName, Type="lst", conv="%u"):
        if Type == "lst":
            #data = self.data["sel" + funcName]
            txtAttr = "in" + funcName
            funcDat = self.useFuncs[funcName]
            funcId = funcDat[0]
            params = funcDat[1:]
            func = getattr(self, self.lstLstFuncs[funcId])
            if funcId in self.lstLstBig:
                func(self.titles[funcName][0], "", funcName, *params)
            else: func(self.titles[funcName][0], funcName, *params)
            #opts = getattr(self, "lst" + funcName + "Opts")
            #txtIn.text = opts[data][1]
        elif Type == "num":
            data = self.data["num" + funcName]
            txtAttr = "txt" + funcName
            enterFunc = None
            txt = ""
            if isinstance(conv, (unicode, str)): txt = conv % data
            else:
                assert callable(conv)
                txt = conv(data)
            funcDat = self.useFuncs[funcName]
            funcId = funcDat[0]
            params = funcDat[1:]
            func = getattr(self, self.lstLineFuncs[funcId])
            #txt1, txt2, txt3, attrName, on_release
            if params[-1]: enterFunc = getattr(self, "enter" + funcName)
            title = self.titles[funcName][0]
            if funcId in self.lstLineBig:
                func(title, txt, params[0], txtAttr, enterFunc)
            else: func(title, txt, txtAttr, enterFunc)
        elif Type[:3] == "chk":
            funcDat = self.useFuncs[funcName]
            funcId = funcDat[0]
            params = funcDat[1:]
            func = getattr(self, self.lstChkFuncs[funcId])
            title = self.titles[funcName][0]
            #3bigger big txt1, kwargs2, txt3, attrName, on_state
            #2bigger txt1, kwargs2, attrName, on_state
            #0txt1, datName, attrName, kwargs2=None, updFunc=None
            #1big txt1, txt3, datName, attrName, kwargs2=None, updFunc=None
            #3bigger big [txt3, on_state Str]
            #2bigger [on_state Str]
            #0[updFunc Str]
            #1big [txt3, updFunc Str]
            updFunc = params[-1]
            if updFunc is not None: updFunc = getattr(self,updFunc)
            args = [title]
            kwargs = {"state":toState[self.data[funcName]]}
            num = 0
            if funcId in self.lstChkBig: num |= 1
            if funcId in self.lstChkBigger: num |= 2
            if num == 0: args.extend([funcName, Type, kwargs, updFunc])
            elif num == 1: args.extend([kwargs, Type, updFunc])
            elif num == 2: args.extend([params[0], funcName, Type, kwargs, updFunc])
            elif num == 3: args.extend([kwargs, params[0], Type, updFunc])
            func(*args)
        elif Type[:6] == "blank_":
            grid = getattr(self, funcName)
            for c in xrange(int(Type[6:])):
                grid.add_widget(sizedLabel(text="", size_hint=(None,None)))
    #like buildTxtAttr except it only refreshes the existing widget to
    #  accurately represent its associated self.data attribute
    def loadTxtAttr(self, funcName, Type="num", conv="%u"):
        if Type == "num":
            data = self.data["num" + funcName]
            txtIn = getattr(self, "txt" + funcName)
            if isinstance(conv, (unicode, str)):
                txtIn.text = conv % data
            else:
                assert callable(conv)
                txtIn.text = conv(data)
        elif Type == "lst":
            data = self.data["sel" + funcName]
            txtIn = getattr(self, "in" + funcName)
            opts = getattr(self, "lst" + funcName + "Opts")
            if isinstance(opts, (list, tuple)): txtIn.text = opts[data][1]
            elif isinstance(opts, dict): txtIn.text = opts.get(data,"Reserved")
        elif Type[:3] == "chk":
            getattr(self, Type).state = toState[self.data[funcName]]
        elif Type[:6] == "blank_": pass
    #maps loadTxtAttr to all of self.lstTxtDatas
    #  if there is an error caused by one element the function will not quit
    def loadTxtData(self):
        fmtError = "ERROR: %%s when txtData: %%s CLASS: %s"
        fmtError %= self.__class__.__name__
        for data in self.lstTxtDatas:
            try:
                self.loadTxtAttr(*data)
            except StandardError:
                log.Log(fmtError % (traceback.format_exc(),str(data)), 2)
    #maps buildTxtAttr to all of self.lstTxtDatas
    #  if there is an error caused by one element the function will not quit
    def buildTxtData(self, warnings=True, autoAddCustomName="gridOther"):
        unusedTitles = set(self.titles)
        unusedFuncs = set(self.useFuncs)
        unusedEnterSets = set(map(lambda x: x[1], self.lstEnterSets))
        fmtError = "ERROR BUILD: %%s when txtData: %%s and class: %s"
        fmtError %= self.__class__.__name__
        for data in self.lstTxtDatas:
            try:
                self.buildTxtAttr(*data)
            except StandardError:
                log.Log(fmtError % (traceback.format_exc(), str(data)), 2)
            finally:
                unusedTitles.discard(data[0])
                unusedFuncs.discard(data[0])
                unusedEnterSets.discard(data[0])
        lens = map(len,(unusedTitles, unusedFuncs, unusedEnterSets))
        if warnings and lens.count(0) != len(lens):
            lstPrn = [
                "WARNING BUILD UNUSED: " + self.__class__.__name__,
                "UNUSED titles keys:"
            ]
            lstPrn.extend(["  " + title for title in sorted(unusedTitles)])
            lstPrn.append("UNUSED useFunc keys:")
            lstPrn.extend(["  " + func for func in sorted(unusedFuncs)])
            lstPrn.append("UNUSED EnterSets keys:")
            lstPrn.extend(["  " + enterSet for enterSet in sorted(unusedEnterSets)])
            log.Log("\n  ".join(lstPrn), 3)
        if autoAddCustomName is not None and getattr(self, autoAddCustomName, None) is not None:
            grid = getattr(self, autoAddCustomName)
            index = len(grid.children)
            txt_in = TextInput(text=self.custom_name, multiline=False)
            self.custom_name_txt_in = txt_in
            grid.add_widget(Label(text="Custom Name"), index)
            grid.add_widget(txt_in, index)
            if getattr(grid, "cols", None) is not None:
                for c in xrange(2, grid.cols):
                    grid.add_widget(Label(), index)
            txt_in.bind(text=lambda obj, v: self.set_custom_name(v))

    def on_chg_custom_name(self, v):
        txt_in = self.custom_name_txt_in
        if txt_in is not None and txt_in.text != v:
            txt_in.text = v
    #takes a regId 2-tuple of (index, reg.curReg) and formats it according to
    #  reg.isDual
    def fmtReg(self, regId, short=True):
        fmtStr = "R%%u %s %%u"
        if self.regs[regId[0]].isDual:
            fmtStr %= "ws" if short else "word select"
            fmtStr %= regId
        else:
            fmtStr = fmtStr[:4].replace("%%", "%")
            fmtStr %= regId[0]
        return fmtStr
    #takes a regId 2-tuple of (index, reg.curReg) and writes that to the spiBus
    def outputReg(self, regId):
        logStr = self.fmtReg(regId, False)
        reg = self.regs[regId[0]]
        orig = reg.curReg
        reg.curReg = regId[1]
        self.userLog.log(self.regOutFmt%reg[:] + logStr)
        reg.spiWriteData(self.spiBus)
        self.userLog.log("Finished write to " + logStr)
        reg.curReg = orig
    #copies self.data[datName] to its bit fields specified in lstWrites
    #Usually lstWrites comes from self.regDatas[datName]
    def writeDataPart(self, datName, lstWrites):
        data = self.data[datName]
        regDataFunc = self.regDataFuncs.get(datName, None)
        ignoreEnd = 0
        if regDataFunc is not None:
            To = regDataFunc[0]
            if len(regDataFunc) > 2 and regDataFunc[2]:
                data = To(data, self)
            else:
                data = To(data)
            if isinstance(data, (tuple, list)):
                if len(data) > 1: ignoreEnd = data[1]
                data = data[0]
        try:
            for write in lstWrites:
                reg = None
                regId = write[0]
                origReg = None
                if isinstance(regId, (int, long)):
                    reg = self.regs[regId]
                    if reg.isDual: reg = reg.both
                else:
                    reg = self.regs[regId[0]]
                    origReg = reg.curReg
                    reg.curReg = regId[1]
                if len(write) == 2:
                    if ignoreEnd:
                        ignoreEnd -= 1
                        data >>= 1
                    else:
                        reg[write[1]] = data & 1
                        data >>= 1
                else:
                    slice_ = slice(*write[1:])
                    indices = xrange(*slice_.indices(len(reg)))
                    shiftBy = len(indices)
                    if ignoreEnd >= shiftBy:
                        data >>= shiftBy
                        ignoreEnd -= shiftBy
                    elif ignoreEnd:
                        start = slice_.start
                        if start is None: start = 0
                        step = slice_.step
                        if step is None: step = 1
                        stop = slice_.stop
                        slice_ = slice(start + ignoreEnd * step, step, stop)
                        data >>= ignoreEnd
                        shiftBy -= ignoreEnd
                        reg[slice_] = data
                        data >>= shiftBy
                    else:
                        reg[slice_] = data
                        data >>= shiftBy
                if origReg is not None: reg.curReg = origReg
        except StandardError as Exc:
            log.Log("Error: %s With datName=%s"%(
                traceback.format_exc(), repr(datName)), 1)
            raise Exc
    def curTabEvt(self, obj, val):
        if val in self.tabNoWrite:
            if self.progBtn.parent is not None:
                self.mainParent = self.progBtn.parent
                self.mainParent.remove_widget(self.progBtn)
        elif self.mainParent is not None and self.progBtn.parent is None:
            self.mainParent.add_widget(self.progBtn)
            self.mainParent = None
    #only available if defRegs is present calling this function without defRegs
    #  present will result in an AttributeError exception being raised
    def resetToDefs(self, obj=None):
        errFmt = "when regVal: %%0%uX CLASS: %s" % (
            (self.regs[0].wordSz+3) / 4, self.__class__.__name__)
        for val in self.defRegs:
            try:
                self.setReg(val)
            except StandardError:
                log.Log(traceback.format_exc() + errFmt % val, 2)
        self.loadDataFromRegs()
        for k in self.defData: self.data[k] = self.defData[k]
        self.loadTxtData()
    def regHasAttr(self, regId, attr):
        for data in self.regDatas[attr]:
            if isinstance(data[0], tuple):
                if data[0] == regId: return True
            else:
                if data[0] == regId[0]: return True
        return False
    def updRegAttrDat(self, lstAttr, Warn=True):
        regIds = set()
        for attr in lstAttr:
            if attr not in self.regDatas:
                if Warn:
                    log.Log("WARNING: %s is not in regDatas. CLASS %s" % (
                        attr, self.__class__.__name__), 2)
                continue
            for data in self.regDatas[attr]: regIds.add(data[0])
        for regId in regIds:
            if isinstance(regId, tuple): getattr(self,"updReg%u_%uDat"%regId)()
            else: getattr(self,"updReg%uDat"%regId)()
    def addCfgMdLbls(self, grid, defStyle, dctLbls = None):
        if dctLbls is None:
            dctLbls = {
                "AutoN":"Select the method of entering the N Counter value",
                "AutoMod":"Select the method of entering modulus",
                "AutoR":"Select the method of entering the R Counter value"}
        lblOrder = filter(None,map(
            lambda x: x[0] if (x[0] in dctLbls) else None, self.lstTxtDatas))
        for c in xrange(len(lblOrder)):
            grid.add_widget(sizedCls1(
                Label,text=dctLbls[lblOrder[c]],**defStyle))
    def getAttrEnterSet(self, attr, Type):
        theK = "%s_%s" % (Type, attr)
        if (Type, attr) == self.lstEnterSets[self.kEnterSets[theK]][0:2]:
            return self.lstEnterSets[self.kEnterSets[theK]]
        lstPreKeys = set([k for k in self.kEnterSets if not k.startswith("_")])
        for c in xrange(len(self.lstEnterSets)):
            k = "%s_%s" % self.lstEnterSets[c][0:2]
            tmp = list(self.lstEnterSets[c][0:2])
            tmp[0] = dct_enterSetTypes[tmp[0]]
            k1 = "%s_%s" % tuple(tmp)
            self.kEnterSets[k] = c
            self.kEnterSets1[k1] = c
            lstPreKeys.discard(k)
        for k in lstPreKeys: del self.kEnterSets[k]
        return self.lstEnterSets[self.kEnterSets[theK]]
    def getAttrEnterSet1(self, attr, Type):
        theK = "%s_%s" % (Type, attr)
        if (Type, attr) == self.lstEnterSets[self.kEnterSets1[theK]][0:2]:
            return self.lstEnterSets[self.kEnterSets1[theK]]
        lstPreKeys = set([k for k in self.kEnterSets if not k.startswith("_")])
        for c in xrange(len(self.lstEnterSets)):
            k = "%s_%s" % self.lstEnterSets[c][0:2]
            tmp = list(self.lstEnterSets[c][0:2])
            tmp[0] = dct_enterSetTypes[tmp[0]]
            k1 = "%s_%s" % tuple(tmp)
            self.kEnterSets[k] = c
            self.kEnterSets1[k1] = c
            lstPreKeys.discard(k)
        for k in lstPreKeys: del self.kEnterSets[k]
        return self.lstEnterSets[self.kEnterSets1[theK]]