from .. import globalVars
from traceback import format_exc
from os import listdir
from time import time as get_time
log = globalVars.log
def isValidPartMod(parts):
    return (len(parts)==2 and parts[1].lower() in ["py", "pyc"] and
            parts[0].startswith("part_"))
def LoadModules(data):
    log.Log("discovering candidate part modules", 3)
    searchPath = __file__.replace("\\", "/")
    searchPath = searchPath[:searchPath.rfind("/")]
    candPartMod = [
        parts[0] for parts in
        map(lambda x: x.rsplit(".",1), listdir(searchPath))
        if isValidPartMod(parts)]
    candPartMod = sorted(set(candPartMod))
    log.Log("found %u candidates"%len(candPartMod), 3)
    tTotal = sum(map(lambda x: data.get(x, 0), candPartMod))
    numFail = 0
    numSuccess = 0
    totalTime = 0
    newTotalTime = 0
    yield tTotal
    for c in xrange(len(candPartMod)):
        tPrev = get_time()
        try:
            exec("import " + candPartMod[c], globals(), globals())
            #partModules[c] = importlib.import_module(candPartMod[c])
            log.Log("loaded: " + candPartMod[c], 3)
            numSuccess += 1
        except:
            log.Log("failed to load: " + candPartMod[c] + "\n" + format_exc()[:-1], 1)
            numFail += 1
        tCur = get_time()
        tImport = tCur - tPrev
        old = data.get(candPartMod[c], 0)
        data[candPartMod[c]] = tImport
        totalTime += old
        newTotalTime += tImport
        yield totalTime, newTotalTime
    log.Log("failed to load %u candidates"%numFail, [3, 2][numFail>0])
    log.Log("loaded " + str(numSuccess) + " modules", 3)
