from BaseAnySwitch import *

log = None

@initFunc(__name__.replace("ProgramIt.", ""))
def init(progLog):
    global log
    log = progLog

class ProgADRFXXXX(BaseSwitch):
    mfgName = "Analog Devices"
    mfgPartName = "ADRF****"
class ADRF_Type1(ProgADRFXXXX):
    txtTable = ["CTRL"]
    swLbls = ["RFC-RF1", "RFC-RF2"]
    optMaps = {0:[1], 1:[0]}
    nPins = 1
    nThrow = 2
@partClass("XM-ADGM1004-0819")
class ProgXM_ADGM1004(BaseSwitch):
    XM_partName = "XM-ADGM1004-0819"
    mfgName = "Analog Devices"
    mfgPartName = "ADGM1004"
    txtTable = ["IN1", "IN2", "IN3", "IN4"]
    swLbls = [
        "RFC-None", "RFC-RF1", "RFC-RF2", "RFC-RF1,RF2",
        "RFC-RF3", "RFC-RF1,RF3", "RFC-RF2,RF3", "RFC-RF1,RF2,RF3",
        "RFC-RF4", "RFC-RF1,RF4", "RFC-RF2,RF4", "RFC-RF1,RF2,RF4",
        "RFC-RF3,RF4", "RFC-RF1,RF3,RF4", "RFC-RF2,RF3,RF4", "RFC-RF1,RF2,RF3,RF4"
    ]
    optMaps = {
        0: [0, 0, 0, 0],
        1: [1, 0, 0, 0],
        2: [0, 1, 0, 0],
        3: [1, 1, 0, 0],
        4: [0, 0, 1, 0],
        5: [1, 0, 1, 0],
        6: [0, 1, 1, 0],
        7: [1, 1, 1, 0],
        8: [0, 0, 0, 1],
        9: [1, 0, 0, 1],
        10: [0, 1, 0, 1],
        11: [1, 1, 0, 1],
        12: [0, 0, 1, 1],
        13: [1, 0, 1, 1],
        14: [0, 1, 1, 1],
        15: [1, 1, 1, 1]
    }
    nPins = 4
    nThrow = 16
@partClass("XM-ADGM1304-0819")
class ProgXM_ADGM1304(ProgXM_ADGM1004):
    mfgPartName = "ADGM1304"
    XM_partName = "XM-ADGM1304-0819"
@partClass("XM-ADG936-0409")
class ProgXM_ADG936(BaseDualSwitch):
    mfgName = "Analog Devices"
    mfgPartName = "ADG936"
    XM_partName = "XM-ADG936-0409"
@partClass("XM-ADG936_R-0409")
class ProgXM_ADG936_R(BaseDualSwitch):
    mfgName = "Analog Devices"
    mfgPartName = "ADG936-R"
    XM_partName = "XM-ADG936_R-0409"
@partClass("XM-A637-0409")
class ProgXM_A637(ADRF_Type1):
    mfgPartName = "ADRF5130"
    XM_partName = "XM-A637-0409"
@partClass("XM-A5G1-0409")
class ProgXM_A5G1(ADRF_Type1):
    mfgPartName = "ADG918"
    XM_partName = "XM-A5G1-0409"
@partClass("XM-A5G2-0409")
class ProgXM_A5G2(ADRF_Type1):
    mfgPartName = "ADG919"
    XM_partName = "XM-A5G2-0409"
class ADI_SPST(ProgADRFXXXX):
    nthrow = 2
    nPins = 1
    txtTable = ["CTRL"]
    optMaps = {0: [0], 1: [1]}
    swLbls = ["RF1 isolated from RF2", "RF1 connected to RF2"]
class HMC_SPST(ADI_SPST):
    mfgName = Hittite
    mfgPartName = "HMC****"
@partClass("XM-A5G6-0404")
class ProgXM_A5G6(ADI_SPST):
    mfgPartName = "ADG901"
    XM_partName = "XM-A5G6-0404"
@partClass("XM-A5G7-0404")
class ProgXM_A5G7(ADI_SPST):
    mfgPartName = "ADG902"
    XM_partName = "XM-A5G7-0404"
@partClass("XM-HMC1055-0409")
class ProgXM_HMC1055(HMC_SPST):
    mfgPartName = "HMC1055"
    XM_partName = "XM-HMC1055-0409"
class ADRF_Type2(ProgADRFXXXX):
    txtTable = ["EN", "CTRL"]
    nThrow = 3
    # RFC-RF1, RFC-RF2, Not Connected
    # 0:[0,1], 1:[0,0]
    swLbls = ["COM-P1", "COM-P2", "Not Connected"]
    optMaps = {0:[0, 0], 1:[0, 1], 2:[1, 0]}
    nPins = 2
@partClass("XM-A5M1-0409")
class ProgXM_A5M1(ADRF_Type2):
    mfgPartName = "ADRF5021"
    XM_partName = "XM-A5M1-0409"
@partClass("XM-A5M2-0409")
class ProgXM_A5M2(ADRF_Type2):
    mfgPartName = "ADRF5021"
    XM_partName = "XM-A5M2-0409"
@partClass("XM-A3R1-0409")
class ProgXM_A3R1(ADRF_Type2):
    mfgPartName = "ADRF5020"
    XM_partName = "XM-A3R1-0409"
@partClass("XM-A6F3-0409")
class ProgXM_A6F3(ADRF_Type2):
    mfgPartName = "ADRF5020"
    XM_partName = "XM-A6F3-0409"
@partClass("XM-ADRF5020*4-0808")
class ProgXM_4_ADRF5020(BaseProgPart):
    DevOnly = True
    mfgPartName = "ADRF5020"
    mfgName = "Analog Devices"
    catId = CAT_SWITCH
    ioType = IO_PIN
    XM_partName = "XM-ADRF5020*4-0808"
    lstGrids = [
        (GridLayout, "theLayout", dict(
            size_hint=(.8, .6), pos_hint={"center_x": .5, "top": .9},
            cols=2, rows=2, spacing=[5, 5], padding=[5] * 4), [
            (BorderedGridLayout, "gridGroup0", dict(cols=2, spacing=[5, 5], padding=[5] * 4), [
                (CheckBox, "radio0_0", {"allow_no_selection": True}), (Label, "lbl0_0", {"text": "RFC-RF1"}),
                (CheckBox, "radio0_1", {"allow_no_selection": True}), (Label, "lbl0_1", {"text": "RFC-RF2"})
            ]),
            (BorderedGridLayout, "gridGroup1", dict(cols=2, spacing=[5, 5], padding=[5] * 4), [
                (CheckBox, "radio1_0", {"allow_no_selection": True}), (Label, "lbl1_0", {"text": "RFC-RF1"}),
                (CheckBox, "radio1_1", {"allow_no_selection": True}), (Label, "lbl1_1", {"text": "RFC-RF2"})
            ]),
            (BorderedGridLayout, "gridGroup2", dict(cols=2, spacing=[5, 5], padding=[5] * 4), [
                (CheckBox, "radio2_0", {"allow_no_selection": True}), (Label, "lbl2_0", {"text": "RFC-RF1"}),
                (CheckBox, "radio2_1", {"allow_no_selection": True}), (Label, "lbl2_1", {"text": "RFC-RF2"})
            ]),
            (BorderedGridLayout, "gridGroup3", dict(cols=2, spacing=[5, 5], padding=[5] * 4), [
                (CheckBox, "radio3_0", {"allow_no_selection": True}), (Label, "lbl3_0", {"text": "RFC-RF1"}),
                (CheckBox, "radio3_1", {"allow_no_selection": True}), (Label, "lbl3_1", {"text": "RFC-RF2"})
            ])
        ]),
        (BorderedGridLayout, "binLayout", dict(
            size_hint=(.8, .1), pos_hint={'x':.2, "top":.2},
            cols=5, rows=2, spacing=[5, 5], padding=[5] * 4), [
            (Label, None, {"text": "Blank"}),
            (Label, None, {"text": "placeholder 0"}),
            (Label, None, {"text": "placeholder 1"}),
            (Label, None, {"text": "placeholder 2"}),
            (Label, None, {"text": "placeholder 3"}),
            (Label, None, {"text": "Binary Data"}),
            (Label, "bt0", {"text": "0"}),
            (Label, "bt1", {"text": "0"}),
            (Label, "bt2", {"text": "0"}),
            (Label, "bt3", {"text": "0"}),
        ])
    ]
    bitColors = (StrRGB("FFF") + (1,), StrRGB("F00") + (1,))
    nPins = 4
    def __init__(self, fl=None, ver=0):
        super(ProgXM_4_ADRF5020, self).__init__(fl, ver)
        self.data = [0, 0, 0, 0]
        self.oldData = [0, 0, 0, 0]

    def serialize(self, fl, ver):
        super(ProgXM_4_ADRF5020, self).serialize(fl, ver)

    def build(self, app):
        layout = super(ProgXM_4_ADRF5020, self).build(app)
        if not hasattr(self, "binLayout"): self.buildFirst()
        sizeY = .61
        posY = .93
        posY1 = posY - sizeY - .03
        layout.add_widget(self.theLayout)
        layout.add_widget(self.binLayout)
        self.layout = layout
        self.progBtn.pos_hint = {"top": posY1, 'x': .1}
        return layout

    def onhide(self, app):
        self.layout.remove_widget(self.theLayout)
        self.layout.remove_widget(self.binLayout)
        super(ProgXM_4_ADRF5020, self).onhide(app)

    def onClkChk(self, grpNum, IsPath1, obj, val):
        self.data[grpNum] = int(not (IsPath1 ^ val))
        self.onProgChg()

    def buildFirst(self):
        dctNamed = {}
        procLstGrid(dctNamed, self.lstGrids, None)
        self.binLayout = dctNamed["binLayout"]
        self.theLayout = dctNamed["theLayout"]
        self.lstBitLbls = [dctNamed["bt0"], dctNamed["bt1"], dctNamed["bt2"], dctNamed["bt3"]]
        self.lstChkBoxGroups = [
            (dctNamed["radio%u_0" % x], dctNamed["radio%u_1" % x])
            for x in xrange(4)]
        for c, (chk0, chk1) in enumerate(self.lstChkBoxGroups):
            chk0.group = chk0.parent
            chk1.group = chk1.parent
            chk0.bind(active=Bind(self.onClkChk, c, False))
            chk1.bind(active=Bind(self.onClkChk, c, True))

    def updateBinary(self):
        for c, bitLbl in enumerate(self.lstBitLbls):
            select = self.oldData[c] ^ self.data[c]
            bitLbl.color = self.bitColors[select]
            bitLbl.text = str(self.data[c])

    def programIt(self, obj=None):
        super(ProgXM_4_ADRF5020, self).programIt(obj)
        self.oldData = list(self.data)
        for pin, val in zip(self.pins, self.data):
            assert isinstance(pin, PinIO_Object)
            pin.value = val
        self.updateBinary()

    def onProgChg(self):
        super(ProgXM_4_ADRF5020, self).onProgChg()
        self.updateBinary()

class ProgHMC_Switch(BaseSwitch):
    mfgName = Hittite
    mfgPartName = "HMC****"
class HMC_Type1(ProgHMC_Switch):
    nPins = 2
    nThrow = 2
    txtTable = ["A", "B"]
    swLbls = ["RFC-RF1", "RFC-RF2"]
    optMaps = {0:[1, 0], 1:[0, 1]}
class HMC_Type2(ProgHMC_Switch):
    nPins = 2
    nThrow = 2
    txtTable = ["A", "B"]
    swLbls = ["RFC-RF1", "RFC-RF2"]
    optMaps = {0:[0, 1], 1:[1, 0]}
@partClass("XM-HMC427A-0409")
class ProgXM_HMC427A(HMC_Type2):
    XM_partName = "XM-HMC427A-0409"
    mfgPartName = "HMC427A"
    swLbls = ["RF4-RF2 & RF1-RF3", "RF4-RF1 & RF2-RF3"]
@partClass("XM-HMC199A-0409")
class ProgXM_HMC199A(HMC_Type1):
    XM_partName = "XM-HMC199A-0409"
    mfgPartName = "HMC199A"
    swLbls = ["RFC1-RFC2 (Bypass)", "RFC1-RF1 & RFC2-RF2"]
@partClass("XM-HMC435A-0409")
class ProgXM_HMC435A(HMC_Type1):
    XM_partName = "XM-HMC435A-0409"
    mfgPartName = "HMC435A"
@partClass("XM-A4F4-0404")
class ProgXM_A4F4(HMC_Type2):
    XM_partName = "XM-A4F4-0404"
    mfgPartName = "HMC986A"
    txtTable = ["V1", "V2"]
@partClass("XM-HMC547A-0409")
class ProgXM_HMC547A(HMC_Type1):
    XM_partName = "XM-HMC547A-0409"
    mfgPartName = "HMC547A"
@partClass("XM-A668-0409")
class ProgXM_A668(HMC_Type1):
    XM_partName = "XM-A668-0409"
    mfgPartName = "HMC347A"
@partClass("XM-HMC784A-0409")
class ProgXM_HMC784A(HMC_Type2):
    XM_partName = "XM-HMC784A-0409"
    mfgPartName = "HMC784A"
@partClass("XM-A6B3-0409")
class ProgXM_A6B3(HMC_Type2):
    XM_partName = "XM-A6B3-0409"
    mfgPartName = "HMC574A"
@partClass("XM-A659-0409")
class ProgXM_A659(HMC_Type1):
    XM_partName = "XM-A659-0409"
    mfgPartName = "HMC270A"
@partClass("XM-HMC544A-0409")
class ProgXM_HMC544A(HMC_Type2):
    XM_partName = "XM-HMC544A-0409"
    mfgPartName = "HMC544A"
class HMC_Type3(ProgHMC_Switch):
    txtTable = ["LS", "CTRL"]
    swLbls = ["RFC-RF1", "RFC-RF2"]
    optMaps = {0:[1, 0], 1:[1, 1]}
class HMC_Type4(ADRF_Type2):
    mfgName = Hittite
    mfgPartName = "HMC****"
class HMC_Type5(ADRF_Type1):
    mfgName = Hittite
    mfgPartName = "HMC****"
@partClass("XM-A6D5-0409")
class ProgXM_A6D5(HMC_Type4):
    XM_partName = "XM-A6D5-0409"
    mfgPartName = "HMC8038"
@partClass("XM-A645-0409")
class ProgXM_A645(HMC_Type3):
    XM_partName = "XM-A645-0409"
    mfgPartName = "HMC1118"
@partClass("XM-HMC232A-0409")
class ProgXM_HMC232A(HMC_Type1):
    XM_partName = "XM-HMC232A-0409"
    mfgPartName = "HMC232A"
@partClass("XM-HMC595A-0409")
class ProgXM_HMC595A(HMC_Type2):
    XM_partName = "XM-HMC595A-0409"
    mfgPartName = "HMC595A"
@partClass("XM-HMC221B-0409")
class ProgXM_HMC221B(HMC_Type2):
    XM_partName = "XM-HMC221B-0409"
    mfgPartName = "HMC221B"
@partClass("XM-HMC197B-0409")
class ProgXM_HMC197B(HMC_Type2):
    XM_partName = "XM-HMC197B-0409"
    mfgPartName = "HMC197B"
@partClass("XM-HMC190B-0409")
class ProgXM_HMC190B(HMC_Type2):
    XM_partName = "XM-HMC190B-0409"
    mfgPartName = "HMC190B"
@partClass("XM-HMC536-0409")
class ProgXM_HMC536(HMC_Type2):
    XM_partName = "XM-HMC536-0409"
    mfgPartName = "HMC536"
@partClass("XM-HMC349A-0409")
class ProgXM_HMC349A(HMC_Type4):
    XM_partName = "XM-HMC349A-0409"
    mfgPartName = "HMC349A"
@partClass("XM-HMC546-0409")
class ProgXM_HMC546(HMC_Type5):
    XM_partName = "XM-HMC546-0409"
    mfgPartName = "HMC546"
    swLbls = ["RFC-RF1/Tx", "RFC-RF2/Rx"]
@partClass("XM-HMC849A-0409")
class ProgXM_HMC849A(HMC_Type4):
    XM_partName = "XM-HMC849A-0409"
    mfgPartName = "HMC849A"
@partClass("XM-HMC_SDD112-0409")#-5V is low, +5V is high
class ProgXM_HMC_SDD112(HMC_Type2):
    XM_partName = "XM-HMC_SDD112-0409"
    mfgPartName = "HMC-SDD112"
@partClass("XM-HMC284A-0409")
class ProgXM_HMC284A(HMC_Type2):
    XM_partName = "XM-HMC284A-0409"
    mfgPartName = "HMC284A"
@partClass("XM-HMC194A-0409")
class ProgXM_HMC194A(HMC_Type2):
    XM_partName = "XM-HMC194A-0409"
    mfgPartName = "HMC194A"
@partClass("XM-HMC545A-0409")
class ProgXM_HMC545A(HMC_Type1):
    XM_partName = "XM-HMC545A-0409"
    mfgPartName = "HMC545A"
@partClass("XM-HMC646-0409")
class ProgXM_HMC646(HMC_Type5):
    swLbls = ["RFC-Tx", "RFC-Rx"]
    XM_partName = "XM-HMC646-0409"
    mfgPartName = "HMC646"

class HMC_Type6(ProgHMC_Switch):
    invBits = False
    nPins = 3
    nThrow = None
    txtTable = None
    swLbls = None
    defSW_Val = 0
    optMaps = None
    @staticmethod
    def txtTableFmt(c): return chr(ord('A') + c)
    @classmethod
    def initCls(cls, numBuses):
        if cls.nThrow is None: cls.nThrow = 2 ** cls.nPins
        if isinstance(cls.txtTableFmt, basestring):
            cls.txtTableFmt = cls.txtTableFmt.__mod__
        if cls.txtTable is None:
            cls.txtTable = map(cls.txtTableFmt, xrange(cls.nPins))
        if cls.swLbls is None:
            cls.swLbls = map("RFC-RF%u".__mod__, xrange(1, cls.nThrow+1))
        cls.swLbls.extend(["All Off"] * (2 ** cls.nPins - cls.nThrow))
        nVals = len(cls.swLbls)
        if cls.optMaps is None:
            cls.optMaps = {
                k: list(bitMapInt(k, cls.nPins)) for k in xrange(nVals)}
            if cls.invBits:
                for k in cls.optMaps:
                    cls.optMaps[k] = map(lambda x: int(not x), cls.optMaps[k])
        super(HMC_Type6, cls).initCls(numBuses)
@partClass("XM-HMC322A-0409")
class ProgXM_HMC322A(HMC_Type6):
    XM_partName = "XM-HMC322A-0409"
    mfgPartName = "HMC322A"
@partClass("XM-HMC321A-0409")
class ProgXM_HMC321A(HMC_Type6):
    XM_partName = "XM-HMC321A-0409"
    mfgPartName = "HMC321A"
@partClass("XM-HMC252A-0409")
class ProgXM_HMC252A(HMC_Type6):
    XM_partName = "XM-HMC252A-0409"
    mfgPartName = "HMC252A"
    nThrow = 6
@partClass("XM-HMC253A-0409")
class ProgXM_HMC253A(HMC_Type6):
    XM_partName = "XM-HMC253A-0409"
    mfgPartName = "HMC253A"
    invBits = True
@partClass("XM-A636-0409")
class ProgXM_A636(HMC_Type6):
    mfgName = "Analog Devices"
    XM_partName = "XM-A636-0409"
    mfgPartName = "ADRF5040"
    nPins = 2
    @staticmethod
    def txtTableFmt(c): return "V%u" % (c+1)
@partClass("XM-HMC344A-0409")
class ProgXM_HMC344A(HMC_Type6):
    XM_partName = "XM-HMC344A-0409"
    mfgPartName = "HMC344A"
    nPins = 2
    invBits = True
@partClass("XM-A656-0409")
class ProgXM_A656(HMC_Type6):
    XM_partName = "XM-A656-0409"
    mfgPartName = "HMC244A"
    nPins = 2
@partClass("XM-A6D4-0409")
class ProgXM_A6D4(HMC_Type6):
    XM_partName = "XM-A6D4-0409"
    mfgPartName = "HMC7992"
    nPins = 2
@partClass("XM-HMC345A-0409")
class ProgXM_HMC345A(HMC_Type6):
    XM_partName = "XM-HMC345A-0409"
    mfgPartName = "HMC345A"
    nPins = 2
@partClass("XM-HMC245A-0409")
class ProgXM_HMC245A(HMC_Type6):
    XM_partName = "XM-HMC245A-0409"
    mfgPartName = "HMC245A"
    nPins = 2
    nThrow = 3
@partClass("XM-A5U8-0409")
class ProgXM_A5U8(ProgHMC_Switch):#NOTE HIGH: [-5V,-2.75V];LOW: [-.25V,+1V]
    XM_partName = "XM-A5U8-0409"
    mfgPartName = "HMC1084"
    nPins = 4
    nThrow = 4
    txtTable = ["VC1", "VC2", "VC3", "VC4"]
    swLbls = ["RFC-RF1", "RFC-RF2", "RFC-RF3", "RFC-RF4"]
    optMaps = {
        0:[1,0,0,0],
        1:[0,1,0,0],
        2:[0,0,1,0],
        3:[0,0,0,1]}
@partClass("XM-A6C1-0409")
class ProgXM_A6C1(HMC_Type6):
    XM_partName = "XM-A6C1-0409"
    mfgPartName = "HMC641ALP4E"
    nPins = 2
    invBits = True
@partClass("XM-A5U5-0409")
class ProgXM_A5U5(HMC_Type6):
    XM_partName = "XM-A5U5-0409"
    mfgPartName = "HMC641ALC4"
    nPins = 2
    invBits = True
@partClass("XM-A654-0409")
class ProgXM_A654(HMC_Type6):
    XM_partName = "XM-A654-0409"
    mfgPartName = "HMC241ALP3E"
    nPins = 2
@partClass("XM-A655-0409")
class ProgXM_A655(HMC_Type6):
    XM_partName = "XM-A655-0409"
    mfgPartName = "HMC241AQS16E"
    nPins = 2
@partClass("XM-ADG904-0409")
class ProgXM_ADG904(ProgADRFXXXX):
    mfgPartName = "ADG904"
    XM_partName = "XM-ADG904-0409"
    txtTable = ["Not EN", "A0", "A1"]
    swLbls = ["RFC-RF1", "RFC-RF2", "RFC-RF3", "RFC-RF4", "All Off"]
    nThrow = 5
    nPins = 3
    optMaps = {
        0:[0, 0, 0],
        1:[0, 1, 0],
        2:[0, 0, 1],
        3:[0, 1, 1],
        4:[1, 0, 0]}
