#raise Exception("LOAD BLACKLIST")
from BaseADF_PLL import *
from math import log as logarithm
log_2 = lambda x: logarithm(x, 2)

log = None

@initFunc(__name__.replace("ProgramIt.", ""))
def init(progLog):
    global log
    log = progLog

class RegWithoutAddr(Register): # has a R/W bit default 0
    wordSz = 16
    ctlSz = 0
    addrSz = 7
    def __init__(self, addr, dualBit=-1):
        super(RegWithoutAddr, self).__init__(addr, dualBit)
        self[:] = 0
        self.addr = addr
        self.rwBit = 0
    def calcText(self):
        return "(0x%02X): 0x%s" % (self.regNum, self.toStr((self.wordSz + 3) / 4, False, 16))

    def spiWriteData(self, spiBus):
        nBits = self.addrSz + 1 + self.wordSz
        num = SimpleBitComp(
            [(0, 16), (16, 17), (17,)], nBits,
            self.word.num, self.rwBit, self.addr)
        spiWriteNum(num, nBits, spiBus)
        self.written()
class BorderedLabel(BorderBehavior, Label): pass

dBmCnv = "%.15gdBm"
dBmify = lambda x: isReservStr(dBmCnv, x)
@partClass("XM-~A6J8-0819")
class ProgXM_ADRF6720_27(PLL_CalPFD_Freq0, PLL_MainMod, PLL_IntFrac, BaseProgADF_PLL):
    mfgName = "Analog Devices"
    interface = "3-wire"
    catId = CAT_PLL_VCO
    XM_partName = "XM-~A6J8-0819"
    mfgPartName = "ADRF6720-27"
    DevOnly = True
    extraBindFuncs = {
        "addEnMaskLine": ("addSmallLine", "gridEnMask"),
        "addEnMaskChk": ("addSmallChkLine", "gridEnMask"),
        "mkSmEnMaskChk": ("addSmChkLine", "gridEnMask"),
        "mkSmEnMaskLst": ("addSmallLstLine", "gridEnMask"),
        "mkModChk": ("addChkLine", "gridMod"),
        "addModLine": ("addLine", "gridMod"),
        "addModLineM": ("addLineM", "gridMod"),
        "addModLst": ("addLstLine", "gridMod"),
        "addSmOtherLn": ("addSmallLine", "gridOther"),
        "mkSmCfgMdChk": ("addSmChkLine", "gridCfgMd"),
        "addCfgMdLst": ("addSmallLstLine", "gridCfgMd"),
        "addRefLst": ("addLstLine", "gridRef"),
        "addSmOtherLst": ("addSmallLstLine", "gridOther")
    }
    lstBindFuncs = dict(BaseProgADF_PLL.lstBindFuncs, **extraBindFuncs)
    #chk funs 7, 8, 9, 10
    lstChkFuncs = BaseProgADF_PLL.lstChkFuncs + [
        "addEnMaskChk", "mkSmEnMaskChk", "mkModChk", "mkSmCfgMdChk"]
    lstChkBigger = BaseProgADF_PLL.lstChkBigger + [7, 9]
    #line func 8, 9, 10, 11
    lstLineFuncs = BaseProgADF_PLL.lstLineFuncs + [
        "addEnMaskLine", "addModLine", "addModLineM", "addSmOtherLn"]
    lstLineBig = BaseProgADF_PLL.lstLineBig + [9, 10]
    #lst func 4, 5, 6, 7, 8
    lstLstFuncs = BaseProgADF_PLL.lstLstFuncs + [
        "mkSmEnMaskLst", "addModLst", "addCfgMdLst", "addRefLst", "addSmOtherLst"]
    lstLstBig = BaseProgADF_PLL.lstLstBig + [5, 7]
    lstDivModeOpts = {
        0b0: "Fractional",
        0b1: "Integer"}
    useFuncs = {
        "R_Freq": (2,"MHz",1),
        "PFD_Freq": (2,"MHz",0),
        "RF_Out": (0,"MHz",1),
        "SpaceCh": (9,"",0),
        "UsrSpaceCh": (9,"kHz",1),
        "NVal": (0,"",1),
        "OutFreq": (0,"MHz",0),
        #"PreScl": (5,),
        #"cntrRst": (2,"updReg4Dat"),
        #"bAutoCntrRst": (2,None),
        "UsrPFD_Freq": (2,"MHz",1),
        "WriteData": (11,1),
        "RegSel": (8,),
        "IntVal": (0,"",1),
        "DCOFF_I": (6,1),
        "LO_DRV_LVL": (3,),
        "DCOFF_Q": (6,1),
        "VTUNE_CTRL": (1,),
        "bDITH_EN": (8, 'updReg66Dat'),
        "bREF_BUF_EN": (8, 'updReg1Dat'),
        "bVCO_MASK": (8, 'updReg16Dat'),
        "bVCO_MUX_MASK": (8, 'updReg16Dat'),
        "bDIV_MASK": (8, 'updReg16Dat'),
        # renamed "REF": (3,),
        "R_Count": (7,),
        "bVCO_EN": (8, 'updReg1Dat'),
        "CP_BLEED": (2,),
        "POL_Q": (3,),
        "DivMode": (3,),
        "VCO_LDO_R2": (1,),
        "bMOD_EN": (8, 'updReg1Dat'),
        "MOD_BLEED": (2,),
        "CP_Scale": (2,),
        "VCO_LDO_R4": (1,),
        "bLO_1XVCO_MASK": (8, 'updReg16Dat'),
        "MOD_RSEL": (4,1),
        "bVCO_LDO_MASK": (8, 'updReg16Dat'),
        "bREF_BUF_MASK": (8, 'updReg16Dat'),
        "bLO_DRV1X_MASK": (8, 'updReg16Dat'),
        "DITH_MAG": (4,1),
        "ABLDLY": (1,),
        "bVCO_MUX_EN": (8, 'updReg1Dat'),
        "bLO_DRV1X_EN": (8, 'updReg1Dat'),
        "bMOD_MASK": (8, 'updReg16Dat'),
        "REF_MUX": (3,),
        "bDIV_EN": (8, 'updReg1Dat'),
        "bQUAD_DIV_EN": (8, 'updReg1Dat'),
        "I_LO": (6,1),
        "bLO_DRV2X_EN": (8, 'updReg1Dat'),
        "PFD_CLK_EDGE": (1,),
        "BAL_COUT": (3,),
        "VCO": (1, '...'),
        "bQUAD_DIV_MASK": (8, 'updReg16Dat'),
        "BAND": (4,1),
        "Q_LO": (6,1),
        "VCO_BAND_SRC": (1,),
        "PhDtcPol": (1,),
        "CP": (2,),
        "bVCO_LDO_EN": (8, 'updReg1Dat'),
        "Dither": (4,1),
        "bSoftReset": (2, 'updReg0Dat'),
        "bCP_EN": (8, 'updReg1Dat'),
        "FracVal": (0,"",1),
        "bLO_DRV2X_MASK": (8, 'updReg16Dat'),
        "POL_I": (3,),
        "bDIV8_EN": (8, 'updReg34Dat'),
        "CP_CTRL": (2,),
        "bDRVDIV2_EN": (8, 'updReg34Dat'),
        "bDIV4_EN": (8, 'updReg34Dat'),
        "bCP_MASK": (8, 'updReg16Dat'),
        "bLO_1XVCO_EN": (8, 'updReg1Dat'),
        "MOD_CSEL": (4,1),
        "BAL_CIN": (3,1),
        "ModVal": (9,"",1)}
    titles = {
        "R_Freq": ("Reference Freq",),
        "PFD_Freq": ("Actual PFD Freq",),
        "RF_Out": ("Desired Output Freq",),
        #"PreScl": ("Internal Prescaler",),
        #"cntrRst": ("Counter Reset",),
        #"bAutoCntrRst": ("Reset Counters on Write",),
        "SpaceCh": ("Actual Channel Spacing",),
        "OutFreq": ("Actual Output Freq",),
        "NVal": ("N = ", "N Value"),
        "UsrPFD_Freq": ("Desired PFD Freq",),
        "UsrSpaceCh": ("Desired Freq Step Size",),
        "RegSel": ("Select Register",),
        "WriteData": ("Enter Register Hex",),
        "IntVal": ("Integer Value",),
        "DCOFF_I": ('DCOFF_I',),
        "LO_DRV_LVL": ('LO_DRV_LVL',),
        "DCOFF_Q": ('DCOFF_Q',),
        "VTUNE_CTRL": ('VTUNE_CTRL',),
        "bDITH_EN": ('DITH_EN',),
        "bREF_BUF_EN": ('REF_BUF_EN',),
        "bVCO_MASK": ('VCO_MASK',),
        "bVCO_MUX_MASK": ('VCO_MUX_MASK',),
        "bDIV_MASK": ('DIV_MASK',),
        # renamed "REF": ('REF',),
        "R_Count": ("Ref Counter (R)",),
        "bVCO_EN": ('VCO_EN',),
        "CP_BLEED": ('CP_BLEED',),
        "POL_Q": ('POL_Q',),
        "DivMode": ('DivMode',),
        "VCO_LDO_R2": ('VCO_LDO_R2',),
        "bMOD_EN": ('MOD_EN',),
        "MOD_BLEED": ('MOD_BLEED',),
        "CP_Scale": ('CP_Scale',),
        "VCO_LDO_R4": ('VCO_LDO_R4',),
        "bLO_1XVCO_MASK": ('LO_1XVCO_MASK',),
        "MOD_RSEL": ('MOD_RSEL',),
        "bVCO_LDO_MASK": ('VCO_LDO_MASK',),
        "bREF_BUF_MASK": ('REF_BUF_MASK',),
        "bLO_DRV1X_MASK": ('LO_DRV1X_MASK',),
        "DITH_MAG": ('DITH_MAG',),
        "ABLDLY": ('ABDLY','Anti-Backlash Delay'),
        "bVCO_MUX_EN": ('VCO_MUX_EN',),
        "bLO_DRV1X_EN": ('LO_DRV1X_EN',),
        "bMOD_MASK": ('MOD_MASK',),
        "REF_MUX": ('REF_MUX',),
        "bDIV_EN": ('DIV_EN',),
        "bQUAD_DIV_EN": ('QUAD_DIV_EN',),
        "I_LO": ('I_LO',),
        "bLO_DRV2X_EN": ('LO_DRV2X_EN',),
        "PFD_CLK_EDGE": ('PFD_CLK_EDGE',),
        "BAL_COUT": ('BAL_COUT',),
        "VCO": ('VCO',),
        "bQUAD_DIV_MASK": ('QUAD_DIV_MASK',),
        "BAND": ('BAND',),
        "Q_LO": ('Q_LO',),
        "VCO_BAND_SRC": ('VCO_BAND_SRC',),
        "PhDtcPol": ("PFD_POLARITY", "Phase Detector Polarity"),
        "CP": ('CP',),
        "bVCO_LDO_EN": ('VCO_LDO_EN',),
        "Dither": ('DITH_VAL',),
        "bSoftReset": ('SOFT_RESET',),
        "bCP_EN": ('CP_EN',),
        "FracVal": ("Fractional Value",),
        "bLO_DRV2X_MASK": ('LO_DRV2X_MASK',),
        "POL_I": ('POL_I',),
        "bDIV8_EN": ('DIV8_EN',),
        "CP_CTRL": ('CP_CTRL',),
        "bDRVDIV2_EN": ('DRVDIV2_EN',),
        "bDIV4_EN": ('DIV4_EN',),
        "bCP_MASK": ('CP_MASK',),
        "bLO_1XVCO_EN": ('LO_1XVCO_EN',),
        "MOD_CSEL": ('MOD_CSEL',),
        "BAL_CIN": ('BAL_CIN',),
        "ModVal": ("Auxiliary Modulus",)}

    lstCP_ScaleOpts = {
        0b0001: u"250 \u03BCA", 0b0011: u"500 \u03BCA",
        0b0111: u"750 \u03BCA", 0b1111: u"1000 \u03BCA"}
    lstCPOpts = map(isReserv, ["Internal Charge Pump", "External Charge Pump"])
    lstCP_BLEEDOpts = map(isReserv, [
        u"%.6g \u03BCA" % ((15.625 * (x % 32)) * [1, -1][x//32]) for x in range(64)])
    # renamed lstREFOpts
    lstR_CountOpts = {
        0b000: u"\u00D72",
        0b001: u"\u00D71",
        0b010: u"\u00F72",
        0b011: u"\u00F74",
        0b100: u"\u00F78"}
    lstPhDtcPolOpts = map(isReserv, ["Positive", "Negative"])
    lstREF_MUXOpts = {
        0b000: u"LOCK_DET",
        0b001: u"VPTAT",
        0b010: u"REFCLK",
        0b011: u"REFCLK\u00F72",
        0b100: u"REFCLK\u00D72",
        0b101: u"REFCLK\u00F78",
        0b110: u"REFCLK\u00F74"}
    lstVCOOpts = {
        0b000: "4.6 GHz to About 4.71 GHz",
        0b001: "4.02 GHz to About 4.6 GHz",
        0b010: "3.5 GHz to About 4.02 GHz",
        0b011: "2.85 GHz to About 3.5 GHz",
        0b100: "External LO/VCO"}
    lstLO_DRV_LVLOpts = {
        0b00: "-5.8 dBm",
        0b01: "-1.0 dBm",
        0b10: "+2.2 dBm"}
    lstVCO_LDO_R2Opts = {
        x: "%u"%x for x in xrange(16)}
    lstVCO_LDO_R4Opts = {
        x: "%u" % x for x in xrange(16)}
    lstBAL_CINOpts = {
        0b0000: "Minimum Capacitance Value",
        0b1111: "Maximum Capacitance Value"}
    lstBAL_COUTOpts = {
        0b0000: "Minimum Capacitance Value",
        0b1111: "Maximum Capacitance Value"}
    lstPOL_IOpts = {
        0b01: "Inverted Q Channel Polarity",
        0b10: "Normal Polarity"
    }
    lstPOL_QOpts = {
        0b01: "Normal Polarity",
        0b10: "Inverted I Channel Polarity"
    }
    lstMOD_BLEEDOpts = {
        x: "%u" % x for x in xrange(8)}
    lstPFD_CLK_EDGEOpts = {
        0b00: "Divide and Reference Down Edge",
        0b01: "Divide Down Edge, Reference Up Edge",
        0b10: "Divide Up Edge, Reference Down Edge",
        0b11: "Divide and Reference Up Edge"}
    lstCP_CTRLOpts = {
        0b000: "Both On",
        0b001: "Pump Down",
        0b010: "Pump Up",
        0b011: "Tristate",
        0b100: "PFD"}
    lstABLDLYOpts = {
        0b00: "0 ns",
        0b01: "0.5 ns",
        0b10: "0.75 ns",
        0b11: "0.9 ns"}
    lstVCO_BAND_SRCOpts = {
        0b0: "Band Calibration Routine",
        0b1: "SPI"}
    lstVTUNE_CTRLOpts = {
        0b00: "Band Calibration Routine",
        0b01: "SPI"}

    DCOFF_Conv = MultipleDivConv(5, (int, str)).getConvTuple()
    lstTxtDatas = [
        ("R_Freq", "num", "%.15g"),
        ("UsrPFD_Freq", "num", "%.15g"),
        # renamed ('REF', 'lst'),
        ("R_Count", "lst"),
        ("PFD_Freq", "num", "%.15g"),
        ("RF_Out", "num", "%.15g"),
        ("NVal", "num", "%.17g"),
        ('FracVal', 'num'),
        ('IntVal', 'num'),
        ("OutFreq", "num", "%.15g"),
        ("UsrSpaceCh", "num", "%.15g"),
        ('ModVal', 'num'),
        ("SpaceCh", "num", Bind(unitHertz, e10=3,fmtBase="%.6g")),
        #("cntrRst", "chkCntrRst"),
        #("bSDReset", "chkSDReset"), ("bAutoCntrRst", "chkAutoCntrRst"),
        #("R_Count", "num"),
        #("IntVal", "num"), ("FracVal", "num"), ("ModVal", "num"),
        #("PreScl", "lst"),
        ('VCO_BAND_SRC', 'lst'),
        ('POL_I', 'lst'), ('POL_Q', 'lst'),
        ('I_LO', 'num'), ('Q_LO', 'num'),
        ('DCOFF_I', 'num', DCOFF_Conv[1]), ('DCOFF_Q', 'num', DCOFF_Conv[1]),
        ('BAL_CIN', 'lst'),
        ('BAL_COUT', 'lst'),
        ('DivMode', 'lst'),
        ('LO_DRV_LVL', 'lst'),
        ('REF_MUX', 'lst'),

        ('bVCO_LDO_EN', 'chkVCO_LDO_EN'),
        ('bVCO_LDO_MASK', 'chkVCO_LDO_MASK'),
        ('bCP_EN', 'chkCP_EN'),
        ('bCP_MASK', 'chkCP_MASK'),
        ('bDIV_EN', 'chkDIV_EN'),
        ('bDIV_MASK', 'chkDIV_MASK'),
        ('bVCO_EN', 'chkVCO_EN'),
        ('bVCO_MASK', 'chkVCO_MASK'),
        ('bREF_BUF_EN', 'chkREF_BUF_EN'),
        ('bREF_BUF_MASK', 'chkREF_BUF_MASK'),
        ('bVCO_MUX_EN', 'chkVCO_MUX_EN'),
        ('bVCO_MUX_MASK', 'chkVCO_MUX_MASK'),
        ('bLO_DRV1X_EN', 'chkLO_DRV1X_EN'),
        ('bLO_DRV1X_MASK', 'chkLO_DRV1X_MASK'),
        ('bLO_DRV2X_EN', 'chkLO_DRV2X_EN'),
        ('bLO_DRV2X_MASK', 'chkLO_DRV2X_MASK'),
        ('bQUAD_DIV_EN', 'chkQUAD_DIV_EN'),
        ('bQUAD_DIV_MASK', 'chkQUAD_DIV_MASK'),
        ('bMOD_EN', 'chkMOD_EN'),
        ('bMOD_MASK', 'chkMOD_MASK'),
        ('bLO_1XVCO_EN', 'chkLO_1XVCO_EN'),
        ('bLO_1XVCO_MASK', 'chkLO_1XVCO_MASK'),
        ('bDRVDIV2_EN', 'chkDRVDIV2_EN'),
        ('bDIV4_EN', 'chkDIV4_EN'),
        ('bDIV8_EN', 'chkDIV8_EN'),
        ('bDITH_EN', 'chkDITH_EN'),

        ('CP_Scale', 'lst'),
        ('CP', 'lst'),
        ('MOD_CSEL', 'num'),
        ('PFD_CLK_EDGE', 'lst'),
        ('VTUNE_CTRL', 'lst'),
        ('CP_CTRL', 'lst'),
        ('DITH_MAG', 'num'),
        ('MOD_RSEL', 'num'),
        ('PhDtcPol', 'lst'),
        ('VCO', 'lst'),
        ('bSoftReset', 'chkSoftReset'),
        ('BAND', 'num'),
        ('Dither', 'num'),
        ('VCO_LDO_R2', 'lst'),
        ('ABLDLY', 'lst'),
        ('VCO_LDO_R4', 'lst'),
        ('MOD_BLEED', 'lst'),
        ('CP_BLEED', 'lst'),
        ("RegSel", "lst"),
        ("WriteData", "num", "%04X")]
    regDatas = {
        "bSoftReset":[(0,0)],
        "bVCO_LDO_EN":[(1,1)], "bCP_EN":[(1,2)], "bDIV_EN":[(1,3)],
        "bVCO_EN":[(1,4)], "bREF_BUF_EN":[(1,5)], "bVCO_MUX_EN":[(1,6)],
        "bLO_DRV1X_EN":[(1,7)], "bLO_DRV2X_EN":[(1,8)], "bQUAD_DIV_EN":[(1,9)],
        "bMOD_EN":[(1,10)], "bLO_1XVCO_EN":[(1,11)],
        "numIntVal":[(2,0,11)], "selDivMode":[(2,11)],
        "numFracVal":[(3,0,16)],
        "numModVal":[(4,0,16)],
        "bVCO_LDO_MASK":[(0x10,1)], "bCP_MASK":[(0x10,2)], "bDIV_MASK":[(0x10,3)],
        "bVCO_MASK":[(0x10,4)], "bREF_BUF_MASK":[(0x10,5)], "bVCO_MUX_MASK":[(0x10,6)],
        "bLO_DRV1X_MASK":[(0x10,7)], "bLO_DRV2X_MASK":[(0x10,8)], "bQUAD_DIV_MASK":[(0x10,9)],
        "bMOD_MASK":[(0x10,10)], "bLO_1XVCO_MASK":[(0x10,11)],
        "selCP_BLEED":[(0x20,0,6)], "selCP_Scale":[(0x20,10,14)], "selCP":[(0x20,14)],
        # renamed: "selREF":[(0x21,0,3)],
        "selR_Count":[(0x21,0,3)],
        "selPhDtcPol":[(0x21,3)], "selREF_MUX":[(0x21,4,7)],
        "selVCO":[(0x22,0,3)], "bDIV4_EN":[(0x22,3)], "bDIV8_EN":[(0x22,4)],
        "bDRVDIV2_EN":[(0x22,5)], "selLO_DRV_LVL":[(0x22,6,8)],
        "selVCO_LDO_R2":[(0x22,8,12)], "selVCO_LDO_R4":[(0x22,12,16)],
        "selBAL_CIN":[(0x30,0,4)], "selBAL_COUT":[(0x30,4,8)],
        "numMOD_CSEL":[(0x31,0,6)], "numMOD_RSEL":[(0x31,6,13)],
        "numI_LO":[(0x32,0,4)], "numQ_LO":[(0x32,4,8)], "selPOL_I":[(0x32,8,10)],
        "selPOL_Q":[(0x32,10,12)], "selMOD_BLEED":[(0x32,12,15)],
        "numDCOFF_Q":[(0x33,0,8)], "numDCOFF_I":[(0x33,8,16)], # sign bit ints (not two's complement)
        "selPFD_CLK_EDGE":[(0x40,0,2)], "selCP_CTRL":[(0x40,2,5)], "selABLDLY":[(0x40,5,7)],
        "numDither":[(0x42,0), (0x43,0,16)], "numDITH_MAG":[(0x42,1,3)], "bDITH_EN":[(0x42,3)],
        #reg 0x43           here^^^^here
        "numBAND":[(0x45,0,7)], "selVCO_BAND_SRC":[(0x45,7)], "selVTUNE_CTRL":[(0x45,8,10)]}
    regDataFuncs = {
        "numDCOFF_I": signBitRegValFunc(8),
        "numDCOFF_Q": signBitRegValFunc(8),
    }
    lstEnterSets = [
        ("float", "R_Freq", (10.,600.), "updPFD_Freq"),
        ("float", "UsrPFD_Freq", (10.,260000.), "updPFD_Freq"),
        ("float", "RF_Out", (54.,13600.), "updAutoNOrder"),
        ("float", "UsrSpaceCh", (1.0,18000.), "updModSpace"),
        ("float", "NVal", (23.0,65536.), "updAutoNOrder"),
        ("lst", "R_Count", "updPFD_Freq"),
        #("lst", "PreScl", "updReg0Dat"),
        ("lst", "PhDtcPol", "updReg4Dat"),
        ("lst", "VCO_BAND_SRC", "updReg69Dat"),
        ("int", "ModVal", (2, 65535), "updModSpace"),
        ("lst", "POL_Q", "updReg50Dat"),
        ("lst", "CP_Scale", "updReg32Dat"),
        ("lst", "CP", "updReg32Dat"),
        ("int", "MOD_CSEL", (0, 63), "updReg49Dat"),
        ("lst", "POL_I", "updReg50Dat"),
        ("lst", "PFD_CLK_EDGE", "updReg64Dat"),
        ("lst", "VTUNE_CTRL", "updReg69Dat"),
        ("lst", "CP_CTRL", "updReg64Dat"),
        ("int", "I_LO", (0, 15), "updReg50Dat"),
        ("lst", "DivMode", "updReg2Dat"),
        ("int", "DITH_MAG", (0, 3), "updReg66Dat"),
        ("lst", "BAL_COUT", "updReg48Dat"),
        ("num", "DCOFF_I", (-127, 127), DCOFF_Conv, "updReg51Dat"),
        ("num", "DCOFF_Q", (-127, 127), DCOFF_Conv, "updReg51Dat"),
        ("int", "FracVal", (0, 65535), "updAutoNOrder"),
        ("int", "MOD_RSEL", (0, 127), "updReg49Dat"),
        ("lst", "PhDtcPol", "updReg33Dat"),
        ("lst", "REF_MUX", "updReg33Dat"),
        ("int", "Q_LO", (0, 15), "updReg50Dat"),
        ("lst", "VCO", "updReg34Dat"),
        ("lst", "LO_DRV_LVL", "updReg34Dat"),
        ("int", "IntVal", (0, 2047), "updAutoNOrder"),
        ("lst", "BAL_CIN", "updReg48Dat"),
        ("int", "BAND", (0, 127), "updReg69Dat"),
        ("int", "Dither", (0, 131071), "updDither"),
        ("lst", "VCO_LDO_R2", "updReg34Dat"),
        ("lst", "ABLDLY", "updReg64Dat"),
        ("lst", "VCO_LDO_R4", "updReg34Dat"),
        ("lst", "MOD_BLEED", "updReg50Dat"),
        ("lst", "CP_BLEED", "updReg32Dat"),
        ("lst", "RegSel", None),
        ("hex", "WriteData", (0, 65535), None)]
    lstRegSelOpts = {
        k: "R 0x%02X (%s)" % (k, name) for k, name in [
            (0x00, "SOFT_RESET"), (0x01, "ENABLES"), (0x02, "INT_DIV"),
            (0x03, "FRAC_DIV"), (0x04, "MOD_DIV"), (0x10, "ENBL_MASK"),
            (0x20, "CP_CTL"), (0x21, "PFD_CTL"), (0x22, "VCO_CTL"),
            (0x30, "BALUN_CTL"), (0x31, "MOD_LIN_CTL"), (0x32, "MOD_CTL0"),
            (0x33, "MOD_CTL1"), (0x40, "PFD_CP_CTL"), (0x42, "DITH_CTL1"),
            (0x43, "DITH_CTL2"), (0x45, "VCO_CTL2"), (0x49, "VCO_CTL3")]}
    defRegs = [
        0x000000, 0x01F67F, 0x02002C, 0x030128, 0x040600, 0x10F67F,
        0x200C26, 0x21000B, 0x222A03, 0x300000, 0x311101, 0x320900,
        0x330000, 0x400010, 0x42000E, 0x430000, 0x450000, 0x4914B4]
    #remove last 4 elements in list to restore defaults
    defData = {
        #"numR_Freq":122.88,"numUsrPFD_Freq":61.44,
        "numR_Freq":100.,"numUsrPFD_Freq":100.,"numPFD_Freq":100.0,
        "numRF_Out":5000.0,"numOutFreq":5000.0,"numNVal":50.0,
        "numWriteData":0, "bAutoFast": True, "bAutoADC": True,
        "numSpaceCh": 200.0,
        "numFreqADC":99.8003992015968,
        "numBldCur":75.0,
        "numTotalCalTm": 2829.42,
        "numPhaseTimeout": 0.01,
        "bAutoBld":True,"bAutoCntrRst":True,
        "numUsrSpaceCh":200.,"numMod1Val":2**24,
        "bAutoSelDiv":True, "selRegSel": 0}
    #defData["numSpaceCh"] = 1.1920928955078125e-05
    rangeVCO_Freq = (3400.,6800.)
    nRegs = 13
    defBoxStyle = dict(pos_hint={'x': 0.0, "top": 1.0}, size_hint_y=.08)
    defInnerTop = defBoxStyle["pos_hint"]["top"] - defBoxStyle["size_hint_y"]
    tabLayout = [
        ("Config Mode", "mainTab", (
            BorderedGridLayout, None, dict(cols=2, spacing=[10, 10], padding=[6]), [
                (Bordered, "layoutCfgMd", {}, [
                    (Label, None, dict(defBoxStyle, text="Configuration Mode")),
                    (GridLayout, "gridCfgMd", {
                        "pos_hint": {'x': 0.0, "top": defInnerTop}, "padding": [6],
                        "cols": 2, "size_hint": (1.0, defInnerTop), "spacing": [10, 10]})]),
                (Bordered, "layoutCfgInf", {}, [
                    (Label, None, dict(defBoxStyle, text="Configuration Info")),
                    (GridLayout, "gridCfgInf", {
                        "pos_hint": {'x': 0.0, "top": defInnerTop}, "padding": [6],
                        "cols": 1, "size_hint": (1.0, defInnerTop), "spacing": [10, 10]})])])),
        ("Main", "vcoTab", (
            GridSelFrameLayout, "gridMain", dict(
                rows=1, spacing=[10, 10], padding=[6], side_names=["VCO", "PFD", "Misc\n   /\nMOD"]), [
                (Bordered, "layoutMod", {}, [
                    (Label, None, dict(defBoxStyle, text="Channel Spacing (Misc/Mod)")),
                    (GridLayout, "gridMod", {
                        "pos_hint": {'x': 0.0, "top": defInnerTop}, "padding": [6],
                        "cols": 3, "size_hint": (1.0, defInnerTop), "spacing": [10, 10]})], -4),
                (Bordered, "layoutRef", {}, [
                    (Label, None, dict(defBoxStyle, text="Reference (PFD)")),
                    (GridLayout, "gridRef", {
                        "pos_hint": {'x': 0.0, "top": defInnerTop}, "padding": [6],
                        "cols": 3, "size_hint": (1.0, defInnerTop), "spacing": [10, 10]})], -4),
                (Bordered, "layoutVCO", {"size_hint_x": 1.2}, [
                    (Label, "lblNCntr", dict(defBoxStyle, text="N Counter (VCO)")),
                    (GridLayout, "gridVCO", {
                        "pos_hint": {'x': 0.0, "top": defInnerTop}, "padding": [6],
                        "cols": 3, "size_hint": (1.0, defInnerTop), "spacing": [10, 10]})], -4)])),
        ("Config 1", "cfgTab", (
            BorderedGridLayout, "gridCfg", dict(cols=4, spacing=[10, 10], padding=[20, 10, 5, 5]))),
        ("Enables/Mask", "enMaskTab", (
            BorderedGridLayout, "gridEnMask", dict(cols=8, spacing=[10, 10], padding=[20, 10, 5, 5]))),
        ("Charge Pump", "chrgTab", (
            BorderedGridLayout, "gridChrg", dict(cols=4, spacing=[10, 10], padding=[20, 10, 5, 5]))),
        ("IN/OUT/PWR", "outTab", (
            BorderedGridLayout, "gridOut", dict(cols=4, spacing=[10, 10], padding=[20, 10, 5, 5]))),
        ("History", "histTab", (
            BorderedGridLayout, "gridHist", dict(cols=1, spacing=[10, 10], padding=[5, 5, 5, 5]))),
        ("Other", "otherTab", (
            BorderedGridLayout, "gridOther", dict(cols=5, spacing=[10, 10], padding=[20, 10, 5, 5])))
    ]
    mkDefaultTabs = True
    def getBestDivIndex(self, rFreq, pfdFreq):
        return restrict(int(log_2(rFreq / pfdFreq * 2) + .5), 0, len(self.lstR_CountOpts))
    def calcPfdFreq(self, rFreq):
        return rFreq * [2, 1, .5, .25, .125][self.data.selR_Count]
    def updDither(self):
        self.updReg66Dat()
        self.updReg67Dat()
    def __init__(self, fl=None, ver=0):
        if not hasattr(self,"regs"):
            self.regs = {x: RegWithoutAddr(x) for x in [
                0x00, 0x01, 0x02, 0x03, 0x04, 0x10, 0x20, 0x21, 0x22,
                0x30, 0x31, 0x32, 0x33, 0x40, 0x42, 0x43, 0x45, 0x49]}
        #print self.data.__dict__.get("numR_Count", "Not Available")
        super(ProgXM_ADRF6720_27, self).__init__(fl, ver)
        self.buildFirst()
        self.tabNoWrite.add(self.otherTab)
        self.tabPanel.bind(current_tab=self.curTabEvt)
    def buildFirst(self):
        self.tabPanel = self.getTabPanel()
        defStyle = {"size_hint":(1.0,None), "height":32}
        dctLbls = {
            "AutoN": "Select the method of entering the N Counter value",
            "AutoMod": "Select the method of entering modulus",
            "AutoR": "Select the method of entering the R Counter value",
            "bAutoSelDiv": "check to auto select the RF Out divider",
            "CalOut": "select which output you want to calc. freq. for"
        }
        self.addCfgMdLbls(self.gridCfgInf, defStyle, dctLbls)
        self.fillGridHist()
        self.buildTxtData(True)
        #self.gridOther.add_widget(Label(text="",size_hint_x=None))
        self.gridOther.add_widget(Button(
            text=" Write Register ",on_release=self.writeReg,
            size_hint=(None, None), size=(152, 36)))
        #self.gridOther.add_widget(Label(text="",size_hint_x=None))
        #self.gridOther.add_widget(sizedButton(text=" Load Into Program ", on_release=self.loadReg))
        #self.gridOther.add_widget(Label(text="",size_hint_x=None))
        self.txtWriteData.size_hint_x = None
        self.txtWriteData.width = 100
        self.gridOther.add_widget(Button(
            text="Reset To Defaults", size_hint_x=None, width=140,
            on_release=self.resetToDefs, size_hint_y=None, height=36))
        #if hasattr(self, "inDivRF"): self.inDivRF.disabled = True
        self.loadTxtData()
        self.addThemRegs()
        for c in self.regs: self.updRegNDat(c)
        self.updAutoN()
        self.updAutoR()
        self.updAutoMod()
        self.updPFD_Freq()
    def setReg(self, regNum):
        addr = (regNum >> 16) & 0x7F
        self.regs[addr][:] = regNum & 0xFFFF
    defRegsPacker = DataPacker(DataArray(
        DataInt(3)))
    def dumpRegs(self):
        rtn = []
        for addr in self.regs:
            reg = self.regs[addr]
            for c in xrange(len(reg.dualLst)):
                reg.curReg = c
                rtn.append(reg.word.num|(addr<<16))
        return rtn
    def addThemRegs(self):
        self.binLayout = GridLayout(
            pos_hint={'y':.02, "right":.99},size_hint=(.79,.15),cols=6)
        for addr in sorted(self.regs):
            reg = self.regs[addr]
            reg.curReg = 0
            self.binLayout.add_widget(reg.build(BorderedLabel, bdr=0))
    def build(self, app):
        self.curLayout = super(ProgXM_ADRF6720_27, self).build(app)
        if not hasattr(self, "binLayout"):self.buildFirst()
        self.curLayout.add_widget(self.tabPanel)
        self.curLayout.add_widget(self.binLayout)
        self.progBtn.pos_hint={'y':0.045*app.defStyle["size_hint"][1],'x':.01}
    def onhide(self, app):
        self.curLayout.remove_widget(self.binLayout)
        self.curLayout.remove_widget(self.tabPanel)
        super(ProgXM_ADRF6720_27, self).onhide(app)
    #takes a regId 2-tuple of (index, reg.curReg) and formats it according to
    #  reg.isDual
    def fmtReg(self, regId, short=True):
        fmtStr = "R 0x%%02X %s %%u"
        if self.regs[regId[0]].isDual:
            fmtStr %= "ws" if short else "word select"
            fmtStr %= regId
        else:
            fmtStr = fmtStr[:9].replace("%%", "%")
            fmtStr %= regId[0]
        return fmtStr
    def writeReg(self, obj=None):
        addr = self.data.selRegSel
        num = self.data.numWriteData
        tmp = SimpleBitComp(
            [(0, 16), (16, 17), (17,)], 24, num, 0, addr)
        self.userLog.log("Directly writing 0x%06X (R 0x%02X, 0x%04X) to the part" % (tmp, addr, num))
        spiWriteNum(tmp, 24, self.spiBus) #HARD-CODED 24 bits
    def loadReg(self, obj=None):
        if self.data.numWriteData & 15 >= len(self.regs): return
        self.setReg(self.data.numWriteData)
        self.onProgChg()
        self.loadDataFromRegs()
        self.loadTxtData()
    def outputReg(self, x):
        supObj = super(ProgXM_ADRF6720_27, self)
        doIt = ("cntrRst" in self.data) and self.regHasAttr(x, "cntrRst")
        if doIt and self.data.bAutoCntrRst:
            self.data.cntrRst = True
            self.userLog.log("Counter Reset: 1")
            self.updRegAttrDat(["cntrRst"])
            supObj.outputReg(x)
            self.data.cntrRst = False
            self.userLog.log("Counter Reset: 0")
            self.updRegAttrDat(["cntrRst"])
            supObj.outputReg(x)
        else: supObj.outputReg(x)
    def programIt(self, obj=None):
        sortMap = {
            2: 0, # at reverse of beginning (end)
            3: 0,
            4: 0}
        defKey = 1
        seq = filter(lambda x: x[0] != 0, [(addr, 0) for addr in self.regs])
        seq = sorted(seq, key=lambda x: (sortMap.get(x[0], defKey), x))[::-1]
        numWait = 0
        strWait = ""
        lstPrn = map(self.fmtReg,seq)
        if "FreqADC" in self.titles:
            numWait = self.data.numPhaseTimeout * 16
            strWait = u"%.5g \u03BCs" % numWait
            lstPrn[-1:-1] = ["wait " + strWait]
        self.userLog.log("Sequence order: " + ", ".join(lstPrn))
        for x in seq:
            if x[0] == 0:
                if "FreqADC" in self.titles:
                    self.userLog.log("wait 16 ADC Cycles (%s)" % strWait)
                    time.sleep(numWait / 10000000)
            self.outputReg(x)
        super(ProgXM_ADRF6720_27, self).programIt(obj)