#raise Exception("LOAD BLACKLIST")
from BaseRegPart import *
from math import log as logarithm
def logBase2(x):
    return logarithm(x, 2)

log = None

@initFunc(__name__.replace("ProgramIt.", ""))
def init(progLog):
    # noinspection PyGlobalUndefined
    global log
    log = progLog

class PFD_Calc1(BasePFD_Calc):
    lstAutoROpts = map(isReserv, [
        "R Counter", "Desired PFD Frequency"
    ])
    def getBestDivIndex(self, rFreq, pfdFreq, context):
        """
        :param float|Decimal rFreq:
        :param float|Decimal pfdFreq:
        :param ProgXM_ADRF6720_27 context:
        :rtype: int|long
        """
        x = int(rFreq / pfdFreq * 2 + .5)
        n = x.bit_length()
        nOpts = len(context.lstR_CountOpts)
        rn = n
        if n >= nOpts:
            rn = n - 1
        elif n > 0:
            x0 = 1 << (n - 1)
            x1 = 1 << n
            a = x1 + x0 - 2 * x
            # let x = (2 * x1 + x0) / 3
            #  a = x1 + x0 - (4/3) * x1 - (2/3) * x0
            #  a = (-1/3) * x1 + (1/3) * x0
            #  since x1 > x0 and x is closer to x1; a < 0
            rn = n if a <= 0 else (n - 1)
        return restrict(rn, 0, nOpts - 1)
    def update(self, context):
        """
        :param ProgXM_ADRF6720_27 context:
        """
        names = self.names
        rFreq = self.getR_Freq(context)
        val = None
        if context.getData(names[0]):
            pfdFreq = context.getData(names[2]) * 10 ** self.pfdFreqShift
            val = self.getBestDivIndex(rFreq, pfdFreq, context)
            context.setData(names[1], val, DC_SYNCH)
        if val is None:
            val = context.getData(names[1])
        context.setData(
            names[3], (rFreq * (2, 1, 0.5, 0.25, 0.125)[val]) / 10 ** self.pfdFreqShift, DC_SYNCH)
thePFD_Calc1 = PFD_Calc1([
    "selAutoR", "selR_Count", "numUsrPFD_Freq", "numPFD_Freq", "numR_Freq"])

#dBmCnv = "%.15gdBm"
#dBmify = lambda x: isReservStr(dBmCnv, x)
@partClass("XM-A6J8-0819")
class ProgXM_ADRF6720_27(BaseProgWithRegs):
    mfgName = "Analog Devices"
    interface = "3-wire"
    catId = CAT_PLL_VCO
    XM_partName = "XM-A6J8-0819"
    mfgPartName = "ADRF6720-27"
    lstDivModeOpts = {
        0b0: "Fractional",
        0b1: "Integer"}

    lstCP_ScaleOpts = {
        0b0001: u"250 \u03BCA", 0b0011: u"500 \u03BCA",
        0b0111: u"750 \u03BCA", 0b1111: u"1000 \u03BCA"}
    lstCPOpts = map(isReserv, ["Internal Charge Pump", "External Charge Pump"])
    lstCP_BLEEDOpts = map(isReserv, [
        u"%.6g \u03BCA" % ((15.625 * (x % 32)) * [1, -1][x//32]) for x in range(64)])
    # renamed lstREFOpts
    lstR_CountOpts = {
        0b000: u"\u00D72",
        0b001: u"\u00D71",
        0b010: u"\u00F72",
        0b011: u"\u00F74",
        0b100: u"\u00F78"}
    lstPhDtcPolOpts = map(isReserv, ["Positive", "Negative"])
    lstREF_MUXOpts = {
        0b000: u"LOCK_DET",
        0b001: u"VPTAT",
        0b010: u"REFCLK",
        0b011: u"REFCLK\u00F72",
        0b100: u"REFCLK\u00D72",
        0b101: u"REFCLK\u00F78",
        0b110: u"REFCLK\u00F74"}
    lstVCOOpts = {
        0b000: "4.6 GHz to About 4.71 GHz",
        0b001: "4.02 GHz to About 4.6 GHz",
        0b010: "3.5 GHz to About 4.02 GHz",
        0b011: "2.85 GHz to About 3.5 GHz",
        0b100: "External LO/VCO"}
    lstLO_DRV_LVLOpts = {
        0b00: "-5.8 dBm",
        0b01: "-1.0 dBm",
        0b10: "+2.2 dBm"}
    lstVCO_LDO_R2Opts = {
        x: "%u"%x for x in xrange(16)}
    lstVCO_LDO_R4Opts = {
        x: "%u" % x for x in xrange(16)}
    lstBAL_CINOpts = {
        0b0000: "Minimum Capacitance Value",
        0b1111: "Maximum Capacitance Value"}
    lstBAL_COUTOpts = {
        0b0000: "Minimum Capacitance Value",
        0b1111: "Maximum Capacitance Value"}
    lstPOL_IOpts = {
        0b01: "Inverted Q Channel Polarity",
        0b10: "Normal Polarity"
    }
    lstPOL_QOpts = {
        0b01: "Normal Polarity",
        0b10: "Inverted I Channel Polarity"
    }
    lstMOD_BLEEDOpts = {
        x: "%u" % x for x in xrange(8)}
    lstPFD_CLK_EDGEOpts = {
        0b00: "Divide and Reference Down Edge",
        0b01: "Divide Down Edge, Reference Up Edge",
        0b10: "Divide Up Edge, Reference Down Edge",
        0b11: "Divide and Reference Up Edge"}
    lstCP_CTRLOpts = {
        0b000: "Both On",
        0b001: "Pump Down",
        0b010: "Pump Up",
        0b011: "Tristate",
        0b100: "PFD"}
    lstABLDLYOpts = {
        0b00: "0 ns",
        0b01: "0.5 ns",
        0b10: "0.75 ns",
        0b11: "0.9 ns"}
    lstVCO_BAND_SRCOpts = {
        0b0: "Band Calibration Routine",
        0b1: "SPI"}
    lstVTUNE_CTRLOpts = {
        0b00: "Band Calibration Routine",
        0b01: "SPI"}
    lstAutoROpts = thePFD_Calc1.lstAutoROpts
    lstAutoRInfs = thePFD_Calc1.lstAutoRInfs
    lstAutoModOpts = theMainModCalc.lstAutoModOpts
    lstAutoModInfs = theMainModCalc.lstAutoModInfs
    lstAutoNOpts = theIntFracCalc.lstAutoNOpts
    lstAutoNInfs = theIntFracCalc.lstAutoNInfs
    DCOFF_Conv = MultipleDivConv(5, (int, str)).getConvTuple()
    lstRegSelOpts = {
        k: "R 0x%02X (%s)" % (k, name) for k, name in [
            (0x00, "SOFT_RESET"), (0x01, "ENABLES"), (0x02, "INT_DIV"),
            (0x03, "FRAC_DIV"), (0x04, "MOD_DIV"), (0x10, "ENBL_MASK"),
            (0x20, "CP_CTL"), (0x21, "PFD_CTL"), (0x22, "VCO_CTL"),
            (0x30, "BALUN_CTL"), (0x31, "MOD_LIN_CTL"), (0x32, "MOD_CTL0"),
            (0x33, "MOD_CTL1"), (0x40, "PFD_CP_CTL"), (0x42, "DITH_CTL1"),
            (0x43, "DITH_CTL2"), (0x45, "VCO_CTL2"), (0x49, "VCO_CTL3")]}
    defRegs = [
        0x000000, 0x01F67F, 0x02002C, 0x030128, 0x040600, 0x10F67F,
        0x200C26, 0x21000B, 0x222A03, 0x300000, 0x311101, 0x320900,
        0x330000, 0x400010, 0x42000E, 0x430000, 0x450000, 0x4914B4]
    #remove last 4 elements in list to restore defaults
    defData = {
        #"numR_Freq":122.88,"numUsrPFD_Freq":61.44,
        "numR_Freq":100.,"numUsrPFD_Freq":100.,"numPFD_Freq":100.0,
        "numRF_Out":5000.0,"numOutFreq":5000.0,"numNVal":50.0,
        "numWriteData":0, "bAutoFast": True, "bAutoADC": True,
        "numSpaceCh": 200.0,
        "numFreqADC":99.8003992015968,
        "numBldCur":75.0,
        "numTotalCalTm": 2829.42,
        "numPhaseTimeout": 0.01,
        "bAutoBld":True,"bAutoCntrRst":True,
        "numUsrSpaceCh":200.,"numMod1Val":2**24,
        "bAutoSelDiv":True, "selRegSel": 0}
    #defData["numSpaceCh"] = 1.1920928955078125e-05
    rangeVCO_Freq = (3400.,6800.)
    nRegs = 13
    infoLabels = simplePllInfoLabels
    defBoxStyle = dict(pos_hint={'x': 0.0, "top": 1.0}, size_hint_y=.08)
    defInnerTop = defBoxStyle["pos_hint"]["top"] - defBoxStyle["size_hint_y"]
    tabLayout = [
        ("Config Mode", "mainTab", (
            BorderedGridLayout, None, dict(cols=2, spacing=[10, 10], padding=[6]), [
                (Bordered, "layoutCfgMd", {}, [
                    (Label, None, dict(defBoxStyle, text="Configuration Mode")),
                    (GridLayout, "gridCfgMd", {
                        "pos_hint": {'x': 0.0, "top": defInnerTop}, "padding": [6],
                        "cols": 2, "size_hint": (1.0, defInnerTop), "spacing": [10, 10]})]),
                (Bordered, "layoutCfgInf", {}, [
                    (Label, None, dict(defBoxStyle, text="Configuration Info")),
                    (GridLayout, "gridCfgInf", {
                        "pos_hint": {'x': 0.0, "top": defInnerTop}, "padding": [6],
                        "cols": 1, "size_hint": (1.0, defInnerTop), "spacing": [10, 10]})])])),
        ("Main", "vcoTab", (
            GridSelFrameLayout, "gridMain", dict(
                rows=1, spacing=[10, 10], padding=[6], side_names=["VCO", "PFD", "Misc\n   /\nMOD"]), [
                (Bordered, "layoutMod", {}, [
                    (Label, None, dict(defBoxStyle, text="Channel Spacing (Misc/Mod)")),
                    (GridLayout, "gridMod", {
                        "pos_hint": {'x': 0.0, "top": defInnerTop}, "padding": [6],
                        "cols": 2, "size_hint": (1.0, defInnerTop), "spacing": [10, 10]})], -4),
                (Bordered, "layoutRef", {}, [
                    (Label, None, dict(defBoxStyle, text="Reference (PFD)")),
                    (GridLayout, "gridRef", {
                        "pos_hint": {'x': 0.0, "top": defInnerTop}, "padding": [6],
                        "cols": 2, "size_hint": (1.0, defInnerTop), "spacing": [10, 10]})], -4),
                (Bordered, "layoutVCO", {"size_hint_x": 1.2}, [
                    (Label, "lblNCntr", dict(defBoxStyle, text="N Counter (VCO)")),
                    (GridLayout, "gridVCO", {
                        "pos_hint": {'x': 0.0, "top": defInnerTop}, "padding": [6],
                        "cols": 2, "size_hint": (1.0, defInnerTop), "spacing": [10, 10]})], -4)])),
        ("Config 1", "cfgTab", (
            BorderedGridLayout, "gridCfg", dict(cols=4, spacing=[10, 10], padding=[20, 10, 5, 5]))),
        ("Enables/Mask", "enMaskTab", (
            BorderedGridLayout, "gridEnMask", dict(cols=8, spacing=[10, 10], padding=[20, 10, 5, 5]))),
        ("Charge Pump", "chrgTab", (
            BorderedGridLayout, "gridChrg", dict(cols=4, spacing=[10, 10], padding=[20, 10, 5, 5]))),
        ("IN/OUT/PWR", "outTab", (
            BorderedGridLayout, "gridOut", dict(cols=4, spacing=[10, 10], padding=[20, 10, 5, 5]))),
        ("History", "histTab", (
            BorderedGridLayout, "gridHist", dict(cols=1, spacing=[10, 10], padding=[5, 5, 5, 5]))),
        ("Other", "otherTab", (
            BorderedGridLayout, "gridOther", dict(cols=5, spacing=[10, 10], padding=[20, 10, 5, 5])))
    ]
    mkDefaultTabs = True
    lstDataEntries = [
        (
            InfoListUserDataView(
                "selAutoN", lstAutoNOpts, lstAutoNInfs, theInfoListMaker, False,
                "Autoset N From", "Autoset N From"
            ),
            "gridCfgMd"
        ),
        (
            InfoListUserDataView(
                "selAutoMod", lstAutoModOpts, lstAutoModInfs, theInfoListMaker, False,
                "Autoset Modulus", "Autoset Modulus"
            ),
            "gridCfgMd"
        ),
        (
            InfoListUserDataView(
                "selAutoR", lstAutoROpts, lstAutoRInfs, theInfoListMaker, False,
                "Autoset R", "Autoset R"
            ),
            "gridCfgMd"
        ),
        (
            NumberUserDataView(
                "numR_Freq", theDecUFloatMakerBig, (float, fromFloat), (10.0, 600.0),
                "Reference Freq", "Reference Freq", "MHz"
            ),
            "gridRef"
        ),
        (
            NumberUserDataView(
                "numUsrPFD_Freq", theDecUFloatMakerBig, (float, fromFloat), (10.0, 260000.0),
                "Desired PFD Freq", "Desired PFD Freq", "MHz"
            ),
            "gridRef"
        ),
        (
            ListUserDataView(
                "selR_Count", lstR_CountOpts, theListMaker, False,
                "Ref Counter (R)", "Ref Counter (R)"
            ).setUpstream(RegisterDownstream([(33, 0, 3)])),
            "gridRef"
        ),
        (
            NumberUserDataView(
                "numPFD_Freq", None, (None, getFormatFn("%.15g")), None,
                "Actual PFD Freq", "Actual PFD Freq", "MHz", True
            ),
            "gridRef"
        ),
        (
            NumberUserDataView(
                "numRF_Out", theDecUFloatMakerBig, (float, fromFloat), (54.0, 13600.0),
                "Desired Output Freq", "Desired Output Freq", "MHz"
            ),
            "gridVCO"
        ),
        (
            NumberUserDataView(
                "numNVal", theDecUFloatMakerBig, (float, fromFloat), (23.0, 65536.0),
                "N Value", "N = ", None
            ),
            "gridVCO"
        ),
        (
            NumberUserDataView(
                "numFracVal", theDecUIntMaker, (int, str), (0, 65535),
                "Fractional Value", "Fractional Value", None
            ).setUpstream(RegisterDownstream([(3, 0, 16)])),
            "gridVCO"
        ),
        (
            NumberUserDataView(
                "numIntVal", theDecUIntMaker, (int, str), (0, 2047),
                "Integer Value", "Integer Value", None
            ).setUpstream(RegisterDownstream([(2, 0, 11)])),
            "gridVCO"
        ),
        (
            NumberUserDataView(
                "numOutFreq", None, (None, getFormatFn("%.15g")), None,
                "Actual Output Freq", "Actual Output Freq", "MHz", True
            ),
            "gridVCO"
        ),
        (
            NumberUserDataView(
                "numUsrSpaceCh", theDecUFloatMakerBig, (float, fromFloat), (1.0, 18000.0),
                "Desired Freq Step Size", "Desired Freq Step Size", "kHz"
            ),
            "gridMod"
        ),
        (
            NumberUserDataView(
                "numModVal", theDecUIntMaker, (int, str), (2, 65535),
                "Auxiliary Modulus", "Auxiliary Modulus", None
            ).setUpstream(RegisterDownstream([(4, 0, 16)])),
            "gridMod"
        ),
        (
            NumberUserDataView(
                "numSpaceCh", None, (None, Bind(unitHertz, e10=3,fmtBase="%.6g")), None,
                "Actual Channel Spacing", "Actual Channel Spacing", None, True
            ),
            "gridMod"
        ),
        (
            ListUserDataView(
                "selVCO_BAND_SRC", lstVCO_BAND_SRCOpts, theListMaker, False,
                "VCO_BAND_SRC", "VCO_BAND_SRC"
            ).setUpstream(RegisterDownstream([(69, 7)])),
            "gridCfg"
        ),
        (
            ListUserDataView(
                "selPOL_I", lstPOL_IOpts, theListMaker, False,
                "POL_I", "POL_I"
            ).setUpstream(RegisterDownstream([(50, 8, 10)])),

            "gridOut"
        ),
        (
            ListUserDataView(
                "selPOL_Q", lstPOL_QOpts, theListMaker, False,
                "POL_Q", "POL_Q"
            ).setUpstream(RegisterDownstream([(50, 10, 12)])),

            "gridOut"
        ),
        (
            NumberUserDataView(
                "numI_LO", theDecUIntMaker, (int, str), (0, 15),
                "I_LO", "I_LO", None
            ).setUpstream(RegisterDownstream([(50, 0, 4)])),

            "gridOut"
        ),
        (
            NumberUserDataView(
                "numQ_LO", theDecUIntMaker, (int, str), (0, 15),
                "Q_LO", "Q_LO", None
            ).setUpstream(RegisterDownstream([(50, 4, 8)])),

            "gridOut"
        ),
        (
            NumberUserDataView(
                "numDCOFF_I", theDecSIntMaker, DCOFF_Conv, (-127, 127),
                "DCOFF_I", "DCOFF_I", None
            ).setUpstream(RegisterDownstream([(51, 8, 16)], *signBitRegValFunc(8))),
            "gridOut"
        ),
        (
            NumberUserDataView(
                "numDCOFF_Q", theDecSIntMaker, DCOFF_Conv, (-127, 127),
                "DCOFF_Q", "DCOFF_Q", None
            ).setUpstream(RegisterDownstream([(51, 0, 8)], *signBitRegValFunc(8))),
            "gridOut"
        ),
        (
            ListUserDataView(
                "selBAL_CIN", lstBAL_CINOpts, theListMaker, False,
                "BAL_CIN", "BAL_CIN"
            ).setUpstream(RegisterDownstream([(48, 0, 4)])),
            "gridOut"
        ),
        (
            ListUserDataView(
                "selBAL_COUT", lstBAL_COUTOpts, theListMaker, False,
                "BAL_COUT", "BAL_COUT"
            ).setUpstream(RegisterDownstream([(48, 4, 8)])),
            "gridOut"
        ),
        (
            ListUserDataView(
                "selDivMode", lstDivModeOpts, theListMaker, False,
                "DivMode", "DivMode"
            ).setUpstream(RegisterDownstream([(2, 11)])),
            "gridOut"
        ),
        (
            ListUserDataView(
                "selLO_DRV_LVL", lstLO_DRV_LVLOpts, theListMaker, False,
                "LO_DRV_LVL", "LO_DRV_LVL"
            ).setUpstream(RegisterDownstream([(34, 6, 8)])),
            "gridOut"
        ),
        (
            ListUserDataView(
                "selREF_MUX", lstREF_MUXOpts, theListMaker, False,
                "REF_MUX", "REF_MUX"
            ).setUpstream(RegisterDownstream([(33, 4, 7)])),
            "gridOut"
        ),
        (
            ChkBoxUserDataView(
                "bVCO_LDO_EN",
                "VCO_LDO_EN"
            ).setUpstream(RegisterDownstream([(1, 1)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bVCO_LDO_MASK",
                "VCO_LDO_MASK"
            ).setUpstream(RegisterDownstream([(16, 1)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bCP_EN",
                "CP_EN"
            ).setUpstream(RegisterDownstream([(1, 2)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bCP_MASK",
                "CP_MASK"
            ).setUpstream(RegisterDownstream([(16, 2)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bDIV_EN",
                "DIV_EN"
            ).setUpstream(RegisterDownstream([(1, 3)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bDIV_MASK",
                "DIV_MASK"
            ).setUpstream(RegisterDownstream([(16, 3)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bVCO_EN",
                "VCO_EN"
            ).setUpstream(RegisterDownstream([(1, 4)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bVCO_MASK",
                "VCO_MASK"
            ).setUpstream(RegisterDownstream([(16, 4)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bREF_BUF_EN",
                "REF_BUF_EN"
            ).setUpstream(RegisterDownstream([(1, 5)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bREF_BUF_MASK",
                "REF_BUF_MASK"
            ).setUpstream(RegisterDownstream([(16, 5)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bVCO_MUX_EN",
                "VCO_MUX_EN"
            ).setUpstream(RegisterDownstream([(1, 6)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bVCO_MUX_MASK",
                "VCO_MUX_MASK"
            ).setUpstream(RegisterDownstream([(16, 6)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bLO_DRV1X_EN",
                "LO_DRV1X_EN"
            ).setUpstream(RegisterDownstream([(1, 7)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bLO_DRV1X_MASK",
                "LO_DRV1X_MASK"
            ).setUpstream(RegisterDownstream([(16, 7)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bLO_DRV2X_EN",
                "LO_DRV2X_EN"
            ).setUpstream(RegisterDownstream([(1, 8)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bLO_DRV2X_MASK",
                "LO_DRV2X_MASK"
            ).setUpstream(RegisterDownstream([(16, 8)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bQUAD_DIV_EN",
                "QUAD_DIV_EN"
            ).setUpstream(RegisterDownstream([(1, 9)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bQUAD_DIV_MASK",
                "QUAD_DIV_MASK"
            ).setUpstream(RegisterDownstream([(16, 9)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bMOD_EN",
                "MOD_EN"
            ).setUpstream(RegisterDownstream([(1, 10)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bMOD_MASK",
                "MOD_MASK"
            ).setUpstream(RegisterDownstream([(16, 10)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bLO_1XVCO_EN",
                "LO_1XVCO_EN"
            ).setUpstream(RegisterDownstream([(1, 11)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bLO_1XVCO_MASK",
                "LO_1XVCO_MASK"
            ).setUpstream(RegisterDownstream([(16, 11)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bDRVDIV2_EN",
                "DRVDIV2_EN"
            ).setUpstream(RegisterDownstream([(34, 5)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bDIV4_EN",
                "DIV4_EN"
            ).setUpstream(RegisterDownstream([(34, 3)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bDIV8_EN",
                "DIV8_EN"
            ).setUpstream(RegisterDownstream([(34, 4)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bDITH_EN",
                "DITH_EN"
            ).setUpstream(RegisterDownstream([(66, 3)])),
            "gridEnMask"
        ),
        (
            ListUserDataView(
                "selCP_Scale", lstCP_ScaleOpts, theListMaker, False,
                "CP_Scale", "CP_Scale"
            ).setUpstream(RegisterDownstream([(32, 10, 14)])),
            "gridChrg"
        ),
        (
            ListUserDataView(
                "selCP", lstCPOpts, theListMaker, False,
                "CP", "CP"
            ).setUpstream(RegisterDownstream([(32, 14)])),
            "gridChrg"
        ),
        (
            NumberUserDataView(
                "numMOD_CSEL", theDecUIntMaker, (int, str), (0, 63),
                "MOD_CSEL", "MOD_CSEL", None
            ).setUpstream(RegisterDownstream([(49, 0, 6)])),
            "gridCfg"
        ),
        (
            ListUserDataView(
                "selPFD_CLK_EDGE", lstPFD_CLK_EDGEOpts, theListMaker, False,
                "PFD_CLK_EDGE", "PFD_CLK_EDGE"
            ).setUpstream(RegisterDownstream([(64, 0, 2)])),
            "gridCfg"
        ),
        (
            ListUserDataView(
                "selVTUNE_CTRL", lstVTUNE_CTRLOpts, theListMaker, False,
                "VTUNE_CTRL", "VTUNE_CTRL"
            ).setUpstream(RegisterDownstream([(69, 8, 10)])),
            "gridCfg"
        ),
        (
            ListUserDataView(
                "selCP_CTRL", lstCP_CTRLOpts, theListMaker, False,
                "CP_CTRL", "CP_CTRL"
            ).setUpstream(RegisterDownstream([(64, 2, 5)])),
            "gridChrg"
        ),
        (
            NumberUserDataView(
                "numDITH_MAG", theDecUIntMaker, (int, str), (0, 3),
                "DITH_MAG", "DITH_MAG", None
            ).setUpstream(RegisterDownstream([(66, 1, 3)])),
            "gridCfg"
        ),
        (
            NumberUserDataView(
                "numMOD_RSEL", theDecUIntMaker, (int, str), (0, 127),
                "MOD_RSEL", "MOD_RSEL", None
            ).setUpstream(RegisterDownstream([(49, 6, 13)])),
            "gridCfg"
        ),
        (
            ListUserDataView(
                "selPhDtcPol", lstPhDtcPolOpts, theListMaker, False,
                "Phase Detector Polarity", "PFD_POLARITY"
            ).setUpstream(RegisterDownstream([(33, 3)])),
            "gridCfg"
        ),
        (
            ListUserDataView(
                "selVCO", lstVCOOpts, theListMaker, False,
                "VCO", "VCO"
            ).setUpstream(RegisterDownstream([(34, 0, 3)])),
            "gridCfg"
        ),
        (
            ChkBoxUserDataView(
                "bSoftReset",
                "SOFT_RESET"
            ).setUpstream(RegisterDownstream([(0, 0)])),
            "gridCfg"
        ),
        (
            NumberUserDataView(
                "numBAND", theDecUIntMaker, (int, str), (0, 127),
                "BAND", "BAND", None
            ).setUpstream(RegisterDownstream([(69, 0, 7)])),
            "gridCfg"
        ),
        (
            NumberUserDataView(
                "numDither", theDecUIntMaker, (int, str), (0, 131071),
                "DITH_VAL", "DITH_VAL", None
            ).setUpstream(RegisterDownstream([(66, 0), (67, 0, 16)])),
            "gridCfg"
        ),
        (
            ListUserDataView(
                "selVCO_LDO_R2", lstVCO_LDO_R2Opts, theListMaker, False,
                "VCO_LDO_R2", "VCO_LDO_R2"
            ).setUpstream(RegisterDownstream([(34, 8, 12)])),
            "gridCfg"
        ),
        (
            ListUserDataView(
                "selABLDLY", lstABLDLYOpts, theListMaker, False,
                "Anti-Backlash Delay", "ABDLY"
            ).setUpstream(RegisterDownstream([(64, 5, 7)])),
            "gridCfg"
        ),
        (
            ListUserDataView(
                "selVCO_LDO_R4", lstVCO_LDO_R4Opts, theListMaker, False,
                "VCO_LDO_R4", "VCO_LDO_R4"
            ).setUpstream(RegisterDownstream([(34, 12, 16)])),
            "gridCfg"
        ),
        (
            ListUserDataView(
                "selMOD_BLEED", lstMOD_BLEEDOpts, theListMaker, False,
                "MOD_BLEED", "MOD_BLEED"
            ).setUpstream(RegisterDownstream([(50, 12, 15)])),
            "gridChrg"
        ),
        (
            ListUserDataView(
                "selCP_BLEED", lstCP_BLEEDOpts, theListMaker, False,
                "CP_BLEED", "CP_BLEED"
            ).setUpstream(RegisterDownstream([(32, 0, 6)])),
            "gridChrg"
        ),
        (
            ListUserDataView(
                "selRegSel", lstRegSelOpts, theListMaker, False,
                "Select Register", "Select Register"
            ),
            "gridOther"
        ),
        (
            NumberUserDataView(
                "numWriteData", theHexUIntMaker, (fromHexStr, getFormatFn("%04X")), (0, 65535),
                "Enter Register Hex", "Enter Register Hex", None
            ),
            "gridOther"
        )
    ]
    regAddrsInSequence = [
        0x02, 0x03, 0x04, 0x01, 0x10, 0x20, 0x21, 0x22, 0x30, 
        0x31, 0x32, 0x33, 0x40, 0x42, 0x43, 0x45, 0x49, 0x00][::-1]
    regDuals = dict.fromkeys(regAddrsInSequence, -1)
    regMaker = RegWithoutAddr
    regCtlSz = regMaker.ctlSz
    regWordSz = regMaker.wordSz
    #cntrRstName = "cntrRst"
    #autoCntrRstName = "bAutoCntrRst"
    addUserLog = "gridHist"
    binLayoutClsName = "GridLayout"
    binLayoutStyle = dict(pos_hint={'y': .02, "right": .99}, size_hint=(.79, .15), cols=6)
    dctCalcSystemUpd = {
        "numR_Freq": ("AutoR", False),
        "selR_Count": ("AutoR", False),
        "numUsrPFD_Freq": ("AutoR", False),
        "numUsrSpaceCh": ("AutoMod", False),
        "numModVal": ("AutoMod", False),
        "numRF_Out": ("AutoN", False),
        "numNVal": ("AutoN", False),
        "numIntVal": ("AutoN", False),
        "numFracVal": ("AutoN", False),
        "selAutoR": ("AutoR", True),
        "selAutoMod": ("AutoMod", True),
        "selAutoN": ("AutoN", True),
    }
    calcSystems = {
        "AutoR": (thePFD_Calc1, "AutoMod"),
        "AutoMod": (theMainModCalc, "AutoN"),
        "AutoN": theIntFracCalc,
    }
    defRegsPacker = DataPacker(DataArray(
        DataInt(3)))

    # self.tabNoWrite.add(self.otherTab);self.tabPanel.bind(current_tab=self.curTabEvt)
    # self.gridOther.add_widget(Button(text=" Write Register ",on_release=self.writeReg, size_hint=(None, None), size=(152, 36)))
    # self.txtWriteData.size_hint_x = None
    # self.txtWriteData.width = 100
    # self.gridOther.add_widget(Button(text="Reset To Defaults", size_hint_x=None, width=140, on_release=self.resetToDefs, size_hint_y=None, height=36))
    # self.progBtn.pos_hint={'y':0.045*app.defStyle["size_hint"][1],'x':.01}

    tabNameNoWrite = {"otherTab"}

    def postBuildFirst(self):
        self.dctNamed["gridOther"].add_widget(Button(text="Write Register", on_release=self.writeSingleReg))
    def addAllRegs(self, binLayout):
        """
        :param Layout binLayout:
        """
        for regId in sorted(self.regAddrsInSequence[::-1]):
            binLayout.add_widget(self.getReg(regId).build(BorderedLabel, bdr=0, bdo=0))

    #takes a regId 2-tuple of (index, reg.curReg) and formats it according to
    #  reg.isDual
    @staticmethod
    def fmtReg(regId, short=True):
        """
        :param int|long|(int|long, int|long) regId:
        :param bool short:
        :rtype: str|unicode
        """
        if isinstance(regId, (int, long)):
            return "R 0x%02X" % regId
        elif short:
            return "R 0x%02X ws %u" % (regId[0], regId[1])
        else:
            return "R 0x%02X word select %u" % (regId[0], regId[1])
    '''def writeReg(self, obj=None):
        addr = self.getData("selRegSel")
        num = self.getData("numWriteData")
        tmp = SimpleBitComp(
            [(0, 16), (16, 17), (17,)], 24, num, 0, addr)
        self.userLog.log("Directly writing 0x%06X (R 0x%02X, 0x%04X) to the part" % (tmp, addr, num))
        spiWriteNum(tmp, 24, self.spiBus) #HARD-CODED 24 bits'''
    def getWriteRegSequence(self):
        return self.regAddrsInSequence