#raise Exception("LOAD BLACKLIST")
from BaseRegPart import *


log = None

@initFunc(__name__.replace("ProgramIt.", ""))
def init(progLog):
    # noinspection PyGlobalUndefined
    global log
    log = progLog



#dBmCnv = "%.15gdBm"
#dBmify = lambda x: isReservStr(dBmCnv, x)
@partClass("XM-A638-0819")
class ProgXM_ADRF6780(BaseProgWithRegs):
    mfgName = "Analog Devices"
    interface = "3-wire"
    catId = CAT_CNV_UP_DN
    XM_partName = "XM-A638-0819"
    mfgPartName = "ADRF6780"
    defRegs = [
        0x000075, 0x02FFFF, 0x030157,
        0x040080, 0x050000, 0x060000]
    #remove last 4 elements in list to restore defaults
    defData = {}
    nRegs = 6
    defBoxStyle = dict(pos_hint={'x': 0.0, "top": 1.0}, size_hint_y=.08)
    defInnerTop = defBoxStyle["pos_hint"]["top"] - defBoxStyle["size_hint_y"]
    tabLayout = [
        ("Config", "cfgTab", (
            BorderedGridLayout, "gridCfg", dict(cols=4, spacing=[10, 10], padding=[20, 10, 5, 5]))),
        ("Enables/Mask", "enMaskTab", (
            BorderedGridLayout, "gridEnMask", dict(cols=6, spacing=[10, 10], padding=[20, 10, 5, 5]))),
        ("History", "histTab", (
            BorderedGridLayout, "gridHist", dict(cols=1, spacing=[10, 10], padding=[5, 5, 5, 5]))),
        ("Other", "otherTab", (
            BorderedGridLayout, "gridOther", dict(cols=5, spacing=[10, 10], padding=[20, 10, 5, 5])))
    ]
    lstRegSelOpts = {
        k: "R 0x%02X (%s)" % (k, name) for k, name in [
        (0x00, "Control"), (0x02, "ALARM_MASK"),
        (0x03, "Enable"), (0x04, "Linearize"), (0x5, "LO_PATH"),
        (0x06, "ADC_CONTROL")]}
    mkDefaultTabs = True
    lstDataEntries = [
        (
            NumberUserDataView(
                "numCHIP_REVISION", theDecUIntMaker, (int, str), (0, 15),
                "CHIP_REVISION", "CHIP_REVISION", None
            ).setUpstream(RegisterDownstream([(0, 0, 4)])),
            "gridCfg"
        ),
        (
            NumberUserDataView(
                "numCHIP_ID", theDecUIntMaker, (int, str), (0, 255),
                "CHIP_ID", "CHIP_ID", None
            ).setUpstream(RegisterDownstream([(0, 4, 12)])),
            "gridCfg"
        ),
        (
            ChkBoxUserDataView(
                "bSOFT_RESET",
                "SOFT_RESET"
            ).setUpstream(RegisterDownstream([(0, 15)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bPARITY_EN",
                "PARITY_EN"
            ).setUpstream(RegisterDownstream([(0, 14)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bADDRESS_RANGE_ERROR_MASK",
                "ADDRESS_RANGE_ERROR_MASK"
            ).setUpstream(RegisterDownstream([(2, 12)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bTOO_MANY_ERRORS_MASK",
                "TOO_MANY_ERRORS_MASK"
            ).setUpstream(RegisterDownstream([(2, 13)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bTOO_FEW_ERRORS_MASK",
                "TOO_FEW_ERRORS_MASK"
            ).setUpstream(RegisterDownstream([(2, 14)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bPARITY_ERROR_MASK",
                "PARITY_ERROR_MASK"
            ).setUpstream(RegisterDownstream([(2, 15)])),
            "gridEnMask"
        ),

        (
            ChkBoxUserDataView(
                "bUC_BIAS_ENABLE",
                "UC_BIAS_ENABLE"
            ).setUpstream(RegisterDownstream([(3, 0)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bLO_ENABLE",
                "LO_ENABLE"
            ).setUpstream(RegisterDownstream([(3, 1)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bLO_PPF_ENABLE",
                "LO_PPF_ENABLE"
            ).setUpstream(RegisterDownstream([(3, 2)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bLO_X2_ENABLE",
                "LO_X2_ENABLE"
            ).setUpstream(RegisterDownstream([(3, 3)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bIQ_MODE_ENABLE",
                "IQ_MODE_ENABLE"
            ).setUpstream(RegisterDownstream([(3, 4)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bIF_MODE_ENABLE",
                "IF_MODE_ENABLE"
            ).setUpstream(RegisterDownstream([(3, 5)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bLO_BUFFER_ENABLE",
                "LO_BUFFER_ENABLE"
            ).setUpstream(RegisterDownstream([(3, 6)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bDETECTOR_ENABLE",
                "DETECTOR_ENABLE"
            ).setUpstream(RegisterDownstream([(3, 7)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bVGA_BUFFER_ENABLE",
                "VGA_BUFFER_ENABLE"
            ).setUpstream(RegisterDownstream([(3, 8)])),
            "gridEnMask"
        ),

        (
            NumberUserDataView(
                "numRDAC_LINEARIZE", theDecUIntMaker, (int, str), (0, 255),
                "RDAC_LINEARIZE", "RDAC_LINEARIZE", None
            ).setUpstream(RegisterDownstream([(4, 0, 8)])),
            "gridCfg"
        ),

        (
            NumberUserDataView(
                "numI_PATH_PHASE_ACCURACY", theDecUIntMaker, (int, str), (0, 15),
                "I_PATH_PHASE_ACCURACY", "I_PATH_PHASE_ACCURACY", None
            ).setUpstream(RegisterDownstream([(5, 0, 4)])),
            "gridCfg"
        ),
        (
            NumberUserDataView(
                "numQ_PATH_PHASE_ACCURACY", theDecUIntMaker, (int, str), (0, 15),
                "Q_PATH_PHASE_ACCURACY", "Q_PATH_PHASE_ACCURACY", None
            ).setUpstream(RegisterDownstream([(5, 4, 8)])),
            "gridCfg"
        ),
        (
            ChkBoxUserDataView(
                "bLO_SIDEBAND",
                "LO_SIDEBAND"
            ).setUpstream(RegisterDownstream([(5, 10)])),
            "gridEnMask"
        ),

        (
            ChkBoxUserDataView(
                "bADC_CLOCK_ENABLE",
                "ADC_CLOCK_ENABLE"
            ).setUpstream(RegisterDownstream([(6, 0)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bADC_ENABLE",
                "ADC_ENABLE"
            ).setUpstream(RegisterDownstream([(6, 1)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bADC_START",
                "ADC_START"
            ).setUpstream(RegisterDownstream([(6, 2)])),
            "gridEnMask"
        ),
        (
            ChkBoxUserDataView(
                "bVDET_OUTPUT_SELECT",
                "VDET_OUTPUT_SELECT"
            ).setUpstream(RegisterDownstream([(6, 3)])),
            "gridEnMask"
        ),

        (
            ListUserDataView(
                "selRegSel", lstRegSelOpts, theListMaker, False,
                "Select Register", "Select Register"
            ),
            "gridOther"
        ),
        (
            NumberUserDataView(
                "numWriteData", theHexUIntMaker, (fromHexStr, getFormatFn("%04X")), (0, 65535),
                "Enter Register Hex", "Enter Register Hex", None
            ),
            "gridOther"
        )
    ]
    regAddrsInSequence = [
        0x00, 0x02, 0x03, 0x04, 0x05, 0x06][::-1]
    regDuals = dict.fromkeys(regAddrsInSequence, -1)
    regMaker = RegWithoutAddr
    regCtlSz = regMaker.ctlSz
    regWordSz = regMaker.wordSz
    #cntrRstName = "cntrRst"
    #autoCntrRstName = "bAutoCntrRst"
    addUserLog = "gridHist"
    binLayoutClsName = "GridLayout"
    binLayoutStyle = dict(pos_hint={'y': .02, "right": .99}, size_hint=(.79, .15), cols=6)
    dctCalcSystemUpd = {}
    calcSystems = {}
    defRegsPacker = DataPacker(DataArray(
        DataInt(3)))

    # self.tabNoWrite.add(self.otherTab);self.tabPanel.bind(current_tab=self.curTabEvt)
    # self.gridOther.add_widget(Button(text=" Write Register ",on_release=self.writeReg, size_hint=(None, None), size=(152, 36)))
    # self.txtWriteData.size_hint_x = None
    # self.txtWriteData.width = 100
    # self.gridOther.add_widget(Button(text="Reset To Defaults", size_hint_x=None, width=140, on_release=self.resetToDefs, size_hint_y=None, height=36))
    # self.progBtn.pos_hint={'y':0.045*app.defStyle["size_hint"][1],'x':.01}

    tabNameNoWrite = {"otherTab"}

    def postBuildFirst(self):
        self.dctNamed["gridOther"].add_widget(Button(text="Write Register", on_release=self.writeSingleReg))
    def addAllRegs(self, binLayout):
        """
        :param Layout binLayout:
        """
        for regId in sorted(self.regAddrsInSequence[::-1]):
            binLayout.add_widget(self.getReg(regId).build(BorderedLabel, bdr=0, bdo=0))

    #takes a regId 2-tuple of (index, reg.curReg) and formats it according to
    #  reg.isDual
    @staticmethod
    def fmtReg(regId, short=True):
        """
        :param int|long|(int|long, int|long) regId:
        :param bool short:
        :rtype: str|unicode
        """
        if isinstance(regId, (int, long)):
            return "R 0x%02X" % regId
        elif short:
            return "R 0x%02X ws %u" % (regId[0], regId[1])
        else:
            return "R 0x%02X word select %u" % (regId[0], regId[1])
    '''def writeReg(self, obj=None):
        addr = self.getData("selRegSel")
        num = self.getData("numWriteData")
        tmp = SimpleBitComp(
            [(0, 16), (16, 17), (17,)], 24, num, 0, addr)
        self.userLog.log("Directly writing 0x%06X (R 0x%02X, 0x%04X) to the part" % (tmp, addr, num))
        spiWriteNum(tmp, 24, self.spiBus) #HARD-CODED 24 bits'''
    def getWriteRegSequence(self):
        return self.regAddrsInSequence