from BaseAnySwitch import *

log = None

@initFunc(__name__.replace("ProgramIt.", ""))
def init(progLog):
    # noinspection PyGlobalUndefined
    global log
    log = progLog

class ProgCSWASwitch(BaseSwitch):
    mfgName = "Mini-Circuits"
    mfgPartName = "CSWA****"
    XM_partName = "Unknown"

@partClass("XM-A2L7-0409")
class ProgXM_A2L7(ProgCSWASwitch):
    mfgPartName = "CSWA2-63DR+"
    XM_partName = "XM-A2L7-0409"
    swLbls = ["COM-P1", "COM-P2"]
    nThrow = 2
    nPins = 1
    optMaps = {0: [1], 1: [0]}
    txtTable = ["CTRL"]

@partClass("XM-A2L8-0409")
class ProgXM_A2L8(ProgCSWASwitch):
    mfgPartName = "CSWA2-63DR+"
    XM_partName = "XM-A2L8-0409"
    swLbls = ["COM-P1", "COM-P2"]
    nThrow = 2
    nPins = 1
    optMaps = {0: [1], 1: [0]}
    txtTable = ["CTRL"]

@partClass("XM-A2L9-0409")
class ProgXM_A2L9(ProgCSWASwitch):
    mfgPartName = "CSWA2-63DR+"
    XM_partName = "XM-A2L9-0409"
    swLbls = ["COM-P1", "COM-P2"]
    nThrow = 2
    nPins = 1
    optMaps = {0: [1], 1: [0]}
    txtTable = ["CTRL"]

@partClass("XM-A2M1-0819")
class ProgXM_A2M1(ProgCSWASwitch):
    mfgPartName = "CSWA2-63DR+"
    XM_partName = "XM-A2M1-0819"
    swLbls = ["COM-P1", "COM-P2", "COM-P3", "COM-P4"]
    nThrow = 4
    nPins = 2
    optMaps = {0: [0, 0], 1: [0, 1], 2: [1, 0], 3: [1, 1]}
    txtTable = ["CTRL 1", "CTRL 2"]
