from BaseAnySwitch import *

log = None

@initFunc(__name__.replace("ProgramIt.", ""))
def init(progLog):
    # noinspection PyGlobalUndefined
    global log
    log = progLog

class ProgPE425XX(BaseSwitch):
    mfgPartName = "PE425**"
    mfgName = "Peregrine"
    nPins = 2
class ProgPE4254X(ProgPE425XX):
    mfgPartName = "PE4254*"
    nThrow = 4
    swLbls = ["RF1  On", "RF2  On", "RF3  On", "RF4  On"]
    optMaps = {0:[0, 0], 1:[1, 0], 2:[0, 1], 3:[1, 1]}
class ProgPE4252X(ProgPE425XX):
    mfgPartName = "PE4252*"
    nThrow = 2
    swLbls = ["RF1  On", "RF2  On"]
@partClass("XM-A3B2-0409")
class ProgXM_A3B2(ProgPE4252X):
    XM_partName = "XM-A3B2-0409"
    mfgPartName = "PE42520"
    txtTable = ["LS", "CTRL"]
    swLbls = ["RFC-RF1", "RFC-RF2"]
    optMaps = {0:[1, 0], 1:[1, 1]}
    #boardImageName = images.baseImg+"0298.png"
@partClass("XM-A3N3-0409")
class ProgXM_A3N3(ProgPE425XX):
    mfgPartName = "PE42722"
    XM_partName = "XM-A3N3-0409"
    nThrow = 2
    nPins = 1
    txtTable = ["V1"]
    swLbls = ["RFC-RF1", "RFC-RF2"]
    optMaps = {0:[1], 1:[0]}
@partClass("XM-A3N2-0409")
class ProgXM_A3N2(ProgPE425XX):
    mfgPartName = "PE42820"
    XM_partName = "XM-A3N2-0409"
    nThrow = 2
    nPins = 1
    txtTable = ["CTRL"]
    swLbls = ["RFC-RF1", "RFC-RF2"]
    optMaps = {0:[1], 1:[0]}
@partClass("XM-A3B3-0409")
class ProgXM_A3B3(ProgPE425XX):
    mfgPartName = "PE42522"
    XM_partName = "XM-A3B3-0409"
    nThrow = 2
    nPins = 1
    txtTable = ["V1"]
    swLbls = ["RF1  On", "RF2  On"]
    optMaps = {0:[0], 1:[1]}
@partClass("XM-A3N1-0404")
class ProgXM_A3N1(ProgXM_A3B3):
    XM_partName = "XM-A3N1-0404"
sw4Lbls = ["RF1 Off, RF2 Off", "RF1 Off, RF2 On", "RF1 On, RF2 Off", "RF1 On, RF2 On"]
@partClass("XM-A3N8-0409")
class ProgXM_A3N8(ProgPE4252X):
    XM_partName = "XM-A3N8-0409"
    mfgPartName = "PE42524"
    optMaps = {0: [0, 0], 1:[0, 1], 2:[1, 0], 3: [1, 1]}
    swLbls = sw4Lbls
    nThrow = 4
    #boardImageName = images.baseImg+"0219.png"
@partClass("XM-A3W4-0404")
class ProgXM_A3W4(ProgPE4252X):
    XM_partName = "XM-A3W4-0404"
    mfgPartName = "PE42525"
    DevOnly = True
    optMaps = {0: [0, 0], 1: [0, 1], 2: [1, 0], 3: [1, 1]}
    swLbls = sw4Lbls
    nThrow = 4
# @partClass("XM-A6J9-0409")
# class ProgXM_A6J9(ProgXM_A3W4):
#     XM_partName = "XM-A6J9-0409"
@partClass("XM-A6J9-0409")
class ProgXM_A6J9(ProgPE4252X):
    mfgPartName = "PE42525"
    XM_partName = "XM-A6J9-0409"
    nThrow = 2
    nPins = 1
    txtTable = ["E0"]
    swLbls = ["COM-P1", "COM-P2"]
    optMaps = {0: [1], 1: [0]}
@partClass("XM-A335-0404")
class ProgXM_A335(ProgXM_A3N8):
    XM_partName = "XM-A335-0404"
@partClass("XM-A3N9-0409")
class ProgXM_A3N9(ProgXM_A3N8):
    XM_partName = "XM-A3N9-0409"
@partClass("XM-A4E5-0409")
class ProgXM_A4E5(ProgXM_A3N8):
    XM_partName = "XM-A4E5-0409"
@partClass("XM-A3N7-0819")
class ProgXM_A3N7(ProgPE4254X):
    XM_partName = "XM-A3N7-0819"
    mfgPartName = "PE42543"
    #boardImageName = images.baseImg+"0297.png"
@partClass("XM-A3N6-0819")
class ProgXM_A3N6(ProgPE4254X):
    XM_partName = "XM-A3N6-0819"
    mfgPartName = "PE42542"
    #boardImageName = images.baseImg+"0297.png"
@partClass("XM-A3N5-0409")
class ProgXM_A3N5(ProgPE4252X):
    XM_partName = "XM-A3N5-0409"
    mfgPartName = "PE42521"
    txtTable = ["LS", "CTRL"]
    optMaps = {0:[1, 0], 1:[1, 1]}
    #boardImageName = images.baseImg+"0298.png"